using System;
using System.Collections;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Reflection;
using System.Windows.Forms;

namespace Syslog.Console.Controls
{
	/// <summary>
	/// ConfigConsoleControl ̊Tv̐łB
	/// </summary>
	public class ConfigConsoleControl : System.Windows.Forms.UserControl
	{
        private const string AppConfigFileName = "mlog_ctl.exe.config";

		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;
        private System.Windows.Forms.GroupBox ConfigGroup;
        private System.Windows.Forms.Label ConfigFilePathLabel;
        private System.Windows.Forms.TextBox ConfigFilePath;
        private System.Windows.Forms.Button ConfigFileOpenButton;
        private System.Windows.Forms.OpenFileDialog ConfigFileOpenDialog;
        private AxSHDocVw.AxWebBrowser ConfigBrowser = null;

		public ConfigConsoleControl()
		{
			// ̌ĂяóAWindows.Forms tH[ fUCiŕKvłB
			InitializeComponent();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
        {
            if( disposing )
            {
                if(components != null)
                {
                    components.Dispose();
                }
            }

            base.Dispose( disposing );
		}

		#region R|[lg fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ConfigConsoleControl));
            this.ConfigGroup = new System.Windows.Forms.GroupBox();
            this.ConfigFileOpenButton = new System.Windows.Forms.Button();
            this.ConfigFilePath = new System.Windows.Forms.TextBox();
            this.ConfigFilePathLabel = new System.Windows.Forms.Label();
            this.ConfigBrowser = new AxSHDocVw.AxWebBrowser();
            this.ConfigFileOpenDialog = new System.Windows.Forms.OpenFileDialog();
            this.ConfigGroup.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.ConfigBrowser)).BeginInit();
            this.SuspendLayout();
            // 
            // ConfigGroup
            // 
            this.ConfigGroup.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.ConfigGroup.Controls.Add(this.ConfigFileOpenButton);
            this.ConfigGroup.Controls.Add(this.ConfigFilePath);
            this.ConfigGroup.Controls.Add(this.ConfigFilePathLabel);
            this.ConfigGroup.Controls.Add(this.ConfigBrowser);
            this.ConfigGroup.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.ConfigGroup.Location = new System.Drawing.Point(8, 8);
            this.ConfigGroup.Name = "ConfigGroup";
            this.ConfigGroup.Size = new System.Drawing.Size(584, 336);
            this.ConfigGroup.TabIndex = 0;
            this.ConfigGroup.TabStop = false;
            this.ConfigGroup.Text = "app.config";
            // 
            // ConfigFileOpenButton
            // 
            this.ConfigFileOpenButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.ConfigFileOpenButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.ConfigFileOpenButton.Location = new System.Drawing.Point(504, 24);
            this.ConfigFileOpenButton.Name = "ConfigFileOpenButton";
            this.ConfigFileOpenButton.Size = new System.Drawing.Size(75, 24);
            this.ConfigFileOpenButton.TabIndex = 2;
            this.ConfigFileOpenButton.Text = "Q(&R)";
            this.ConfigFileOpenButton.Click += new System.EventHandler(this.ConfigFileOpenButton_Click);
            // 
            // ConfigFilePath
            // 
            this.ConfigFilePath.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.ConfigFilePath.Location = new System.Drawing.Point(128, 24);
            this.ConfigFilePath.Name = "ConfigFilePath";
            this.ConfigFilePath.ReadOnly = true;
            this.ConfigFilePath.Size = new System.Drawing.Size(368, 22);
            this.ConfigFilePath.TabIndex = 1;
            this.ConfigFilePath.Text = "";
            this.ConfigFilePath.TextChanged += new System.EventHandler(this.ConfigFilePath_TextChanged);
            // 
            // ConfigFilePathLabel
            // 
            this.ConfigFilePathLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.ConfigFilePathLabel.Location = new System.Drawing.Point(8, 24);
            this.ConfigFilePathLabel.Name = "ConfigFilePathLabel";
            this.ConfigFilePathLabel.Size = new System.Drawing.Size(112, 23);
            this.ConfigFilePathLabel.TabIndex = 0;
            this.ConfigFilePathLabel.Text = "ݒt@CpX(&P):";
            this.ConfigFilePathLabel.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
            // 
            // ConfigBrowser
            // 
            this.ConfigBrowser.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.ConfigBrowser.ContainingControl = this;
            this.ConfigBrowser.Enabled = true;
            this.ConfigBrowser.Location = new System.Drawing.Point(8, 51);
            this.ConfigBrowser.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("ConfigBrowser.OcxState")));
            this.ConfigBrowser.Size = new System.Drawing.Size(568, 277);
            this.ConfigBrowser.TabIndex = 3;
            this.ConfigBrowser.TabStop = false;
            // 
            // ConfigFileOpenDialog
            // 
            this.ConfigFileOpenDialog.DefaultExt = "config";
            this.ConfigFileOpenDialog.Filter = ".config t@C (*.config)|*.config|ׂẴt@C|*.*";
            // 
            // ConfigConsoleControl
            // 
            this.Controls.Add(this.ConfigGroup);
            this.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.Name = "ConfigConsoleControl";
            this.Size = new System.Drawing.Size(600, 350);
            this.Load += new System.EventHandler(this.ConfigConsoleControl_Load);
            this.ConfigGroup.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.ConfigBrowser)).EndInit();
            this.ResumeLayout(false);

        }
		#endregion

        private void ConfigConsoleControl_Load(object sender, System.EventArgs e)
        {
            string ConfigPath = Path.Combine(Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location), AppConfigFileName);

            ConfigFilePath.Text = Path.GetFullPath(ConfigPath);
        }

        private void ConfigFilePath_TextChanged(object sender, System.EventArgs e)
        {
            object RefNull = null;

            ConfigBrowser.Navigate(ConfigFilePath.Text, ref RefNull, ref RefNull, ref RefNull, ref RefNull);

            ConfigFilePath.SelectionStart = ConfigFilePath.Text.Length;
        }

        private void ConfigFileOpenButton_Click(object sender, System.EventArgs e)
        {
            if (DialogResult.OK == ConfigFileOpenDialog.ShowDialog())
            {
                ConfigFilePath.Text = ConfigFileOpenDialog.FileName;
            }
        }
	}
}
