using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Net;
using System.Windows.Forms;
using System.Xml;

namespace Syslog.Console.Controls.ConfigCreator
{
	public class DbWriterInputControl : Syslog.Console.Controls.ConfigCreator.ConfigInputControl
	{
        private System.Windows.Forms.Label ConnectionStringLabel;
        private System.Windows.Forms.TextBox ConnectionStringTextBox;
        private System.Windows.Forms.Label TableNameLabel;
        private System.Windows.Forms.TextBox TableNameTextBox;
        private System.Windows.Forms.TextBox CollectorIDTextBox;
        private System.Windows.Forms.Label CollectorIDLabel;
		private System.ComponentModel.IContainer components = null;

		public DbWriterInputControl()
		{
			// ̌Ăяo Windows tH[ fUCiŕKvłB
            InitializeComponent();

            CollectorIDTextBox.Text = Dns.GetHostName();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region fUCiŐꂽR[h
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            this.ConnectionStringLabel = new System.Windows.Forms.Label();
            this.ConnectionStringTextBox = new System.Windows.Forms.TextBox();
            this.TableNameLabel = new System.Windows.Forms.Label();
            this.TableNameTextBox = new System.Windows.Forms.TextBox();
            this.CollectorIDTextBox = new System.Windows.Forms.TextBox();
            this.CollectorIDLabel = new System.Windows.Forms.Label();
            this.InputGroup.SuspendLayout();
            // 
            // InputGroup
            // 
            this.InputGroup.Controls.Add(this.ConnectionStringTextBox);
            this.InputGroup.Controls.Add(this.ConnectionStringLabel);
            this.InputGroup.Controls.Add(this.TableNameLabel);
            this.InputGroup.Controls.Add(this.TableNameTextBox);
            this.InputGroup.Controls.Add(this.CollectorIDTextBox);
            this.InputGroup.Controls.Add(this.CollectorIDLabel);
            this.InputGroup.Name = "InputGroup";
            this.InputGroup.Text = "Simple Database Writer";
            // 
            // ConnectionStringLabel
            // 
            this.ConnectionStringLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.ConnectionStringLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.ConnectionStringLabel.Location = new System.Drawing.Point(32, 32);
            this.ConnectionStringLabel.Name = "ConnectionStringLabel";
            this.ConnectionStringLabel.Size = new System.Drawing.Size(280, 23);
            this.ConnectionStringLabel.TabIndex = 0;
            this.ConnectionStringLabel.Text = "ڑ(&C):";
            // 
            // ConnectionStringTextBox
            // 
            this.ConnectionStringTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.ConnectionStringTextBox.Location = new System.Drawing.Point(32, 56);
            this.ConnectionStringTextBox.Name = "ConnectionStringTextBox";
            this.ConnectionStringTextBox.Size = new System.Drawing.Size(304, 22);
            this.ConnectionStringTextBox.TabIndex = 1;
            this.ConnectionStringTextBox.Text = "Provider=SQLOLEDB;Integrated Security=SSPI;";
            // 
            // TableNameLabel
            // 
            this.TableNameLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.TableNameLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.TableNameLabel.Location = new System.Drawing.Point(32, 88);
            this.TableNameLabel.Name = "TableNameLabel";
            this.TableNameLabel.Size = new System.Drawing.Size(280, 23);
            this.TableNameLabel.TabIndex = 2;
            this.TableNameLabel.Text = "ۑe[u(&T):";
            // 
            // TableNameTextBox
            // 
            this.TableNameTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.TableNameTextBox.Location = new System.Drawing.Point(32, 112);
            this.TableNameTextBox.Name = "TableNameTextBox";
            this.TableNameTextBox.Size = new System.Drawing.Size(304, 22);
            this.TableNameTextBox.TabIndex = 3;
            this.TableNameTextBox.Text = "";
            // 
            // CollectorIDTextBox
            // 
            this.CollectorIDTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.CollectorIDTextBox.Location = new System.Drawing.Point(32, 168);
            this.CollectorIDTextBox.Name = "CollectorIDTextBox";
            this.CollectorIDTextBox.Size = new System.Drawing.Size(304, 22);
            this.CollectorIDTextBox.TabIndex = 5;
            this.CollectorIDTextBox.Text = "";
            // 
            // CollectorIDLabel
            // 
            this.CollectorIDLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.CollectorIDLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.CollectorIDLabel.Location = new System.Drawing.Point(32, 144);
            this.CollectorIDLabel.Name = "CollectorIDLabel";
            this.CollectorIDLabel.Size = new System.Drawing.Size(280, 23);
            this.CollectorIDLabel.TabIndex = 4;
            this.CollectorIDLabel.Text = "Syslog Collector ID(&I):";
            // 
            // DbWriterInputControl
            // 
            this.Name = "DbWriterInputControl";
            this.InputGroup.ResumeLayout(false);

        }
        #endregion

        public override string ToString(string innerString)
        {
            const string AssemblyID = "db-writer";
            const string AssemblyType = "Syslog.Collector.Writer.SimpleDbWriter";
            const string AssemblyName = "mlog_coll";

            const string ConfigEntry = "db";
            const string ConnectionString = "connectionString";
            const string TargetTableName = "table";
            const string CollectorID = "collectorId";

            XmlDocument doc = new XmlDocument();
            XmlElement element = doc.CreateElement(ConfigEntry);

            XmlAttribute ConnectionStringAttribute = doc.CreateAttribute(ConnectionString);
            ConnectionStringAttribute.Value = ConnectionStringTextBox.Text;

            XmlAttribute TableNameAttribute = doc.CreateAttribute(TargetTableName);
            TableNameAttribute.Value = TableNameTextBox.Text;

            XmlAttribute CollectorIDAttribute = doc.CreateAttribute(CollectorID);
            CollectorIDAttribute.Value = CollectorIDTextBox.Text;

            element.Attributes.Append(ConnectionStringAttribute);
            element.Attributes.Append(TableNameAttribute);
            element.Attributes.Append(CollectorIDAttribute);

            AssemblyElementCreator AssemblyCreator = new AssemblyElementCreator(AssemblyID, AssemblyType, AssemblyName);
            XmlNode AssemblyNode = doc.ImportNode(AssemblyCreator.ToNode(element), true);

            doc.AppendChild(AssemblyNode);

            return doc.OuterXml;
        }
	}
}

