using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.Xml;

namespace Syslog.Console.Controls.ConfigCreator
{
	public class EventLogWriterInputControl : Syslog.Console.Controls.ConfigCreator.ConfigInputControl
	{
        private System.Windows.Forms.Label MessageFormatLabel;
        private System.Windows.Forms.ComboBox MessageFormatCombo;
		private System.ComponentModel.IContainer components = null;

		public EventLogWriterInputControl()
		{
			// ̌Ăяo Windows tH[ fUCiŕKvłB
            InitializeComponent();

            // qRg[Iɍ쐬
            this.CreateControl();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region fUCiŐꂽR[h
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            this.MessageFormatLabel = new System.Windows.Forms.Label();
            this.MessageFormatCombo = new System.Windows.Forms.ComboBox();
            this.InputGroup.SuspendLayout();
            // 
            // InputGroup
            // 
            this.InputGroup.Controls.Add(this.MessageFormatCombo);
            this.InputGroup.Controls.Add(this.MessageFormatLabel);
            this.InputGroup.Name = "InputGroup";
            this.InputGroup.Text = "Simple EventLog Writer";
            // 
            // MessageFormatLabel
            // 
            this.MessageFormatLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.MessageFormatLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.MessageFormatLabel.Location = new System.Drawing.Point(32, 32);
            this.MessageFormatLabel.Name = "MessageFormatLabel";
            this.MessageFormatLabel.Size = new System.Drawing.Size(304, 23);
            this.MessageFormatLabel.TabIndex = 0;
            this.MessageFormatLabel.Text = "bZ[W tH[}bg(&F):";
            // 
            // MessageFormatCombo
            // 
            this.MessageFormatCombo.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.MessageFormatCombo.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.MessageFormatCombo.Items.AddRange(new object[] {
                                                                    "Text",
                                                                    "XML"});
            this.MessageFormatCombo.Location = new System.Drawing.Point(32, 56);
            this.MessageFormatCombo.Name = "MessageFormatCombo";
            this.MessageFormatCombo.Size = new System.Drawing.Size(296, 22);
            this.MessageFormatCombo.TabIndex = 1;
            // 
            // EventLogWriterInputControl
            // 
            this.Name = "EventLogWriterInputControl";
            this.Load += new System.EventHandler(this.EventLogWriterInputControl_Load);
            this.InputGroup.ResumeLayout(false);

        }
		#endregion

        private void EventLogWriterInputControl_Load(object sender, System.EventArgs e)
        {
            MessageFormatCombo.SelectedIndex = 0;
        }

        public override string ToString(string innerString)
        {
            const string AssemblyID = "eventlog-writer";
            const string AssemblyType = "Syslog.Collector.Writer.SimpleEventLogWriter";
            const string AssemblyName = "mlog_coll";

            const string ConfigEntry = "eventlog";
            const string EventLogMachine = "machine";
            const string EventLogMachineValue = ".";
            const string OutputFormat = "format";

            XmlDocument doc = new XmlDocument();
            XmlElement element = doc.CreateElement(ConfigEntry);

            XmlAttribute EventLogMachineAttribute = doc.CreateAttribute(EventLogMachine);
            EventLogMachineAttribute.Value = EventLogMachineValue;

            XmlAttribute FormatAttribute = doc.CreateAttribute(OutputFormat);
            FormatAttribute.Value = MessageFormatCombo.SelectedItem.ToString();

            element.Attributes.Append(EventLogMachineAttribute);
            element.Attributes.Append(FormatAttribute);

            AssemblyElementCreator AssemblyCreator = new AssemblyElementCreator(AssemblyID, AssemblyType, AssemblyName);
            XmlNode AssemblyNode = doc.ImportNode(AssemblyCreator.ToNode(element), true);

            doc.AppendChild(AssemblyNode);

            return doc.OuterXml;
        }
	}
}

