using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace Syslog.Console.Controls.ConfigCreator
{
	public class GlobalSettingsInputControl : Syslog.Console.Controls.ConfigCreator.ConfigInputControl
    {
        private System.Windows.Forms.Label GlobalSettingDescription;
        private Syslog.Console.Controls.EncodingSelectorComboBox EncodingCombo;
        private System.Windows.Forms.Label EncodingLabel;
        private System.Windows.Forms.ComboBox ErrorPacketCombo;
        private System.Windows.Forms.Label ErrorPacketLabel;
		private System.ComponentModel.IContainer components = null;

		public GlobalSettingsInputControl()
		{
			// ̌Ăяo Windows tH[ fUCiŕKvłB
			InitializeComponent();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region fUCiŐꂽR[h
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            this.GlobalSettingDescription = new System.Windows.Forms.Label();
            this.EncodingCombo = new EncodingSelectorComboBox();
            this.EncodingLabel = new System.Windows.Forms.Label();
            this.ErrorPacketCombo = new System.Windows.Forms.ComboBox();
            this.ErrorPacketLabel = new System.Windows.Forms.Label();
            this.InputGroup.SuspendLayout();
            // 
            // InputGroup
            // 
            this.InputGroup.Controls.Add(this.EncodingCombo);
            this.InputGroup.Controls.Add(this.EncodingLabel);
            this.InputGroup.Controls.Add(this.ErrorPacketCombo);
            this.InputGroup.Controls.Add(this.ErrorPacketLabel);
            this.InputGroup.Controls.Add(this.GlobalSettingDescription);
            this.InputGroup.Name = "InputGroup";
            this.InputGroup.Size = new System.Drawing.Size(350, 256);
            this.InputGroup.Text = "Global Settings";
            // 
            // GlobalSettingDescription
            // 
            this.GlobalSettingDescription.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.GlobalSettingDescription.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.GlobalSettingDescription.Location = new System.Drawing.Point(24, 40);
            this.GlobalSettingDescription.Name = "GlobalSettingDescription";
            this.GlobalSettingDescription.Size = new System.Drawing.Size(288, 64);
            this.GlobalSettingDescription.TabIndex = 0;
            this.GlobalSettingDescription.Text = "Managed Syslog Server Ŝ̐ݒs܂B";
            // 
            // EncodingCombo
            // 
            this.EncodingCombo.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.EncodingCombo.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.EncodingCombo.Location = new System.Drawing.Point(40, 112);
            this.EncodingCombo.Name = "EncodingCombo";
            this.EncodingCombo.Size = new System.Drawing.Size(296, 22);
            this.EncodingCombo.TabIndex = 4;
            // 
            // EncodingLabel
            // 
            this.EncodingLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.EncodingLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.EncodingLabel.Location = new System.Drawing.Point(24, 88);
            this.EncodingLabel.Name = "EncodingLabel";
            this.EncodingLabel.Size = new System.Drawing.Size(184, 22);
            this.EncodingLabel.TabIndex = 3;
            this.EncodingLabel.Text = "GR[hݒ(&E):";
            // 
            // ErrorPacketCombo
            // 
            this.ErrorPacketCombo.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.ErrorPacketCombo.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.ErrorPacketCombo.Items.AddRange(new object[] {
                                                                  "Ignore",
                                                                  "Drop",
                                                                  "Reject"});
            this.ErrorPacketCombo.Location = new System.Drawing.Point(40, 176);
            this.ErrorPacketCombo.Name = "ErrorPacketCombo";
            this.ErrorPacketCombo.Size = new System.Drawing.Size(296, 22);
            this.ErrorPacketCombo.TabIndex = 5;
            // 
            // ErrorPacketLabel
            // 
            this.ErrorPacketLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.ErrorPacketLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.ErrorPacketLabel.Location = new System.Drawing.Point(24, 152);
            this.ErrorPacketLabel.Name = "ErrorPacketLabel";
            this.ErrorPacketLabel.Size = new System.Drawing.Size(184, 22);
            this.ErrorPacketLabel.TabIndex = 2;
            this.ErrorPacketLabel.Text = "G[pPbg(&P):";
            // 
            // GlobalSettingsInputControl
            // 
            this.Name = "GlobalSettingsInputControl";
            this.Size = new System.Drawing.Size(350, 256);
            this.Load += new System.EventHandler(this.GlobalSettingsInputControl_Load);
            this.InputGroup.ResumeLayout(false);

        }
		#endregion

        private void GlobalSettingsInputControl_Load(object sender, System.EventArgs e)
        {
            EncodingCombo.SetDefaultSelection();

            ErrorPacketCombo.SelectedIndex = 0;
        }

        public override string ToString(string innerString)
        {
            const string ConfigElement = "settings";
            const string ConfigInnterSettings = "configuration";
            const string ConfigEncodingElement = "defaultEncoding";
            const string ConfigEncodingNameAttribute = "name";
            const string ConfigErrorPacketElement = "errorPacket";
            const string ConfigErrorPacketRuleAttribute = "rule";

            XmlDocument doc = new XmlDocument();
            XmlElement element = doc.CreateElement(ConfigElement);

            XmlElement InnerSettingsElement = doc.CreateElement(ConfigInnterSettings);
            InnerSettingsElement.InnerXml = innerString;

            XmlElement encoding = doc.CreateElement(ConfigEncodingElement);
            encoding.SetAttribute(ConfigEncodingNameAttribute, EncodingCombo.SelectedValue.ToString());

            XmlElement packet = doc.CreateElement(ConfigErrorPacketElement);
            packet.SetAttribute(ConfigErrorPacketRuleAttribute, ErrorPacketCombo.SelectedItem.ToString());

            element.AppendChild(InnerSettingsElement);
            element.AppendChild(encoding);
            element.AppendChild(packet);
            doc.AppendChild(element);

            return doc.OuterXml;
        }
	}
}

