using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Net;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace Syslog.Console.Controls.ConfigCreator
{
	public class EncodingSelectorInputControl : Syslog.Console.Controls.ConfigCreator.ConfigInputControl
    {
        private System.Windows.Forms.Label EncodingSelectorDescriptionLabel;
        private System.Windows.Forms.Label IPAddressLabel;
        private System.Windows.Forms.Label EncodingLabel;
        private System.Windows.Forms.Button AddButton;
        private System.Windows.Forms.Button DeleteButton;
        private System.Windows.Forms.ColumnHeader IPAddressColumn;
        private System.Windows.Forms.ColumnHeader EncodingColumn;
        private System.Windows.Forms.ListView EncodingListView;
        private Syslog.Console.Controls.IPAddressBox IPAddressTextBox;
        private Syslog.Console.Controls.EncodingSelectorComboBox EncodingCombo;
		private System.ComponentModel.IContainer components = null;

		public EncodingSelectorInputControl()
		{
			// ̌Ăяo Windows tH[ fUCiŕKvłB
            InitializeComponent();

            // qRg[Iɍ쐬
            this.CreateControl();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region fUCiŐꂽR[h
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(EncodingSelectorInputControl));
            this.EncodingSelectorDescriptionLabel = new System.Windows.Forms.Label();
            this.IPAddressLabel = new System.Windows.Forms.Label();
            this.EncodingLabel = new System.Windows.Forms.Label();
            this.EncodingListView = new System.Windows.Forms.ListView();
            this.IPAddressColumn = new System.Windows.Forms.ColumnHeader();
            this.EncodingColumn = new System.Windows.Forms.ColumnHeader();
            this.AddButton = new System.Windows.Forms.Button();
            this.DeleteButton = new System.Windows.Forms.Button();
            this.IPAddressTextBox = new Syslog.Console.Controls.IPAddressBox();
            this.EncodingCombo = new Syslog.Console.Controls.EncodingSelectorComboBox();
            this.InputGroup.SuspendLayout();
            // 
            // InputGroup
            // 
            this.InputGroup.Controls.Add(this.EncodingCombo);
            this.InputGroup.Controls.Add(this.IPAddressTextBox);
            this.InputGroup.Controls.Add(this.DeleteButton);
            this.InputGroup.Controls.Add(this.AddButton);
            this.InputGroup.Controls.Add(this.EncodingListView);
            this.InputGroup.Controls.Add(this.EncodingLabel);
            this.InputGroup.Controls.Add(this.IPAddressLabel);
            this.InputGroup.Controls.Add(this.EncodingSelectorDescriptionLabel);
            this.InputGroup.Name = "InputGroup";
            this.InputGroup.Text = "Encoding Selector";
            // 
            // EncodingSelectorDescriptionLabel
            // 
            this.EncodingSelectorDescriptionLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.EncodingSelectorDescriptionLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.EncodingSelectorDescriptionLabel.Location = new System.Drawing.Point(24, 32);
            this.EncodingSelectorDescriptionLabel.Name = "EncodingSelectorDescriptionLabel";
            this.EncodingSelectorDescriptionLabel.Size = new System.Drawing.Size(304, 23);
            this.EncodingSelectorDescriptionLabel.TabIndex = 0;
            this.EncodingSelectorDescriptionLabel.Text = "\[XAhXɊÂėp镶R[hύX܂B";
            // 
            // IPAddressLabel
            // 
            this.IPAddressLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.IPAddressLabel.Location = new System.Drawing.Point(24, 56);
            this.IPAddressLabel.Name = "IPAddressLabel";
            this.IPAddressLabel.Size = new System.Drawing.Size(88, 23);
            this.IPAddressLabel.TabIndex = 1;
            this.IPAddressLabel.Text = "IPAhX(&A):";
            // 
            // EncodingLabel
            // 
            this.EncodingLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.EncodingLabel.Location = new System.Drawing.Point(24, 88);
            this.EncodingLabel.Name = "EncodingLabel";
            this.EncodingLabel.Size = new System.Drawing.Size(88, 23);
            this.EncodingLabel.TabIndex = 3;
            this.EncodingLabel.Text = "R[h(&E):";
            // 
            // EncodingListView
            // 
            this.EncodingListView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.EncodingListView.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                               this.IPAddressColumn,
                                                                                               this.EncodingColumn});
            this.EncodingListView.FullRowSelect = true;
            this.EncodingListView.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
            this.EncodingListView.HideSelection = false;
            this.EncodingListView.Location = new System.Drawing.Point(16, 160);
            this.EncodingListView.Name = "EncodingListView";
            this.EncodingListView.Size = new System.Drawing.Size(320, 88);
            this.EncodingListView.TabIndex = 7;
            this.EncodingListView.View = System.Windows.Forms.View.Details;
            this.EncodingListView.SelectedIndexChanged += new System.EventHandler(this.EncodingListView_SelectedIndexChanged);
            // 
            // IPAddressColumn
            // 
            this.IPAddressColumn.Text = "IPAhX";
            this.IPAddressColumn.Width = 180;
            // 
            // EncodingColumn
            // 
            this.EncodingColumn.Text = "R[h";
            this.EncodingColumn.Width = 120;
            // 
            // AddButton
            // 
            this.AddButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.AddButton.Enabled = false;
            this.AddButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.AddButton.Location = new System.Drawing.Point(168, 120);
            this.AddButton.Name = "AddButton";
            this.AddButton.Size = new System.Drawing.Size(75, 32);
            this.AddButton.TabIndex = 5;
            this.AddButton.Text = "ǉ(&A)";
            this.AddButton.Click += new System.EventHandler(this.AddButton_Click);
            // 
            // DeleteButton
            // 
            this.DeleteButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.DeleteButton.Enabled = false;
            this.DeleteButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.DeleteButton.Location = new System.Drawing.Point(256, 120);
            this.DeleteButton.Name = "DeleteButton";
            this.DeleteButton.Size = new System.Drawing.Size(75, 32);
            this.DeleteButton.TabIndex = 6;
            this.DeleteButton.Text = "폜(&D)";
            this.DeleteButton.Click += new System.EventHandler(this.DeleteButton_Click);
            // 
            // IPAddressTextBox
            // 
            this.IPAddressTextBox.Address = ((System.Net.IPAddress)(resources.GetObject("IPAddressTextBox.Address")));
            this.IPAddressTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.IPAddressTextBox.Error = "";
            this.IPAddressTextBox.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.IPAddressTextBox.IconAlignment = System.Windows.Forms.ErrorIconAlignment.MiddleLeft;
            this.IPAddressTextBox.IconPadding = 0;
            this.IPAddressTextBox.Location = new System.Drawing.Point(112, 56);
            this.IPAddressTextBox.Name = "IPAddressTextBox";
            this.IPAddressTextBox.Size = new System.Drawing.Size(224, 22);
            this.IPAddressTextBox.TabIndex = 2;
            this.IPAddressTextBox.Text = "";
            this.IPAddressTextBox.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.IPAddressTextBox_KeyPress);
            this.IPAddressTextBox.TextChanged += new System.EventHandler(this.IPAddressTextBox_TextChanged);
            // 
            // EncodingCombo
            // 
            this.EncodingCombo.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.EncodingCombo.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.EncodingCombo.Location = new System.Drawing.Point(112, 88);
            this.EncodingCombo.Name = "EncodingCombo";
            this.EncodingCombo.Size = new System.Drawing.Size(224, 22);
            this.EncodingCombo.TabIndex = 4;
            // 
            // EncodingSelectorInputControl
            // 
            this.Name = "EncodingSelectorInputControl";
            this.Load += new System.EventHandler(this.EncodingSelectorInputControl_Load);
            this.InputGroup.ResumeLayout(false);

        }
		#endregion

        public override string ToString(string innerString)
        {
            const string AssemblyID = "encoding-selector-filter";
            const string AssemblyType = "Syslog.Listener.Filter.EncodingSelector";
            const string AssemblyName = "mlog_listen";
            const string AddressEntry = "select";
            const string IPAddressEntry = "source";
            const string EncodingEntry = "encoding";

            XmlDocument doc = new XmlDocument();
            XmlDocumentFragment frag = doc.CreateDocumentFragment();

            foreach (ListViewItem item in EncodingListView.Items)
            {
                XmlAttribute IPAddressAttribute = doc.CreateAttribute(IPAddressEntry);
                IPAddressAttribute.Value = item.SubItems[0].Text;

                XmlAttribute EncodingAttribute = doc.CreateAttribute(EncodingEntry);
                EncodingAttribute.Value = item.SubItems[1].Text;

                XmlElement AddressElement = doc.CreateElement(AddressEntry);
                AddressElement.Attributes.Append(IPAddressAttribute);
                AddressElement.Attributes.Append(EncodingAttribute);

                frag.AppendChild(AddressElement);
            }

            AssemblyElementCreator AssemblyCreator = new AssemblyElementCreator(AssemblyID, AssemblyType, AssemblyName);
            XmlNode AssemblyNode = doc.ImportNode(AssemblyCreator.ToNode((XmlNode) frag), true);

            doc.AppendChild(AssemblyNode);

            return doc.OuterXml;
        }

        private void EncodingSelectorInputControl_Load(object sender, System.EventArgs e)
        {
            EncodingCombo.SetDefaultSelection();
        }

        private void IPAddressTextBox_TextChanged(object sender, System.EventArgs e)
        {
            if (IPAddressTextBox.TextLength > 0)
            {
                AddButton.Enabled = true;
            }
            else
            {
                AddButton.Enabled = false;
            }
        }

        private void IPAddressTextBox_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
        {
            this.PressEnterKey(e);
        }

        private void EncodingCombo_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
        {
            this.PressEnterKey(e);
        }

        private void AddButton_Click(object sender, System.EventArgs e)
        {
            try
            {
                this.AddEncoding(IPAddressTextBox.Text, EncodingCombo.SelectedValue.ToString());

                IPAddressTextBox.Clear();
            }
            catch
            {
            }
            
            IPAddressTextBox.Focus();
        }

        private void DeleteButton_Click(object sender, System.EventArgs e)
        {
            foreach (ListViewItem item in EncodingListView.SelectedItems)
            {
                item.Remove();
            }

            if (EncodingListView.FocusedItem != null)
            {
                EncodingListView.FocusedItem.Selected = true;
                EncodingListView.FocusedItem.EnsureVisible();
            }
        }

        private void EncodingListView_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            if (EncodingListView.SelectedItems.Count > 0)
            {
                DeleteButton.Enabled = true;

                IPAddressTextBox.Text = EncodingListView.SelectedItems[0].SubItems[0].Text;
                EncodingCombo.SelectedIndex = EncodingCombo.FindString(Encoding.GetEncoding(EncodingListView.SelectedItems[0].SubItems[1].Text).EncodingName);
            }
            else
            {
                DeleteButton.Enabled = false;
            }
        }

        private ListViewItem AddEncoding(string address, string encoding)
        {
            return this.AddEncoding(IPAddress.Parse(address), Encoding.GetEncoding(encoding));
        }

        private ListViewItem AddEncoding(IPAddress address, Encoding encoding)
        {
            EncodingListView.SelectedItems.Clear();

            foreach (ListViewItem item in EncodingListView.Items)
            {
                if (item.Text == address.ToString())
                {
                    if (item.SubItems[1].Text != encoding.WebName)
                    {
                        item.SubItems[1].Text = encoding.WebName;
                    }

                    item.Selected = true;
                    item.Focused = true;
                    item.EnsureVisible();

                    return item;
                }
            }

            ListViewItem EncodingEntry = new ListViewItem(address.ToString());
            EncodingEntry.SubItems.Add(encoding.WebName);

            EncodingEntry.Focused = true;

            ListViewItem InsertedEntry = EncodingListView.Items.Add(EncodingEntry);
            InsertedEntry.EnsureVisible();

            return InsertedEntry;
        }

        private void PressEnterKey(KeyPressEventArgs e)
        {
            if ((int) e.KeyChar == (int) Keys.Enter)
            {
                this.AddButton.PerformClick();

                e.Handled = true;
            }
        }
	}
}

