using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.Xml;

namespace Syslog.Console.Controls.ConfigCreator
{
	public class PriorityFilterInputControl : Syslog.Console.Controls.ConfigCreator.ConfigInputControl
	{
        private System.Windows.Forms.Label SeverityLabel;
        private System.Windows.Forms.ComboBox SeverityCombo;
        private System.Windows.Forms.Label PriorityFilterLabel;
		private System.ComponentModel.IContainer components = null;

		public PriorityFilterInputControl()
		{
			// ̌Ăяo Windows tH[ fUCiŕKvłB
            InitializeComponent();

            // qRg[Iɍ쐬
            this.CreateControl();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region fUCiŐꂽR[h
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            this.PriorityFilterLabel = new System.Windows.Forms.Label();
            this.SeverityLabel = new System.Windows.Forms.Label();
            this.SeverityCombo = new System.Windows.Forms.ComboBox();
            this.InputGroup.SuspendLayout();
            // 
            // InputGroup
            // 
            this.InputGroup.Controls.Add(this.SeverityCombo);
            this.InputGroup.Controls.Add(this.PriorityFilterLabel);
            this.InputGroup.Controls.Add(this.SeverityLabel);
            this.InputGroup.Name = "InputGroup";
            this.InputGroup.Text = "Priority Filter";
            // 
            // PriorityFilterLabel
            // 
            this.PriorityFilterLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.PriorityFilterLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.PriorityFilterLabel.Location = new System.Drawing.Point(24, 32);
            this.PriorityFilterLabel.Name = "PriorityFilterLabel";
            this.PriorityFilterLabel.Size = new System.Drawing.Size(312, 23);
            this.PriorityFilterLabel.TabIndex = 0;
            this.PriorityFilterLabel.Text = "̗DxɖȂ Syslog bZ[WtB^O܂B";
            // 
            // SeverityLabel
            // 
            this.SeverityLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.SeverityLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.SeverityLabel.Location = new System.Drawing.Point(24, 64);
            this.SeverityLabel.Name = "SeverityLabel";
            this.SeverityLabel.Size = new System.Drawing.Size(160, 23);
            this.SeverityLabel.TabIndex = 1;
            this.SeverityLabel.Text = "dx(&F):";
            // 
            // SeverityCombo
            // 
            this.SeverityCombo.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.SeverityCombo.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.SeverityCombo.Items.AddRange(new object[] {
                                                               "Emergency",
                                                               "Alert",
                                                               "Critical",
                                                               "Error",
                                                               "Warning",
                                                               "Notice",
                                                               "Informational",
                                                               "Debug"});
            this.SeverityCombo.Location = new System.Drawing.Point(48, 88);
            this.SeverityCombo.Name = "SeverityCombo";
            this.SeverityCombo.Size = new System.Drawing.Size(288, 22);
            this.SeverityCombo.TabIndex = 2;
            // 
            // PriorityFilterInputControl
            // 
            this.Name = "PriorityFilterInputControl";
            this.Load += new System.EventHandler(this.PriorityFilterInputControl_Load);
            this.InputGroup.ResumeLayout(false);

        }
		#endregion

        private void PriorityFilterInputControl_Load(object sender, System.EventArgs e)
        {
            SeverityCombo.SelectedIndex = SeverityCombo.Items.Count - 1 - 1;
        }

        public override string ToString(string innerString)
        {
            const string AssemblyID = "priority-filter";
            const string AssemblyType = "Syslog.Relay.Filter.PriorityFilter";
            const string AssemblyName = "mlog_relay";

            const string PriorityEntry = "allow";
            const string SeverityLevel = "severity";

            XmlDocument doc = new XmlDocument();
            XmlElement element = doc.CreateElement(PriorityEntry);

            XmlAttribute SeverityAttribute = doc.CreateAttribute(SeverityLevel);
            SeverityAttribute.Value = SeverityCombo.SelectedItem.ToString();

            element.Attributes.Append(SeverityAttribute);

            AssemblyElementCreator AssemblyCreator = new AssemblyElementCreator(AssemblyID, AssemblyType, AssemblyName);
            XmlNode AssemblyNode = doc.ImportNode(AssemblyCreator.ToNode(element), true);

            doc.AppendChild(AssemblyNode);

            return doc.OuterXml;
        }
	}
}

