using System;
using System.ComponentModel;
using System.Text;
using System.Windows.Forms;

namespace Syslog.Console.Controls
{
	/// <summary>
	/// EncodingSelectorComboBox ̊Tv̐łB
	/// </summary>
	public class EncodingSelectorComboBox : System.Windows.Forms.ComboBox
    {
        private readonly Encoding[] EncodingList =
            new Encoding[] {
                               Encoding.ASCII,
                               Encoding.GetEncoding("latin1"),
                               Encoding.GetEncoding("Windows-1252"),
                               Encoding.Unicode,
                               Encoding.BigEndianUnicode,
                               Encoding.UTF7,
                               Encoding.UTF8,
                               Encoding.GetEncoding("shift_jis"),
                               Encoding.GetEncoding("euc-jp"),
                               Encoding.GetEncoding("iso-2022-jp")};

		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;

		public EncodingSelectorComboBox()
		{
			// ̌ĂяóAWindows.Forms tH[ fUCiŕKvłB
            InitializeComponent();

            this.DisplayMember = "EncodingName";
            this.ValueMember = "WebName";
            this.DataSource = EncodingList;
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region R|[lg fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            // 
            // EncodingSelectorComboBox
            // 
            this.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
        }
		#endregion

        [Browsable(false)]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public new object DataSource
        {
            get
            {
                return base.DataSource;
            }
            set
            {
                base.DataSource = value;
            }
        }

        [Browsable(false)]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public new ObjectCollection Items
        {
            get
            {
                return base.Items;
            }
        }

        [Browsable(false)]
        public new string ValueMember
        {
            get
            {
                return base.ValueMember;
            }
            set
            {
                base.ValueMember = value;
            }
        }

        public void SetDefaultSelection()
        {
            this.SelectedIndex = this.FindString(Encoding.GetEncoding("euc-jp").EncodingName);
        }
    }
}
