using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Net;
using System.Windows.Forms;

namespace Syslog.Console.Controls
{
	/// <summary>
	/// IPAddressBox ̊Tv̐łB
	/// </summary>
	public class IPAddressBox : System.Windows.Forms.TextBox
	{
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;
        private System.Windows.Forms.ErrorProvider AddressErrorProvider;

		public IPAddressBox()
		{
			// ̌ĂяóAWindows.Forms tH[ fUCiŕKvłB
			InitializeComponent();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region R|[lg fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            this.AddressErrorProvider = new System.Windows.Forms.ErrorProvider();
            // 
            // IPAddressBox
            // 
            this.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.AddressErrorProvider.SetIconAlignment(this, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
            this.Text = "127.0.0.1";
            this.Validating += new System.ComponentModel.CancelEventHandler(this.Address_Validating);
            this.TextChanged += new System.EventHandler(this.IPAddressBox_TextChanged);

        }
		#endregion

        private void Address_Validating(object sender, System.ComponentModel.CancelEventArgs e)
        {
            string address = this.Text.Trim();

            if (address.Length > 0)
            {
                try
                {
                    IPAddress.Parse(address);

                    AddressErrorProvider.SetError(this, String.Empty);
                }
                catch (Exception ex)
                {
                    AddressErrorProvider.SetError(this, ex.Message);

                    e.Cancel = true;
                }
            }
            else
            {
                AddressErrorProvider.SetError(this, String.Empty);
            }
        }

        private void IPAddressBox_TextChanged(object sender, System.EventArgs e)
        {
            if (this.TextLength == 0)
            {
                this.OnValidating(new CancelEventArgs());
            }
        }

        public string Error
        {
            get
            {
                return this.IPAddressErrorProvider.GetError(this);
            }
            set
            {
                this.IPAddressErrorProvider.SetError(this, value);
            }
        }

        public ErrorIconAlignment IconAlignment
        {
            get
            {
                return this.IPAddressErrorProvider.GetIconAlignment(this);
            }
            set
            {
                this.IPAddressErrorProvider.SetIconAlignment(this, value);
            }
        }

        public int IconPadding
        {
            get
            {
                return this.IPAddressErrorProvider.GetIconPadding(this);
            }
            set
            {
                this.IPAddressErrorProvider.SetIconPadding(this, value);
            }
        }
        
        [Browsable(false)]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public IPAddress Address
        {
            get
            {
                return IPAddress.Parse(this.Text.Trim());
            }
            set
            {
                this.Text = value.ToString();
            }
        }

        public ErrorProvider IPAddressErrorProvider
        {
            get
            {
                return AddressErrorProvider;
            }
            set
            {
                AddressErrorProvider = value;
            }
        }
	}
}
