using System;

namespace Syslog.Console.Controls
{
	/// <summary>
	/// ServiceStartupMode ̊Tv̐łB
	/// </summary>
	public enum ServiceStartupMode
	{
        /// <summary></summary>
        Automatic = 2,
        /// <summary>蓮</summary>
        Manual = 3,
        /// <summary></summary>
        Disabled = 4
	}

    public class ServiceStartupModeType
    {
        private ServiceStartupMode StartupMode = ServiceStartupMode.Automatic;
        private static readonly string[] ModeName = {"", "蓮", ""};

        public ServiceStartupModeType()
        {
        }

        public ServiceStartupModeType(ServiceStartupMode mode)
        {
            StartupMode = mode;
        }

        public ServiceStartupMode Mode
        {
            get
            {
                return StartupMode;
            }
            set
            {
                StartupMode = value;
            }
        }

        public string DisplayName
        {
            get
            {
                return ServiceStartupModeType.ToString(this.Mode);
            }
        }

        public override string ToString()
        {
            return this.DisplayName;
        }

        public static string ToString(ServiceStartupMode mode)
        {
            return ModeName.GetValue((int) mode - (int) ServiceStartupMode.Automatic).ToString();
        }
    }
}
