using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Diagnostics;
using System.Windows.Forms;

namespace Syslog.Console.Controls
{
	/// <summary>
	/// TraceMonitorControl ̊Tv̐łB
	/// </summary>
	public class TraceMonitorControl : System.Windows.Forms.UserControl
    {
        /// <summary>
        /// KvȃfUCiϐłB
        /// </summary>
        #region fUCiϐ
        private System.Windows.Forms.ToolBar TraceToolBar;
        private System.Windows.Forms.ToolBarButton RefreshTraceToolButton;
        private System.Windows.Forms.ToolBarButton SplitTraceToolButton;
        private System.Windows.Forms.ToolBarButton ConnectTraceToolButton;
        private System.Windows.Forms.ToolBarButton DisconnectTraceToolButton;
        private System.Windows.Forms.DataGrid TraceMonitorGrid;
        private System.Data.DataSet TraceDetailsSet;
        private System.Data.DataTable TraceDataTable;
        private System.Data.DataColumn ReceivedTimeColumn;
        private System.Data.DataColumn ReceivedHostColumn;
        private System.Data.DataColumn PriorityColumn;
        private System.Data.DataColumn FacilityColumn;
        private System.Data.DataColumn SeverityColumn;
        private System.Data.DataColumn TimestampColumn;
        private System.Data.DataColumn RemoteHostColumn;
        private System.Data.DataColumn MessageBodyColumn;
        private System.Windows.Forms.DataGridTableStyle TraceDataTableStyle;
        private System.Windows.Forms.DataGridTextBoxColumn ReceivedTimeColumnStyle;
        private System.Windows.Forms.DataGridTextBoxColumn ReceivedHostColumnStyle;
        private System.Windows.Forms.DataGridTextBoxColumn PriorityColumnStyle;
        private System.Windows.Forms.DataGridTextBoxColumn FacilityColumnStyle;
        private System.Windows.Forms.DataGridTextBoxColumn SeverityColumnStyle;
        private System.Windows.Forms.DataGridTextBoxColumn TimestampColumnStyle;
        private System.Windows.Forms.DataGridTextBoxColumn RemoteHostColumnStyle;
        private System.Windows.Forms.DataGridTextBoxColumn MessageBodyColumnStyle;
        private System.Data.DataView TraceDataView;
        private System.Windows.Forms.ListView TraceMonitorList;
        private System.Windows.Forms.ColumnHeader ReceivedTimeHeader;
        private System.Windows.Forms.ColumnHeader ReceivedHostHeader;
        private System.Windows.Forms.ColumnHeader PriorityHeader;
        private System.Windows.Forms.ColumnHeader FacilityHeader;
        private System.Windows.Forms.ColumnHeader SeverityHeader;
        private System.Windows.Forms.ColumnHeader RemoteHostHeader;
        private System.Windows.Forms.ColumnHeader MessageBodyHeader;
        private System.Windows.Forms.ColumnHeader TimestampHeader;
        private System.ComponentModel.IContainer components = null;
        #endregion

		public TraceMonitorControl()
		{
			// ̌ĂяóAWindows.Forms tH[ fUCiŕKvłB
			InitializeComponent();

            this.SelectLatestRow();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region R|[lg fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            this.TraceToolBar = new System.Windows.Forms.ToolBar();
            this.ConnectTraceToolButton = new System.Windows.Forms.ToolBarButton();
            this.DisconnectTraceToolButton = new System.Windows.Forms.ToolBarButton();
            this.SplitTraceToolButton = new System.Windows.Forms.ToolBarButton();
            this.RefreshTraceToolButton = new System.Windows.Forms.ToolBarButton();
            this.TraceMonitorGrid = new System.Windows.Forms.DataGrid();
            this.TraceDataView = new System.Data.DataView();
            this.TraceDataTable = new System.Data.DataTable();
            this.ReceivedTimeColumn = new System.Data.DataColumn();
            this.ReceivedHostColumn = new System.Data.DataColumn();
            this.PriorityColumn = new System.Data.DataColumn();
            this.FacilityColumn = new System.Data.DataColumn();
            this.SeverityColumn = new System.Data.DataColumn();
            this.TimestampColumn = new System.Data.DataColumn();
            this.RemoteHostColumn = new System.Data.DataColumn();
            this.MessageBodyColumn = new System.Data.DataColumn();
            this.TraceDataTableStyle = new System.Windows.Forms.DataGridTableStyle();
            this.ReceivedTimeColumnStyle = new System.Windows.Forms.DataGridTextBoxColumn();
            this.ReceivedHostColumnStyle = new System.Windows.Forms.DataGridTextBoxColumn();
            this.PriorityColumnStyle = new System.Windows.Forms.DataGridTextBoxColumn();
            this.FacilityColumnStyle = new System.Windows.Forms.DataGridTextBoxColumn();
            this.SeverityColumnStyle = new System.Windows.Forms.DataGridTextBoxColumn();
            this.TimestampColumnStyle = new System.Windows.Forms.DataGridTextBoxColumn();
            this.RemoteHostColumnStyle = new System.Windows.Forms.DataGridTextBoxColumn();
            this.MessageBodyColumnStyle = new System.Windows.Forms.DataGridTextBoxColumn();
            this.TraceDetailsSet = new System.Data.DataSet();
            this.TraceMonitorList = new System.Windows.Forms.ListView();
            this.ReceivedTimeHeader = new System.Windows.Forms.ColumnHeader();
            this.ReceivedHostHeader = new System.Windows.Forms.ColumnHeader();
            this.PriorityHeader = new System.Windows.Forms.ColumnHeader();
            this.FacilityHeader = new System.Windows.Forms.ColumnHeader();
            this.SeverityHeader = new System.Windows.Forms.ColumnHeader();
            this.TimestampHeader = new System.Windows.Forms.ColumnHeader();
            this.RemoteHostHeader = new System.Windows.Forms.ColumnHeader();
            this.MessageBodyHeader = new System.Windows.Forms.ColumnHeader();
            ((System.ComponentModel.ISupportInitialize)(this.TraceMonitorGrid)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.TraceDataView)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.TraceDataTable)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.TraceDetailsSet)).BeginInit();
            this.SuspendLayout();
            // 
            // TraceToolBar
            // 
            this.TraceToolBar.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
            this.TraceToolBar.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
                                                                                            this.ConnectTraceToolButton,
                                                                                            this.DisconnectTraceToolButton,
                                                                                            this.SplitTraceToolButton,
                                                                                            this.RefreshTraceToolButton});
            this.TraceToolBar.DropDownArrows = true;
            this.TraceToolBar.Location = new System.Drawing.Point(0, 0);
            this.TraceToolBar.Name = "TraceToolBar";
            this.TraceToolBar.ShowToolTips = true;
            this.TraceToolBar.Size = new System.Drawing.Size(600, 43);
            this.TraceToolBar.TabIndex = 0;
            this.TraceToolBar.TabStop = true;
            this.TraceToolBar.Wrappable = false;
            this.TraceToolBar.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.TraceToolBar_ButtonClick);
            // 
            // ConnectTraceToolButton
            // 
            this.ConnectTraceToolButton.Text = "Jn(&C)";
            // 
            // DisconnectTraceToolButton
            // 
            this.DisconnectTraceToolButton.Enabled = false;
            this.DisconnectTraceToolButton.Text = "~(&D)";
            // 
            // SplitTraceToolButton
            // 
            this.SplitTraceToolButton.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // RefreshTraceToolButton
            // 
            this.RefreshTraceToolButton.Text = "XV(&R)";
            // 
            // TraceMonitorGrid
            // 
            this.TraceMonitorGrid.AllowNavigation = false;
            this.TraceMonitorGrid.CaptionFont = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.TraceMonitorGrid.CaptionVisible = false;
            this.TraceMonitorGrid.DataMember = "";
            this.TraceMonitorGrid.DataSource = this.TraceDataView;
            this.TraceMonitorGrid.Dock = System.Windows.Forms.DockStyle.Top;
            this.TraceMonitorGrid.FlatMode = true;
            this.TraceMonitorGrid.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.TraceMonitorGrid.HeaderFont = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.TraceMonitorGrid.HeaderForeColor = System.Drawing.SystemColors.ControlText;
            this.TraceMonitorGrid.Location = new System.Drawing.Point(0, 43);
            this.TraceMonitorGrid.Name = "TraceMonitorGrid";
            this.TraceMonitorGrid.ParentRowsVisible = false;
            this.TraceMonitorGrid.ReadOnly = true;
            this.TraceMonitorGrid.RowHeadersVisible = false;
            this.TraceMonitorGrid.Size = new System.Drawing.Size(600, 144);
            this.TraceMonitorGrid.TabIndex = 1;
            this.TraceMonitorGrid.TableStyles.AddRange(new System.Windows.Forms.DataGridTableStyle[] {
                                                                                                         this.TraceDataTableStyle});
            // 
            // TraceDataView
            // 
            this.TraceDataView.AllowDelete = false;
            this.TraceDataView.AllowEdit = false;
            this.TraceDataView.AllowNew = false;
            this.TraceDataView.ApplyDefaultSort = true;
            this.TraceDataView.Sort = "ReceivedTime ASC";
            this.TraceDataView.Table = this.TraceDataTable;
            // 
            // TraceDataTable
            // 
            this.TraceDataTable.Columns.AddRange(new System.Data.DataColumn[] {
                                                                                  this.ReceivedTimeColumn,
                                                                                  this.ReceivedHostColumn,
                                                                                  this.PriorityColumn,
                                                                                  this.FacilityColumn,
                                                                                  this.SeverityColumn,
                                                                                  this.TimestampColumn,
                                                                                  this.RemoteHostColumn,
                                                                                  this.MessageBodyColumn});
            this.TraceDataTable.MinimumCapacity = 2500;
            this.TraceDataTable.TableName = "TraceData";
            // 
            // ReceivedTimeColumn
            // 
            this.ReceivedTimeColumn.AllowDBNull = false;
            this.ReceivedTimeColumn.Caption = "M";
            this.ReceivedTimeColumn.ColumnMapping = System.Data.MappingType.Attribute;
            this.ReceivedTimeColumn.ColumnName = "ReceivedTime";
            this.ReceivedTimeColumn.DataType = typeof(System.DateTime);
            // 
            // ReceivedHostColumn
            // 
            this.ReceivedHostColumn.ColumnMapping = System.Data.MappingType.Attribute;
            this.ReceivedHostColumn.ColumnName = "ReceivedHost";
            // 
            // PriorityColumn
            // 
            this.PriorityColumn.AllowDBNull = false;
            this.PriorityColumn.ColumnMapping = System.Data.MappingType.Attribute;
            this.PriorityColumn.ColumnName = "Priority";
            this.PriorityColumn.DataType = typeof(System.Byte);
            // 
            // FacilityColumn
            // 
            this.FacilityColumn.AllowDBNull = false;
            this.FacilityColumn.ColumnMapping = System.Data.MappingType.Attribute;
            this.FacilityColumn.ColumnName = "Facility";
            // 
            // SeverityColumn
            // 
            this.SeverityColumn.AllowDBNull = false;
            this.SeverityColumn.ColumnMapping = System.Data.MappingType.Attribute;
            this.SeverityColumn.ColumnName = "Severity";
            // 
            // TimestampColumn
            // 
            this.TimestampColumn.AllowDBNull = false;
            this.TimestampColumn.ColumnMapping = System.Data.MappingType.Attribute;
            this.TimestampColumn.ColumnName = "Timestamp";
            this.TimestampColumn.DataType = typeof(System.DateTime);
            // 
            // RemoteHostColumn
            // 
            this.RemoteHostColumn.AllowDBNull = false;
            this.RemoteHostColumn.ColumnMapping = System.Data.MappingType.Attribute;
            this.RemoteHostColumn.ColumnName = "RemoteHost";
            // 
            // MessageBodyColumn
            // 
            this.MessageBodyColumn.ColumnMapping = System.Data.MappingType.SimpleContent;
            this.MessageBodyColumn.ColumnName = "MessageBody";
            // 
            // TraceDataTableStyle
            // 
            this.TraceDataTableStyle.DataGrid = this.TraceMonitorGrid;
            this.TraceDataTableStyle.GridColumnStyles.AddRange(new System.Windows.Forms.DataGridColumnStyle[] {
                                                                                                                  this.ReceivedTimeColumnStyle,
                                                                                                                  this.ReceivedHostColumnStyle,
                                                                                                                  this.PriorityColumnStyle,
                                                                                                                  this.FacilityColumnStyle,
                                                                                                                  this.SeverityColumnStyle,
                                                                                                                  this.TimestampColumnStyle,
                                                                                                                  this.RemoteHostColumnStyle,
                                                                                                                  this.MessageBodyColumnStyle});
            this.TraceDataTableStyle.HeaderForeColor = System.Drawing.SystemColors.ControlText;
            this.TraceDataTableStyle.MappingName = "TraceData";
            this.TraceDataTableStyle.ReadOnly = true;
            this.TraceDataTableStyle.RowHeadersVisible = false;
            // 
            // ReceivedTimeColumnStyle
            // 
            this.ReceivedTimeColumnStyle.Format = "yyyy-MM-ddTHH:mm:ss.ff";
            this.ReceivedTimeColumnStyle.FormatInfo = null;
            this.ReceivedTimeColumnStyle.HeaderText = "M";
            this.ReceivedTimeColumnStyle.MappingName = "ReceivedTime";
            this.ReceivedTimeColumnStyle.ReadOnly = true;
            this.ReceivedTimeColumnStyle.Width = 130;
            // 
            // ReceivedHostColumnStyle
            // 
            this.ReceivedHostColumnStyle.Format = "";
            this.ReceivedHostColumnStyle.FormatInfo = null;
            this.ReceivedHostColumnStyle.HeaderText = "MzXg";
            this.ReceivedHostColumnStyle.MappingName = "ReceivedHost";
            this.ReceivedHostColumnStyle.ReadOnly = true;
            this.ReceivedHostColumnStyle.Width = 75;
            // 
            // PriorityColumnStyle
            // 
            this.PriorityColumnStyle.Format = "";
            this.PriorityColumnStyle.FormatInfo = null;
            this.PriorityColumnStyle.HeaderText = "Dx";
            this.PriorityColumnStyle.MappingName = "Priority";
            this.PriorityColumnStyle.ReadOnly = true;
            this.PriorityColumnStyle.Width = 45;
            // 
            // FacilityColumnStyle
            // 
            this.FacilityColumnStyle.Format = "";
            this.FacilityColumnStyle.FormatInfo = null;
            this.FacilityColumnStyle.HeaderText = "@\";
            this.FacilityColumnStyle.MappingName = "Facility";
            this.FacilityColumnStyle.ReadOnly = true;
            this.FacilityColumnStyle.Width = 50;
            // 
            // SeverityColumnStyle
            // 
            this.SeverityColumnStyle.Format = "";
            this.SeverityColumnStyle.FormatInfo = null;
            this.SeverityColumnStyle.HeaderText = "dx";
            this.SeverityColumnStyle.MappingName = "Severity";
            this.SeverityColumnStyle.ReadOnly = true;
            this.SeverityColumnStyle.Width = 50;
            // 
            // TimestampColumnStyle
            // 
            this.TimestampColumnStyle.Format = "s";
            this.TimestampColumnStyle.FormatInfo = null;
            this.TimestampColumnStyle.HeaderText = "^CX^v";
            this.TimestampColumnStyle.MappingName = "Timestamp";
            this.TimestampColumnStyle.ReadOnly = true;
            this.TimestampColumnStyle.Width = 115;
            // 
            // RemoteHostColumnStyle
            // 
            this.RemoteHostColumnStyle.Format = "";
            this.RemoteHostColumnStyle.FormatInfo = null;
            this.RemoteHostColumnStyle.HeaderText = "MzXg";
            this.RemoteHostColumnStyle.MappingName = "RemoteHost";
            this.RemoteHostColumnStyle.ReadOnly = true;
            this.RemoteHostColumnStyle.Width = 75;
            // 
            // MessageBodyColumnStyle
            // 
            this.MessageBodyColumnStyle.Format = "";
            this.MessageBodyColumnStyle.FormatInfo = null;
            this.MessageBodyColumnStyle.HeaderText = "bZ[W";
            this.MessageBodyColumnStyle.MappingName = "MessageBody";
            this.MessageBodyColumnStyle.ReadOnly = true;
            this.MessageBodyColumnStyle.Width = 500;
            // 
            // TraceDetailsSet
            // 
            this.TraceDetailsSet.DataSetName = "TraceDetails";
            this.TraceDetailsSet.Locale = new System.Globalization.CultureInfo("ja-JP");
            this.TraceDetailsSet.Namespace = "urn:schemas-cham-reo-net/managedsyslogserver/1.0/console/controls";
            this.TraceDetailsSet.Tables.AddRange(new System.Data.DataTable[] {
                                                                                 this.TraceDataTable});
            // 
            // TraceMonitorList
            // 
            this.TraceMonitorList.AllowColumnReorder = true;
            this.TraceMonitorList.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                               this.ReceivedTimeHeader,
                                                                                               this.ReceivedHostHeader,
                                                                                               this.PriorityHeader,
                                                                                               this.FacilityHeader,
                                                                                               this.SeverityHeader,
                                                                                               this.TimestampHeader,
                                                                                               this.RemoteHostHeader,
                                                                                               this.MessageBodyHeader});
            this.TraceMonitorList.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.TraceMonitorList.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.TraceMonitorList.FullRowSelect = true;
            this.TraceMonitorList.GridLines = true;
            this.TraceMonitorList.Location = new System.Drawing.Point(0, 190);
            this.TraceMonitorList.MultiSelect = false;
            this.TraceMonitorList.Name = "TraceMonitorList";
            this.TraceMonitorList.Size = new System.Drawing.Size(600, 160);
            this.TraceMonitorList.Sorting = System.Windows.Forms.SortOrder.Descending;
            this.TraceMonitorList.TabIndex = 2;
            this.TraceMonitorList.View = System.Windows.Forms.View.Details;
            // 
            // ReceivedTimeHeader
            // 
            this.ReceivedTimeHeader.Text = "M";
            this.ReceivedTimeHeader.Width = 135;
            // 
            // ReceivedHostHeader
            // 
            this.ReceivedHostHeader.Text = "MzXg";
            // 
            // PriorityHeader
            // 
            this.PriorityHeader.Text = "Dx";
            this.PriorityHeader.Width = 55;
            // 
            // FacilityHeader
            // 
            this.FacilityHeader.Text = "@\";
            this.FacilityHeader.Width = 55;
            // 
            // SeverityHeader
            // 
            this.SeverityHeader.Text = "dx";
            this.SeverityHeader.Width = 55;
            // 
            // TimestampHeader
            // 
            this.TimestampHeader.Text = "^CX^v";
            this.TimestampHeader.Width = 120;
            // 
            // RemoteHostHeader
            // 
            this.RemoteHostHeader.Text = "MzXg";
            // 
            // MessageBodyHeader
            // 
            this.MessageBodyHeader.Text = "bZ[W";
            this.MessageBodyHeader.Width = 300;
            // 
            // TraceMonitorControl
            // 
            this.Controls.Add(this.TraceMonitorList);
            this.Controls.Add(this.TraceMonitorGrid);
            this.Controls.Add(this.TraceToolBar);
            this.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.Name = "TraceMonitorControl";
            this.Size = new System.Drawing.Size(600, 350);
            ((System.ComponentModel.ISupportInitialize)(this.TraceMonitorGrid)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.TraceDataView)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.TraceDataTable)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.TraceDetailsSet)).EndInit();
            this.ResumeLayout(false);

        }
		#endregion

        private void SelectLatestRow()
        {
            if (TraceMonitorList.Items.Count > 0)
            {
                TraceMonitorList.Items[TraceMonitorList.Items.Count -1].Selected = true;
                TraceMonitorList.EnsureVisible(TraceMonitorList.Items.Count - 1);
            }
            
            TraceMonitorGrid.Select(TraceDataView.Count - 1);
        }

        private void TraceToolBar_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
        {
            const int ConnectButtonIndex = 0;
            const int DisconnectButtonIndex = 1;
            const int RefreshButtonIndex = 3;

            switch (TraceToolBar.Buttons.IndexOf(e.Button))
            {
                case ConnectButtonIndex:
                {
                    this.StartTrace();

                    e.Button.Enabled = false;
                    TraceToolBar.Buttons[DisconnectButtonIndex].Enabled = true;

                    break;
                }
                case DisconnectButtonIndex:
                {
                    this.StopTrace();

                    e.Button.Enabled = false;
                    TraceToolBar.Buttons[ConnectButtonIndex].Enabled = true;

                    break;
                }
                case RefreshButtonIndex:
                {
                    TraceMonitorGrid.Refresh();
                    TraceMonitorList.Refresh();
                    TraceMonitorList.EnsureVisible(TraceMonitorList.Items.Count - 1);
                    break;
                }
            }
        }

        private void StartTrace()
        {
        }

        private void StopTrace()
        {
        }
    }
}
