using System;
using System.Collections;
using System.Collections.Specialized;
using System.Runtime.Serialization;

namespace Syslog.Config
{
	/// <summary>
	/// <see cref="NameObjectCollectionBase"/>  <see cref="AssemblyEntry"/> ̃RNV\܂B
	/// </summary>
    public class AssemblyEntryCollection : NameObjectCollectionBase, ICloneable, ICollection
    {
        #region RXgN^ WbN
        /// <summary>
        /// <para> <see cref="AssemblyEntryCollection"/> 쐬܂B</para>
        /// </summary>
        /// <remarks>>
        /// <para>̏ʂ 8 łB</para>
        /// </remarks>
        public AssemblyEntryCollection() : base(8)
        {
        }

        /// <summary>
        /// w肵ʂ <see cref="AssemblyEntryCollection"/> 쐬܂
        /// </summary>
        /// <param name="capacity"><see cref="AssemblyEntryCollection"/> ԂŊi[ł <see cref="AssemblyEntry"/> ̐B</param>
        public AssemblyEntryCollection(int capacity) : base(capacity)
        {
        }

        /// <summary>
        /// w肵nbVR[hvoC_ƔrZqgp <see cref="AssemblyEntryCollection"/> 쐬܂B
        /// </summary>
        /// <param name="hashProvider">
        /// <para>eL[ <see cref="Object.GetHashCode"/> ł̃nbVR[hvoC_𗘗pꍇ null QƁB</para>
        /// <para>܂</para>
        /// <para><see cref="AssemblyEntryCollection"/> ׂ̂ẴL[ɃnbVR[h񋟂 <see cref="IHashCodeProvider"/>B</para>
        /// </param>
        /// <param name="comparer">
        /// <para>eL[ <see cref="Object.Equals"/> ł̔rZq𗘗pꍇ null QƁB</para>
        /// <para>܂</para>
        /// <para>2̃L[ǂ𔻒f邽߂Ɏgp <see cref="IComparer"/>B</para>
        /// </param>
        public AssemblyEntryCollection(IHashCodeProvider hashProvider, IComparer comparer) : base(hashProvider, comparer)
        {
        }

        /// <summary>
        /// w肵 <see cref="SerializationInfo"/>  <see cref="StreamingContext"/> ŃVAł <see cref="AssemblyEntryCollection"/> 쐬܂B
        /// </summary>
        /// <param name="info"><see cref="AssemblyEntryCollection"/> VA邽߂ɕKvȏi[Ă <see cref="SerializationInfo"/>B</param>
        /// <param name="context"><see cref="AssemblyEntryCollection"/> Ɋ֘AtĂVAXg[̃\[XуfXeBl[Vi[Ă <see cref="StreamingContext"/>B</param>
        public AssemblyEntryCollection(SerializationInfo info, StreamingContext context) : base(info, context)
        {
        }

        /// <summary>
        /// w肵ʂŃnbVR[hvoC_ƔrZqgp <see cref="AssemblyEntryCollection"/> 쐬܂B
        /// </summary>
        /// <param name="capacity"><see cref="AssemblyEntryCollection"/> ԂŊi[ł <see cref="AssemblyEntry"/> ̐B</param>
        /// <param name="hashProvider">
        /// <para>eL[ <see cref="Object.GetHashCode"/> ł̃nbVR[hvoC_𗘗pꍇ null QƁB</para>
        /// <para>܂</para>
        /// <para><see cref="AssemblyEntryCollection"/> ׂ̂ẴL[ɃnbVR[h񋟂 <see cref="IHashCodeProvider"/>B</para>
        /// </param>
        /// <param name="comparer">
        /// <para>eL[ <see cref="Object.Equals"/> ł̔rZq𗘗pꍇ null QƁB</para>
        /// <para>܂</para>
        /// <para>2̃L[ǂ𔻒f邽߂Ɏgp <see cref="IComparer"/>B</para>
        /// </param>
        public AssemblyEntryCollection(int capacity, IHashCodeProvider hashProvider, IComparer comparer)
            : base(capacity, hashProvider, comparer)
        {
        }
        #endregion

        /// <summary>
        /// <see cref="AssemblyEntryCollection"/> ̎w肵CfbNXɂGg擾܂B
        /// </summary>
        public AssemblyEntry this[int index]
        {
            get
            {
                return (AssemblyEntry) this.BaseGet(index);
            }
        }

        /// <summary>
        /// <see cref="AssemblyEntryCollection"/> ̎w肵[Gg擾܂͐ݒ肵܂B
        /// </summary>
        public AssemblyEntry this[string name]
        {
            get
            {
                return (AssemblyEntry) this.BaseGet(name);
            }
            set
            {
                if (value != null)
                {
                    this.BaseSet(name, value);
                }
                else
                {
                    throw new ArgumentNullException("Item");
                }
            }
        }

        /// <summary>
        /// <see cref="AssemblyEntryCollection"/> ׂ̂ẴL[擾܂B
        /// </summary>
        public string[] AllKeys
        {
            get
            {
                return this.BaseGetAllKeys();
            }
        }

        /// <summary>
        /// <see cref="AssemblyEntryCollection"/> ׂ̂ẴGg擾܂B
        /// </summary>
        public AssemblyEntry[] AllValues
        {
            get
            {
                return (AssemblyEntry[]) this.BaseGetAllValues(typeof(AssemblyEntry));
            }
        }

        /// <summary>
        /// <see cref="AssemblyEntryCollection"/> AnullQƂł͂ȂL[i[Ă邩ǂ͎l擾܂B
        /// </summary>
        public bool HasKeys
        {
            get
            {
                return this.BaseHasKeys();
            }
        }

        /// <summary>
        /// ݂ <see cref="AssemblyEntryCollection"/> ɃGgǉ܂B
        /// </summary>
        /// <param name="entry">ǉ <see cref="AssemblyEntry"/>B</param>
        public void Add(AssemblyEntry entry)
        {
            this.Add(entry.ID, entry);
        }

        /// <summary>
        /// w肵OђlGg <see cref="AssemblyEntryCollection"/> ɒǉ܂B
        /// </summary>
        /// <param name="key"></param>
        /// <param name="entry">ǉ <see cref="AssemblyEntry"/>B</param>
        public void Add(string key, AssemblyEntry entry)
        {
            if (key == null)
            {
                throw new ArgumentNullException("key");
            }

            if (entry == null)
            {
                throw new ArgumentNullException("entry");
            }

            this.BaseAdd(key, entry);
        }

        /// <summary>
        /// w肵L[Gg <see cref="AssemblyEntryCollection"/> CX^X폜܂B
        /// </summary>
        /// <param name="key">폜Gg̃L[B</param>
        public void Remove(string key)
        {
            this.BaseRemove(key);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="index"></param>
        public void RemoveAt(int index)
        {
            this.BaseRemoveAt(index);
        }

        /// <summary>
        /// <see cref="AssemblyEntryCollection"/> 炷ׂẴGg폜܂B
        /// </summary>
        public void Clear()
        {
            this.BaseClear();
        }

        /// <summary>
        /// <see cref="AssemblyEntryCollection"/> ̎w肵CfbNXɂL[擾܂B
        /// </summary>
        /// <param name="index">RNV擾L[ 0 n܂CfbNXB</param>
        /// <returns><see cref="AssemblyEntryCollection"/> ̎w肵CfbNXɂL[B</returns>
        public string GetKey(int index)
        {
            return this.BaseGetKey(index);
        }

        #region ICloneable o
        /// <summary>
        /// <see cref="AssemblyEntryCollection"/> ̏ڍ׃Rs[쐬܂B
        /// </summary>
        /// <returns><see cref="AssemblyEntryCollection"/> ̏ڍ׃Rs[B</returns>
        public object Clone()
        {
            // V AssemblyEntryCollection 쐬
            AssemblyEntryCollection col = new AssemblyEntryCollection(this.Count);

            lock (this)
            {
                // ׂĂ AssemblyEntry ̏ڍ׃Rs[쐬
                foreach (string key in this.Keys)
                {
                    col.Add((AssemblyEntry) this[key].Clone());
                }
            }

            // AssemblyEntryCollection ̏ڍ׃Rs[ԂB
            return col;
        }
        #endregion


        /// <summary>
        /// <see cref="AssemblyEntryCollection"/> 𔽕ł <see cref="System.Collections.IEnumerator"/> Ԃ܂B
        /// </summary>
        /// <returns><see cref="AssemblyEntryCollection"/>  <see cref="System.Collections.IEnumerator"/>B</returns>
        public new IEnumerator GetEnumerator()
        {
            return this.AllValues.GetEnumerator();
        }

        #region ICollection o
        /// <summary>
        /// <see cref="AssemblyEntryCollection"/> ւ̃ANZXĂ邩ǂl擾܂B
        /// </summary>
        public bool IsSynchronized
        {
            get
            {
                return false;
            }
        }

        /// <summary>
        /// 1  <see cref="System.Array"/> CX^X̎w肵CfbNX <see cref="AssemblyEntryCollection"/> ̃GgRs[܂B
        /// </summary>
        /// <param name="array"><see cref="AssemblyEntryCollection"/>  <see cref="AssemblyEntry"/> Rs[ 1 <see cref="System.Array"/>B</param>
        /// <param name="index">Rs[̊JnʒuƂȂAarray  0 n܂CfbNXԍB</param>
        public void CopyTo(Array array, int index)
        {
            this.CopyTo(array, (long) index);
        }

        /// <summary>
        /// 1  <see cref="System.Array"/> CX^X̎w肵 64 rbglCfbNX <see cref="AssemblyEntryCollection"/> ̃GgRs[܂B
        /// </summary>
        /// <param name="array"><see cref="AssemblyEntryCollection"/>  <see cref="AssemblyEntry"/> Rs[ 1 <see cref="System.Array"/>B</param>
        /// <param name="index">Rs[̊JnʒuƂȂAarray  0 n܂ 64 rbglCfbNXԍB</param>
        public void CopyTo(Array array, long index)
        {
            AssemblyEntryCollection Entries = (AssemblyEntryCollection) this.Clone();
            Entries.AllValues.CopyTo(array, index);
        }

        /// <summary>
        /// <see cref="AssemblyEntryCollection"/> ւ̃ANZX𓯊łIuWFNg擾܂B
        /// </summary>
        public object SyncRoot
        {
            get
            {
                return this;
            }
        }

        #endregion
    }
}
