using System;
using System.Collections;
using System.Configuration;
using System.Diagnostics;
using System.Text;

namespace Syslog.Config
{
	/// <summary>
	/// app.config ݒt@CftHg̕GR[fBOݒ擾܂
	/// </summary>
	public class DefaultEncoding
    {
        private const string ConfigEncodingSection = "syslogConfig/settings/defaultEncoding";
        private const string ConfigEncodingKey = "name";
        private const string DefaultEncodingName = "euc-jp";

        /// <summary>
        /// ftHg̕GR[fBOݒ擾܂B
        /// </summary>
        /// <example>
        /// <para>\t@CݒB</para>
        /// <code>&lt;defaultEncoding name="euc-jp" /&gt;</code>
        /// </example>
        /// <returns>app.config ̒lɐݒ肳ꂽ <see cref="Encoding"/>B</returns>
        public static Encoding GetDefaultEncoding()
        {
            // app.config ݒt@CftHg̕GR[fBOݒǂݍ
            IDictionary encodingSetting = (IDictionary) ConfigurationSettings.GetConfig(ConfigEncodingSection);
            
            try
            {
                // GR[fBOw肳Ăꍇ
                if (encodingSetting.Contains(ConfigEncodingKey))
                {
                    // w肳ꂽGR[fBOԂ
                    return Encoding.GetEncoding(encodingSetting[ConfigEncodingKey].ToString());
                }
            }
            catch (NotSupportedException e)
            {
                Debug.Assert(false, "w肳ꂽGR[fBOpł܂ł!", e.ToString());
                Trace.WriteLine("w肳ꂽGR[fBOpł܂ł!", "Syslog.Config.DefaultEncoding");
                // ȕGR[fBOw肳Ăꍇ̓ftHg̕GR[fBO𗘗p
            }

            // ftHg̕GR[fBOԂ
            return Encoding.GetEncoding(DefaultEncodingName);
        }
	}
}
