using System;
using System.Diagnostics;

namespace Syslog.Relay
{
	/// <summary>
	/// [eBOɃtB^OKp邽߂̃CxgfQ[g񋟂܂B
	/// </summary>
	public class RelayFilterEvent
	{
        /// <summary>
        /// [eBOCxgB[eBOtB^Kp邽߂̃CxgłB
        /// </summary>
        public event RoutingEventHandler Routing;

        /// <summary>
        /// ftHgRXgN^B
        /// </summary>
		public RelayFilterEvent()
		{
		}

        /// <summary>
        /// [eBOtB^Cxgs܂B
        /// </summary>
        /// <param name="sender">Cxg̔\[XIuWFNgB</param>
        /// <param name="e">[eBOCxgŗp RoutingEventArgsB</param>
        /// <returns>̃tB^ɓn SyslogInfo B null Ԃƃ[eBOrŒ~܂B</returns>
        internal protected SyslogInfo OnRouting(object sender, RoutingEventArgs e)
        {
            // [eBOCxg̃Xio^Ăꍇ
            if (Routing != null)
            {
                SyslogInfo info = e.Syslog;

                // [eBOtB^CxgM郊XĩXg擾
                Delegate[] DelegateList = Routing.GetInvocationList();

                // tB^OCxgԂɏ
                foreach (Delegate d in DelegateList)
                {
                    // CxgfQ[goRătB^O
                    info = (SyslogInfo) d.DynamicInvoke(new object[] {e.Plugin, e});

                    // null Ԃꂽꍇ͌㑱̏~
                    if (info == null)
                    {
                        Trace.Indent();
                        Trace.WriteLine(String.Format("Syslog Message Filtered of Routing Filter on {0}, {1}", ((ISyslogRelayFilter) d.Target).Name, DateTime.Now.ToString("s")), "Syslog.Relay.RelayController");
                        Trace.Unindent();

                        break;
                    }
                }

                // ̃W[ɏp
                return info;
            }
            // [eBOCxgXi݂Ȃꍇ
            else
            {
                // 㑱̏~
                return null;
            }
        }
	}
}
