using System;
using System.Collections;
using System.ComponentModel;
using System.Configuration.Install;
using System.Diagnostics;
using Microsoft.Win32;

namespace Syslog.Collector.Writer
{
	/// <summary>
	/// SimpleEventLogWriter 쐬 Syslog CxgOCXg[ō폜邽߂̃CXg[NXB
	/// </summary>
	[RunInstaller(true)]
	public class SyslogEventLogInstaller : System.Configuration.Install.Installer
    {
        private const string EventLogKeyPath = @"SYSTEM\CurrentControlSet\Services\EventLog\Syslog";
        private const string EventLogMaxSizeKey = "MaxSize";
        private const int EventLogMaxSizeValue = 10485760;
        private const string EventLogRetentionKey = "Retention";
        private const int EventLogRetentionValue = 0;

		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;

        /// <summary>
        /// RXgN^B
        /// </summary>
		public SyslogEventLogInstaller() : base()
		{
			// ̌Ăяo̓fUCiŕKvłB
			InitializeComponent();

            // CxgÕ\[Xłɓo^Ăꍇ
            if (EventLog.SourceExists(SimpleEventLogWriter.Source))
            {
                // \[X폜
                EventLog.DeleteEventSource(SimpleEventLogWriter.Source);
            }

            // CxgO쐬邽߂ɃCXg[NX𗘗p
            EventLogInstaller myEventLogInstaller = new EventLogInstaller();
            // CxgÕ\[Xݒ肷
            myEventLogInstaller.Source = SimpleEventLogWriter.Source;
            // bZ[WۑCxgO̖Oݒ肷
            myEventLogInstaller.Log = SimpleEventLogWriter.Log;
            // CXg[NXRNVɒǉ
            Installers.Add(myEventLogInstaller);
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}


		#region R|[lg fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			components = new System.ComponentModel.Container();
		}
		#endregion

        
        /// <summary>
        /// CXg[ŃCXg[sꂽƂ Syslog CxgO쐬܂B
        /// </summary>
        /// <param name="stateSaver">CXg[ÕRs[^̏Ԃi[Ă IDictionary B</param>
        public override void Install(IDictionary stateSaver)
        {
            base.Install (stateSaver);
            
            // WXgL[݉\ŃI[v܂
            using (RegistryKey EventLogKey = Registry.LocalMachine.OpenSubKey(String.Format(EventLogKeyPath, SimpleEventLogWriter.Log), true))
            {
                // CxgO̍őTCYݒ肵܂
                EventLogKey.SetValue(EventLogMaxSizeKey, EventLogMaxSizeValue);
                // CxgȌ㏑ݒ肵܂
                EventLogKey.SetValue(EventLogRetentionKey, EventLogRetentionValue);

                EventLogKey.Close();
            }
        }

        /// <summary>
        /// CXg[Ń[obNsꂽƂ Syslog CxgO폜܂B
        /// </summary>
        /// <param name="savedState">CXg[ÕRs[^̏Ԃi[Ă IDictionary B</param>
        public override void Rollback(IDictionary savedState)
        {
            base.Rollback (savedState);
            
            try
            {
                // WXgL[݉\ŃI[v܂
                using (RegistryKey EventLogKey = Registry.LocalMachine.OpenSubKey(String.Format(EventLogKeyPath, SimpleEventLogWriter.Log), true))
                {
                    // CxgO̍őTCY폜܂
                    EventLogKey.DeleteValue(EventLogMaxSizeKey, false);
                    // CxgȌ㏑폜܂
                    EventLogKey.DeleteValue(EventLogRetentionKey, false);

                    EventLogKey.Close();
                }
            }
            catch (Exception e)
            {
                // G[OɋL^
                base.Context.LogMessage(e.ToString());
            }
        }

        /// <summary>
        /// CXg[ŃACXg[sꂽƂ Syslog CxgO폜܂B
        /// </summary>
        /// <param name="savedState">CXg[̃Rs[^̏Ԃi[Ă IDictionary B</param>
        public override void Uninstall(IDictionary savedState)
        {
            base.Uninstall (savedState);
            
            try
            {
                // WXgL[݉\ŃI[v܂
                using (RegistryKey EventLogKey = Registry.LocalMachine.OpenSubKey(String.Format(EventLogKeyPath, SimpleEventLogWriter.Log), true))
                {
                    // CxgO̍őTCY폜܂
                    EventLogKey.DeleteValue(EventLogMaxSizeKey, false);
                    // CxgȌ㏑폜܂
                    EventLogKey.DeleteValue(EventLogRetentionKey, false);

                    EventLogKey.Close();
                }
            }
            catch (Exception e)
            {
                // G[OɋL^
                base.Context.LogMessage(e.ToString());
            }
        }
    }
}
