using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Diagnostics;
using System.IO;
using System.Reflection;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace Syslog.Console.Controls
{
	/// <summary>
	/// ConfigCreateControl ̊Tv̐łB
	/// </summary>
	public class ConfigCreateControl : System.Windows.Forms.UserControl
	{
        private const int ConfigIndentSize = 2;

        #region fUCiϐ
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;
        private System.Windows.Forms.GroupBox ConfigDesignerGroup;
        private System.Windows.Forms.Splitter ConfigSplitter;
        private System.Windows.Forms.TreeView ConfigSectionTree;
        private System.Windows.Forms.TabControl ConfigCreatorTab;
        private System.Windows.Forms.TabPage GlobalSettingsPage;
        private System.Windows.Forms.TabPage SimpleSyslogForwarderPage;
        private System.Windows.Forms.TabPage TracePage;
        private System.Windows.Forms.TabPage IPv6Page;
        private System.Windows.Forms.TabPage ListenerPage;
        private System.Windows.Forms.TabPage ListenerModulePage;
        private System.Windows.Forms.TabPage UDPListenerPage;
        private System.Windows.Forms.TabPage ListenerFilterPage;
        private System.Windows.Forms.TabPage EncodingSelectorPage;
        private System.Windows.Forms.TabPage RelayPage;
        private System.Windows.Forms.TabPage RelayPluginPage;
        private System.Windows.Forms.TabPage DefaultCollectorPluginPage;
        private System.Windows.Forms.TabPage RelayFilterPage;
        private System.Windows.Forms.TabPage SourceAddressFilterPage;
        private System.Windows.Forms.TabPage PriorityFilterPage;
        private System.Windows.Forms.TabPage CollectorPage;
        private System.Windows.Forms.TabPage SimpleFileWriterPage;
        private System.Windows.Forms.TabPage SimpleEventLogWriterPage;
        private System.Windows.Forms.TabPage SimpleDbWriterPage;
        private System.Windows.Forms.Button ConfigPreviewButton;
        private System.Windows.Forms.Button ConfigSaveButton;
        private System.Windows.Forms.TabPage SimpleEventLogListenerPage;
        private Syslog.Console.Controls.ConfigCreator.GlobalSettingsInputControl GlobalSettingsInput;
        private Syslog.Console.Controls.ConfigCreator.IPv6InputControl IPv6Input;
        private Syslog.Console.Controls.ConfigCreator.TraceInputControl TraceInput;
        private Syslog.Console.Controls.ConfigCreator.ListenerInputControl ListenerInput;
        private Syslog.Console.Controls.ConfigCreator.ListenerModuleInputControl ListenerModuleInput;
        private Syslog.Console.Controls.ConfigCreator.UdpListenerInputControl UdpListenerInput;
        private Syslog.Console.Controls.ConfigCreator.EventLogListenerInputControl EventLogListenerInput;
        private Syslog.Console.Controls.ConfigCreator.ListenerFilterInputControl ListenerFilterInput;
        private Syslog.Console.Controls.ConfigCreator.RelayInputControl RelayInput;
        private Syslog.Console.Controls.ConfigCreator.RelayPluginInputControl RelayPluginInput;
        private Syslog.Console.Controls.ConfigCreator.DefaultCollectorPluginInputControl DefaultCollectorPluginInput;
        private Syslog.Console.Controls.ConfigCreator.RelayFilterInputControl RelayFilterInput;
        private Syslog.Console.Controls.ConfigCreator.SourceAddressRelayFilterInputControl SourceAddressRelayFilterInput;
        private Syslog.Console.Controls.ConfigCreator.PriorityFilterInputControl PriorityFilterInput;
        private Syslog.Console.Controls.ConfigCreator.CollectorInputControl CollectorInput;
        private Syslog.Console.Controls.ConfigCreator.FileWriterInputControl FileWriterInput;
        private Syslog.Console.Controls.ConfigCreator.EventLogWriterInputControl EventLogWriterInput;
        private Syslog.Console.Controls.ConfigCreator.DbWriterInputControl DbWriterInput;
        private Syslog.Console.Controls.ConfigCreator.SyslogForwarderInputControl SyslogForwarderInput;
        private Syslog.Console.Controls.ConfigCreator.EncodingSelectorInputControl EncodingSelectorInput;
        private System.Windows.Forms.SaveFileDialog ConfigSaveDialog;
        private System.Windows.Forms.Panel ConfigBuildPanel;
        #endregion

		public ConfigCreateControl()
		{
			// ̌ĂяóAWindows.Forms tH[ fUCiŕKvłB
			InitializeComponent();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region R|[lg fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            this.ConfigDesignerGroup = new System.Windows.Forms.GroupBox();
            this.ConfigCreatorTab = new System.Windows.Forms.TabControl();
            this.GlobalSettingsPage = new System.Windows.Forms.TabPage();
            this.GlobalSettingsInput = new Syslog.Console.Controls.ConfigCreator.GlobalSettingsInputControl();
            this.TracePage = new System.Windows.Forms.TabPage();
            this.TraceInput = new Syslog.Console.Controls.ConfigCreator.TraceInputControl();
            this.IPv6Page = new System.Windows.Forms.TabPage();
            this.IPv6Input = new Syslog.Console.Controls.ConfigCreator.IPv6InputControl();
            this.ListenerPage = new System.Windows.Forms.TabPage();
            this.ListenerInput = new Syslog.Console.Controls.ConfigCreator.ListenerInputControl();
            this.ListenerModulePage = new System.Windows.Forms.TabPage();
            this.ListenerModuleInput = new Syslog.Console.Controls.ConfigCreator.ListenerModuleInputControl();
            this.UDPListenerPage = new System.Windows.Forms.TabPage();
            this.UdpListenerInput = new Syslog.Console.Controls.ConfigCreator.UdpListenerInputControl();
            this.SimpleEventLogListenerPage = new System.Windows.Forms.TabPage();
            this.EventLogListenerInput = new Syslog.Console.Controls.ConfigCreator.EventLogListenerInputControl();
            this.ListenerFilterPage = new System.Windows.Forms.TabPage();
            this.ListenerFilterInput = new Syslog.Console.Controls.ConfigCreator.ListenerFilterInputControl();
            this.EncodingSelectorPage = new System.Windows.Forms.TabPage();
            this.EncodingSelectorInput = new Syslog.Console.Controls.ConfigCreator.EncodingSelectorInputControl();
            this.RelayPage = new System.Windows.Forms.TabPage();
            this.RelayInput = new Syslog.Console.Controls.ConfigCreator.RelayInputControl();
            this.RelayPluginPage = new System.Windows.Forms.TabPage();
            this.RelayPluginInput = new Syslog.Console.Controls.ConfigCreator.RelayPluginInputControl();
            this.DefaultCollectorPluginPage = new System.Windows.Forms.TabPage();
            this.DefaultCollectorPluginInput = new Syslog.Console.Controls.ConfigCreator.DefaultCollectorPluginInputControl();
            this.RelayFilterPage = new System.Windows.Forms.TabPage();
            this.RelayFilterInput = new Syslog.Console.Controls.ConfigCreator.RelayFilterInputControl();
            this.SourceAddressFilterPage = new System.Windows.Forms.TabPage();
            this.SourceAddressRelayFilterInput = new Syslog.Console.Controls.ConfigCreator.SourceAddressRelayFilterInputControl();
            this.PriorityFilterPage = new System.Windows.Forms.TabPage();
            this.PriorityFilterInput = new Syslog.Console.Controls.ConfigCreator.PriorityFilterInputControl();
            this.CollectorPage = new System.Windows.Forms.TabPage();
            this.CollectorInput = new Syslog.Console.Controls.ConfigCreator.CollectorInputControl();
            this.SimpleFileWriterPage = new System.Windows.Forms.TabPage();
            this.FileWriterInput = new Syslog.Console.Controls.ConfigCreator.FileWriterInputControl();
            this.SimpleEventLogWriterPage = new System.Windows.Forms.TabPage();
            this.EventLogWriterInput = new Syslog.Console.Controls.ConfigCreator.EventLogWriterInputControl();
            this.SimpleDbWriterPage = new System.Windows.Forms.TabPage();
            this.DbWriterInput = new Syslog.Console.Controls.ConfigCreator.DbWriterInputControl();
            this.SimpleSyslogForwarderPage = new System.Windows.Forms.TabPage();
            this.SyslogForwarderInput = new Syslog.Console.Controls.ConfigCreator.SyslogForwarderInputControl();
            this.ConfigBuildPanel = new System.Windows.Forms.Panel();
            this.ConfigPreviewButton = new System.Windows.Forms.Button();
            this.ConfigSaveButton = new System.Windows.Forms.Button();
            this.ConfigSplitter = new System.Windows.Forms.Splitter();
            this.ConfigSectionTree = new System.Windows.Forms.TreeView();
            this.ConfigSaveDialog = new System.Windows.Forms.SaveFileDialog();
            this.ConfigDesignerGroup.SuspendLayout();
            this.ConfigCreatorTab.SuspendLayout();
            this.GlobalSettingsPage.SuspendLayout();
            this.TracePage.SuspendLayout();
            this.IPv6Page.SuspendLayout();
            this.ListenerPage.SuspendLayout();
            this.ListenerModulePage.SuspendLayout();
            this.UDPListenerPage.SuspendLayout();
            this.SimpleEventLogListenerPage.SuspendLayout();
            this.ListenerFilterPage.SuspendLayout();
            this.EncodingSelectorPage.SuspendLayout();
            this.RelayPage.SuspendLayout();
            this.RelayPluginPage.SuspendLayout();
            this.DefaultCollectorPluginPage.SuspendLayout();
            this.RelayFilterPage.SuspendLayout();
            this.SourceAddressFilterPage.SuspendLayout();
            this.PriorityFilterPage.SuspendLayout();
            this.CollectorPage.SuspendLayout();
            this.SimpleFileWriterPage.SuspendLayout();
            this.SimpleEventLogWriterPage.SuspendLayout();
            this.SimpleDbWriterPage.SuspendLayout();
            this.SimpleSyslogForwarderPage.SuspendLayout();
            this.ConfigBuildPanel.SuspendLayout();
            this.SuspendLayout();
            // 
            // ConfigDesignerGroup
            // 
            this.ConfigDesignerGroup.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.ConfigDesignerGroup.Controls.Add(this.ConfigCreatorTab);
            this.ConfigDesignerGroup.Controls.Add(this.ConfigBuildPanel);
            this.ConfigDesignerGroup.Controls.Add(this.ConfigSplitter);
            this.ConfigDesignerGroup.Controls.Add(this.ConfigSectionTree);
            this.ConfigDesignerGroup.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.ConfigDesignerGroup.Location = new System.Drawing.Point(8, 8);
            this.ConfigDesignerGroup.Name = "ConfigDesignerGroup";
            this.ConfigDesignerGroup.Size = new System.Drawing.Size(584, 366);
            this.ConfigDesignerGroup.TabIndex = 0;
            this.ConfigDesignerGroup.TabStop = false;
            this.ConfigDesignerGroup.Text = "Config Designer";
            // 
            // ConfigCreatorTab
            // 
            this.ConfigCreatorTab.Appearance = System.Windows.Forms.TabAppearance.FlatButtons;
            this.ConfigCreatorTab.Controls.Add(this.GlobalSettingsPage);
            this.ConfigCreatorTab.Controls.Add(this.TracePage);
            this.ConfigCreatorTab.Controls.Add(this.IPv6Page);
            this.ConfigCreatorTab.Controls.Add(this.ListenerPage);
            this.ConfigCreatorTab.Controls.Add(this.ListenerModulePage);
            this.ConfigCreatorTab.Controls.Add(this.UDPListenerPage);
            this.ConfigCreatorTab.Controls.Add(this.SimpleEventLogListenerPage);
            this.ConfigCreatorTab.Controls.Add(this.ListenerFilterPage);
            this.ConfigCreatorTab.Controls.Add(this.EncodingSelectorPage);
            this.ConfigCreatorTab.Controls.Add(this.RelayPage);
            this.ConfigCreatorTab.Controls.Add(this.RelayPluginPage);
            this.ConfigCreatorTab.Controls.Add(this.DefaultCollectorPluginPage);
            this.ConfigCreatorTab.Controls.Add(this.RelayFilterPage);
            this.ConfigCreatorTab.Controls.Add(this.SourceAddressFilterPage);
            this.ConfigCreatorTab.Controls.Add(this.PriorityFilterPage);
            this.ConfigCreatorTab.Controls.Add(this.CollectorPage);
            this.ConfigCreatorTab.Controls.Add(this.SimpleFileWriterPage);
            this.ConfigCreatorTab.Controls.Add(this.SimpleEventLogWriterPage);
            this.ConfigCreatorTab.Controls.Add(this.SimpleDbWriterPage);
            this.ConfigCreatorTab.Controls.Add(this.SimpleSyslogForwarderPage);
            this.ConfigCreatorTab.Dock = System.Windows.Forms.DockStyle.Fill;
            this.ConfigCreatorTab.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.ConfigCreatorTab.ItemSize = new System.Drawing.Size(0, 22);
            this.ConfigCreatorTab.Location = new System.Drawing.Point(188, 18);
            this.ConfigCreatorTab.Name = "ConfigCreatorTab";
            this.ConfigCreatorTab.SelectedIndex = 0;
            this.ConfigCreatorTab.Size = new System.Drawing.Size(393, 297);
            this.ConfigCreatorTab.TabIndex = 1;
            this.ConfigCreatorTab.SelectedIndexChanged += new System.EventHandler(this.ConfigCreatorTab_SelectedIndexChanged);
            // 
            // GlobalSettingsPage
            // 
            this.GlobalSettingsPage.AutoScroll = true;
            this.GlobalSettingsPage.Controls.Add(this.GlobalSettingsInput);
            this.GlobalSettingsPage.Location = new System.Drawing.Point(4, 26);
            this.GlobalSettingsPage.Name = "GlobalSettingsPage";
            this.GlobalSettingsPage.Size = new System.Drawing.Size(385, 267);
            this.GlobalSettingsPage.TabIndex = 0;
            this.GlobalSettingsPage.Text = "Global Settings";
            // 
            // GlobalSettingsInput
            // 
            this.GlobalSettingsInput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.GlobalSettingsInput.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.GlobalSettingsInput.Location = new System.Drawing.Point(0, 0);
            this.GlobalSettingsInput.Name = "GlobalSettingsInput";
            this.GlobalSettingsInput.Size = new System.Drawing.Size(385, 267);
            this.GlobalSettingsInput.TabIndex = 0;
            // 
            // TracePage
            // 
            this.TracePage.Controls.Add(this.TraceInput);
            this.TracePage.Location = new System.Drawing.Point(4, 26);
            this.TracePage.Name = "TracePage";
            this.TracePage.Size = new System.Drawing.Size(385, 267);
            this.TracePage.TabIndex = 1;
            this.TracePage.Text = "Trace";
            this.TracePage.Visible = false;
            // 
            // TraceInput
            // 
            this.TraceInput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.TraceInput.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.TraceInput.Location = new System.Drawing.Point(0, 0);
            this.TraceInput.Name = "TraceInput";
            this.TraceInput.Size = new System.Drawing.Size(385, 267);
            this.TraceInput.TabIndex = 0;
            // 
            // IPv6Page
            // 
            this.IPv6Page.Controls.Add(this.IPv6Input);
            this.IPv6Page.Location = new System.Drawing.Point(4, 26);
            this.IPv6Page.Name = "IPv6Page";
            this.IPv6Page.Size = new System.Drawing.Size(385, 267);
            this.IPv6Page.TabIndex = 2;
            this.IPv6Page.Text = "IPv6";
            this.IPv6Page.Visible = false;
            // 
            // IPv6Input
            // 
            this.IPv6Input.Dock = System.Windows.Forms.DockStyle.Fill;
            this.IPv6Input.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.IPv6Input.Location = new System.Drawing.Point(0, 0);
            this.IPv6Input.Name = "IPv6Input";
            this.IPv6Input.Size = new System.Drawing.Size(385, 267);
            this.IPv6Input.TabIndex = 0;
            // 
            // ListenerPage
            // 
            this.ListenerPage.Controls.Add(this.ListenerInput);
            this.ListenerPage.Location = new System.Drawing.Point(4, 26);
            this.ListenerPage.Name = "ListenerPage";
            this.ListenerPage.Size = new System.Drawing.Size(385, 267);
            this.ListenerPage.TabIndex = 3;
            this.ListenerPage.Text = "Syslog Listener";
            this.ListenerPage.Visible = false;
            // 
            // ListenerInput
            // 
            this.ListenerInput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.ListenerInput.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.ListenerInput.Location = new System.Drawing.Point(0, 0);
            this.ListenerInput.Name = "ListenerInput";
            this.ListenerInput.Size = new System.Drawing.Size(385, 267);
            this.ListenerInput.TabIndex = 0;
            // 
            // ListenerModulePage
            // 
            this.ListenerModulePage.Controls.Add(this.ListenerModuleInput);
            this.ListenerModulePage.Location = new System.Drawing.Point(4, 26);
            this.ListenerModulePage.Name = "ListenerModulePage";
            this.ListenerModulePage.Size = new System.Drawing.Size(385, 267);
            this.ListenerModulePage.TabIndex = 4;
            this.ListenerModulePage.Text = "Listener Modules";
            this.ListenerModulePage.Visible = false;
            // 
            // ListenerModuleInput
            // 
            this.ListenerModuleInput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.ListenerModuleInput.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.ListenerModuleInput.Location = new System.Drawing.Point(0, 0);
            this.ListenerModuleInput.Name = "ListenerModuleInput";
            this.ListenerModuleInput.Size = new System.Drawing.Size(385, 267);
            this.ListenerModuleInput.TabIndex = 0;
            // 
            // UDPListenerPage
            // 
            this.UDPListenerPage.Controls.Add(this.UdpListenerInput);
            this.UDPListenerPage.Location = new System.Drawing.Point(4, 26);
            this.UDPListenerPage.Name = "UDPListenerPage";
            this.UDPListenerPage.Size = new System.Drawing.Size(385, 267);
            this.UDPListenerPage.TabIndex = 5;
            this.UDPListenerPage.Text = "UDP Listener";
            this.UDPListenerPage.Visible = false;
            // 
            // UdpListenerInput
            // 
            this.UdpListenerInput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.UdpListenerInput.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.UdpListenerInput.Location = new System.Drawing.Point(0, 0);
            this.UdpListenerInput.Name = "UdpListenerInput";
            this.UdpListenerInput.Size = new System.Drawing.Size(385, 267);
            this.UdpListenerInput.TabIndex = 0;
            // 
            // SimpleEventLogListenerPage
            // 
            this.SimpleEventLogListenerPage.Controls.Add(this.EventLogListenerInput);
            this.SimpleEventLogListenerPage.Location = new System.Drawing.Point(4, 26);
            this.SimpleEventLogListenerPage.Name = "SimpleEventLogListenerPage";
            this.SimpleEventLogListenerPage.Size = new System.Drawing.Size(385, 267);
            this.SimpleEventLogListenerPage.TabIndex = 20;
            this.SimpleEventLogListenerPage.Text = "Simple EventLog Listener";
            // 
            // EventLogListenerInput
            // 
            this.EventLogListenerInput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.EventLogListenerInput.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.EventLogListenerInput.Location = new System.Drawing.Point(0, 0);
            this.EventLogListenerInput.Name = "EventLogListenerInput";
            this.EventLogListenerInput.Size = new System.Drawing.Size(385, 267);
            this.EventLogListenerInput.TabIndex = 1;
            // 
            // ListenerFilterPage
            // 
            this.ListenerFilterPage.Controls.Add(this.ListenerFilterInput);
            this.ListenerFilterPage.Location = new System.Drawing.Point(4, 26);
            this.ListenerFilterPage.Name = "ListenerFilterPage";
            this.ListenerFilterPage.Size = new System.Drawing.Size(385, 267);
            this.ListenerFilterPage.TabIndex = 7;
            this.ListenerFilterPage.Text = "Listener Filters";
            this.ListenerFilterPage.Visible = false;
            // 
            // ListenerFilterInput
            // 
            this.ListenerFilterInput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.ListenerFilterInput.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.ListenerFilterInput.Location = new System.Drawing.Point(0, 0);
            this.ListenerFilterInput.Name = "ListenerFilterInput";
            this.ListenerFilterInput.Size = new System.Drawing.Size(385, 267);
            this.ListenerFilterInput.TabIndex = 0;
            // 
            // EncodingSelectorPage
            // 
            this.EncodingSelectorPage.Controls.Add(this.EncodingSelectorInput);
            this.EncodingSelectorPage.Location = new System.Drawing.Point(4, 26);
            this.EncodingSelectorPage.Name = "EncodingSelectorPage";
            this.EncodingSelectorPage.Size = new System.Drawing.Size(385, 267);
            this.EncodingSelectorPage.TabIndex = 8;
            this.EncodingSelectorPage.Text = "Encoding Selector";
            this.EncodingSelectorPage.Visible = false;
            // 
            // EncodingSelectorInput
            // 
            this.EncodingSelectorInput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.EncodingSelectorInput.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.EncodingSelectorInput.Location = new System.Drawing.Point(0, 0);
            this.EncodingSelectorInput.Name = "EncodingSelectorInput";
            this.EncodingSelectorInput.Size = new System.Drawing.Size(385, 267);
            this.EncodingSelectorInput.TabIndex = 0;
            // 
            // RelayPage
            // 
            this.RelayPage.Controls.Add(this.RelayInput);
            this.RelayPage.Location = new System.Drawing.Point(4, 26);
            this.RelayPage.Name = "RelayPage";
            this.RelayPage.Size = new System.Drawing.Size(385, 267);
            this.RelayPage.TabIndex = 9;
            this.RelayPage.Text = "Syslog Relay";
            this.RelayPage.Visible = false;
            // 
            // RelayInput
            // 
            this.RelayInput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.RelayInput.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.RelayInput.Location = new System.Drawing.Point(0, 0);
            this.RelayInput.Name = "RelayInput";
            this.RelayInput.Size = new System.Drawing.Size(385, 267);
            this.RelayInput.TabIndex = 0;
            // 
            // RelayPluginPage
            // 
            this.RelayPluginPage.Controls.Add(this.RelayPluginInput);
            this.RelayPluginPage.Location = new System.Drawing.Point(4, 26);
            this.RelayPluginPage.Name = "RelayPluginPage";
            this.RelayPluginPage.Size = new System.Drawing.Size(385, 267);
            this.RelayPluginPage.TabIndex = 10;
            this.RelayPluginPage.Text = "Relay Plugins";
            this.RelayPluginPage.Visible = false;
            // 
            // RelayPluginInput
            // 
            this.RelayPluginInput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.RelayPluginInput.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.RelayPluginInput.Location = new System.Drawing.Point(0, 0);
            this.RelayPluginInput.Name = "RelayPluginInput";
            this.RelayPluginInput.Size = new System.Drawing.Size(385, 267);
            this.RelayPluginInput.TabIndex = 0;
            // 
            // DefaultCollectorPluginPage
            // 
            this.DefaultCollectorPluginPage.Controls.Add(this.DefaultCollectorPluginInput);
            this.DefaultCollectorPluginPage.Location = new System.Drawing.Point(4, 26);
            this.DefaultCollectorPluginPage.Name = "DefaultCollectorPluginPage";
            this.DefaultCollectorPluginPage.Size = new System.Drawing.Size(385, 267);
            this.DefaultCollectorPluginPage.TabIndex = 11;
            this.DefaultCollectorPluginPage.Text = "Default Collector Plugin";
            this.DefaultCollectorPluginPage.Visible = false;
            // 
            // DefaultCollectorPluginInput
            // 
            this.DefaultCollectorPluginInput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.DefaultCollectorPluginInput.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.DefaultCollectorPluginInput.Location = new System.Drawing.Point(0, 0);
            this.DefaultCollectorPluginInput.Name = "DefaultCollectorPluginInput";
            this.DefaultCollectorPluginInput.Size = new System.Drawing.Size(385, 267);
            this.DefaultCollectorPluginInput.TabIndex = 0;
            // 
            // RelayFilterPage
            // 
            this.RelayFilterPage.Controls.Add(this.RelayFilterInput);
            this.RelayFilterPage.Location = new System.Drawing.Point(4, 26);
            this.RelayFilterPage.Name = "RelayFilterPage";
            this.RelayFilterPage.Size = new System.Drawing.Size(385, 267);
            this.RelayFilterPage.TabIndex = 12;
            this.RelayFilterPage.Text = "Relay Filters";
            this.RelayFilterPage.Visible = false;
            // 
            // RelayFilterInput
            // 
            this.RelayFilterInput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.RelayFilterInput.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.RelayFilterInput.Location = new System.Drawing.Point(0, 0);
            this.RelayFilterInput.Name = "RelayFilterInput";
            this.RelayFilterInput.Size = new System.Drawing.Size(385, 267);
            this.RelayFilterInput.TabIndex = 1;
            // 
            // SourceAddressFilterPage
            // 
            this.SourceAddressFilterPage.Controls.Add(this.SourceAddressRelayFilterInput);
            this.SourceAddressFilterPage.Location = new System.Drawing.Point(4, 26);
            this.SourceAddressFilterPage.Name = "SourceAddressFilterPage";
            this.SourceAddressFilterPage.Size = new System.Drawing.Size(385, 267);
            this.SourceAddressFilterPage.TabIndex = 13;
            this.SourceAddressFilterPage.Text = "Source Address Filter";
            this.SourceAddressFilterPage.Visible = false;
            // 
            // SourceAddressRelayFilterInput
            // 
            this.SourceAddressRelayFilterInput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.SourceAddressRelayFilterInput.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.SourceAddressRelayFilterInput.Location = new System.Drawing.Point(0, 0);
            this.SourceAddressRelayFilterInput.Name = "SourceAddressRelayFilterInput";
            this.SourceAddressRelayFilterInput.Size = new System.Drawing.Size(385, 267);
            this.SourceAddressRelayFilterInput.TabIndex = 0;
            // 
            // PriorityFilterPage
            // 
            this.PriorityFilterPage.Controls.Add(this.PriorityFilterInput);
            this.PriorityFilterPage.Location = new System.Drawing.Point(4, 26);
            this.PriorityFilterPage.Name = "PriorityFilterPage";
            this.PriorityFilterPage.Size = new System.Drawing.Size(385, 267);
            this.PriorityFilterPage.TabIndex = 14;
            this.PriorityFilterPage.Text = "Priority Filter";
            this.PriorityFilterPage.Visible = false;
            // 
            // PriorityFilterInput
            // 
            this.PriorityFilterInput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.PriorityFilterInput.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.PriorityFilterInput.Location = new System.Drawing.Point(0, 0);
            this.PriorityFilterInput.Name = "PriorityFilterInput";
            this.PriorityFilterInput.Size = new System.Drawing.Size(385, 267);
            this.PriorityFilterInput.TabIndex = 0;
            // 
            // CollectorPage
            // 
            this.CollectorPage.Controls.Add(this.CollectorInput);
            this.CollectorPage.Location = new System.Drawing.Point(4, 26);
            this.CollectorPage.Name = "CollectorPage";
            this.CollectorPage.Size = new System.Drawing.Size(385, 267);
            this.CollectorPage.TabIndex = 15;
            this.CollectorPage.Text = "Syslog Collector";
            this.CollectorPage.Visible = false;
            // 
            // CollectorInput
            // 
            this.CollectorInput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.CollectorInput.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.CollectorInput.Location = new System.Drawing.Point(0, 0);
            this.CollectorInput.Name = "CollectorInput";
            this.CollectorInput.Size = new System.Drawing.Size(385, 267);
            this.CollectorInput.TabIndex = 0;
            // 
            // SimpleFileWriterPage
            // 
            this.SimpleFileWriterPage.Controls.Add(this.FileWriterInput);
            this.SimpleFileWriterPage.Location = new System.Drawing.Point(4, 26);
            this.SimpleFileWriterPage.Name = "SimpleFileWriterPage";
            this.SimpleFileWriterPage.Size = new System.Drawing.Size(385, 267);
            this.SimpleFileWriterPage.TabIndex = 16;
            this.SimpleFileWriterPage.Text = "Simple File Writer";
            this.SimpleFileWriterPage.Visible = false;
            // 
            // FileWriterInput
            // 
            this.FileWriterInput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.FileWriterInput.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.FileWriterInput.Location = new System.Drawing.Point(0, 0);
            this.FileWriterInput.Name = "FileWriterInput";
            this.FileWriterInput.Size = new System.Drawing.Size(385, 267);
            this.FileWriterInput.TabIndex = 0;
            // 
            // SimpleEventLogWriterPage
            // 
            this.SimpleEventLogWriterPage.Controls.Add(this.EventLogWriterInput);
            this.SimpleEventLogWriterPage.Location = new System.Drawing.Point(4, 26);
            this.SimpleEventLogWriterPage.Name = "SimpleEventLogWriterPage";
            this.SimpleEventLogWriterPage.Size = new System.Drawing.Size(385, 267);
            this.SimpleEventLogWriterPage.TabIndex = 17;
            this.SimpleEventLogWriterPage.Text = "Simple EventLog Writer";
            this.SimpleEventLogWriterPage.Visible = false;
            // 
            // EventLogWriterInput
            // 
            this.EventLogWriterInput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.EventLogWriterInput.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.EventLogWriterInput.Location = new System.Drawing.Point(0, 0);
            this.EventLogWriterInput.Name = "EventLogWriterInput";
            this.EventLogWriterInput.Size = new System.Drawing.Size(385, 267);
            this.EventLogWriterInput.TabIndex = 0;
            // 
            // SimpleDbWriterPage
            // 
            this.SimpleDbWriterPage.Controls.Add(this.DbWriterInput);
            this.SimpleDbWriterPage.Location = new System.Drawing.Point(4, 26);
            this.SimpleDbWriterPage.Name = "SimpleDbWriterPage";
            this.SimpleDbWriterPage.Size = new System.Drawing.Size(385, 267);
            this.SimpleDbWriterPage.TabIndex = 18;
            this.SimpleDbWriterPage.Text = "Simple DB Writer";
            this.SimpleDbWriterPage.Visible = false;
            // 
            // DbWriterInput
            // 
            this.DbWriterInput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.DbWriterInput.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.DbWriterInput.Location = new System.Drawing.Point(0, 0);
            this.DbWriterInput.Name = "DbWriterInput";
            this.DbWriterInput.Size = new System.Drawing.Size(385, 267);
            this.DbWriterInput.TabIndex = 0;
            // 
            // SimpleSyslogForwarderPage
            // 
            this.SimpleSyslogForwarderPage.Controls.Add(this.SyslogForwarderInput);
            this.SimpleSyslogForwarderPage.Location = new System.Drawing.Point(4, 26);
            this.SimpleSyslogForwarderPage.Name = "SimpleSyslogForwarderPage";
            this.SimpleSyslogForwarderPage.Size = new System.Drawing.Size(385, 267);
            this.SimpleSyslogForwarderPage.TabIndex = 19;
            this.SimpleSyslogForwarderPage.Text = "Simple Syslog Forwarder";
            this.SimpleSyslogForwarderPage.Visible = false;
            // 
            // SyslogForwarderInput
            // 
            this.SyslogForwarderInput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.SyslogForwarderInput.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.SyslogForwarderInput.Location = new System.Drawing.Point(0, 0);
            this.SyslogForwarderInput.Name = "SyslogForwarderInput";
            this.SyslogForwarderInput.Size = new System.Drawing.Size(385, 267);
            this.SyslogForwarderInput.TabIndex = 0;
            // 
            // ConfigBuildPanel
            // 
            this.ConfigBuildPanel.Controls.Add(this.ConfigPreviewButton);
            this.ConfigBuildPanel.Controls.Add(this.ConfigSaveButton);
            this.ConfigBuildPanel.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.ConfigBuildPanel.Location = new System.Drawing.Point(188, 315);
            this.ConfigBuildPanel.Name = "ConfigBuildPanel";
            this.ConfigBuildPanel.Size = new System.Drawing.Size(393, 48);
            this.ConfigBuildPanel.TabIndex = 2;
            // 
            // ConfigPreviewButton
            // 
            this.ConfigPreviewButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.ConfigPreviewButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.ConfigPreviewButton.Location = new System.Drawing.Point(161, 8);
            this.ConfigPreviewButton.Name = "ConfigPreviewButton";
            this.ConfigPreviewButton.Size = new System.Drawing.Size(104, 32);
            this.ConfigPreviewButton.TabIndex = 0;
            this.ConfigPreviewButton.Text = "vr[(&V)";
            this.ConfigPreviewButton.Click += new System.EventHandler(this.ConfigPreviewButton_Click);
            // 
            // ConfigSaveButton
            // 
            this.ConfigSaveButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.ConfigSaveButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.ConfigSaveButton.Location = new System.Drawing.Point(281, 8);
            this.ConfigSaveButton.Name = "ConfigSaveButton";
            this.ConfigSaveButton.Size = new System.Drawing.Size(104, 32);
            this.ConfigSaveButton.TabIndex = 1;
            this.ConfigSaveButton.Text = "ۑ(&S)";
            this.ConfigSaveButton.Click += new System.EventHandler(this.ConfigSaveButton_Click);
            // 
            // ConfigSplitter
            // 
            this.ConfigSplitter.Location = new System.Drawing.Point(184, 18);
            this.ConfigSplitter.Name = "ConfigSplitter";
            this.ConfigSplitter.Size = new System.Drawing.Size(4, 345);
            this.ConfigSplitter.TabIndex = 4;
            this.ConfigSplitter.TabStop = false;
            // 
            // ConfigSectionTree
            // 
            this.ConfigSectionTree.Dock = System.Windows.Forms.DockStyle.Left;
            this.ConfigSectionTree.HideSelection = false;
            this.ConfigSectionTree.HotTracking = true;
            this.ConfigSectionTree.ImageIndex = -1;
            this.ConfigSectionTree.Location = new System.Drawing.Point(3, 18);
            this.ConfigSectionTree.Name = "ConfigSectionTree";
            this.ConfigSectionTree.Nodes.AddRange(new System.Windows.Forms.TreeNode[] {
                                                                                          new System.Windows.Forms.TreeNode("Global Settings", new System.Windows.Forms.TreeNode[] {
                                                                                                                                                                                       new System.Windows.Forms.TreeNode("Trace"),
                                                                                                                                                                                       new System.Windows.Forms.TreeNode("IPv6")}),
                                                                                          new System.Windows.Forms.TreeNode("Syslog Listener", new System.Windows.Forms.TreeNode[] {
                                                                                                                                                                                       new System.Windows.Forms.TreeNode("Listener Modules", new System.Windows.Forms.TreeNode[] {
                                                                                                                                                                                                                                                                                     new System.Windows.Forms.TreeNode("UDP Listener"),
                                                                                                                                                                                                                                                                                     new System.Windows.Forms.TreeNode("Simple EventLog Listener")}),
                                                                                                                                                                                       new System.Windows.Forms.TreeNode("Listener Filters", new System.Windows.Forms.TreeNode[] {
                                                                                                                                                                                                                                                                                     new System.Windows.Forms.TreeNode("Encoding Selector")})}),
                                                                                          new System.Windows.Forms.TreeNode("Syslog Relay", new System.Windows.Forms.TreeNode[] {
                                                                                                                                                                                    new System.Windows.Forms.TreeNode("Relay Plugins", new System.Windows.Forms.TreeNode[] {
                                                                                                                                                                                                                                                                               new System.Windows.Forms.TreeNode("Default Collector Plugin")}),
                                                                                                                                                                                    new System.Windows.Forms.TreeNode("Relay Filters", new System.Windows.Forms.TreeNode[] {
                                                                                                                                                                                                                                                                               new System.Windows.Forms.TreeNode("Source Address Filter"),
                                                                                                                                                                                                                                                                               new System.Windows.Forms.TreeNode("Priority Filter")})}),
                                                                                          new System.Windows.Forms.TreeNode("Syslog Collector", new System.Windows.Forms.TreeNode[] {
                                                                                                                                                                                        new System.Windows.Forms.TreeNode("Simple File Writer"),
                                                                                                                                                                                        new System.Windows.Forms.TreeNode("Simple EventLog Writer"),
                                                                                                                                                                                        new System.Windows.Forms.TreeNode("Simple DB Writer"),
                                                                                                                                                                                        new System.Windows.Forms.TreeNode("Simple Syslog Forwarder")})});
            this.ConfigSectionTree.SelectedImageIndex = -1;
            this.ConfigSectionTree.ShowPlusMinus = false;
            this.ConfigSectionTree.ShowRootLines = false;
            this.ConfigSectionTree.Size = new System.Drawing.Size(181, 345);
            this.ConfigSectionTree.TabIndex = 0;
            this.ConfigSectionTree.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.ConfigSectionTree_AfterSelect);
            // 
            // ConfigSaveDialog
            // 
            this.ConfigSaveDialog.DefaultExt = "config";
            this.ConfigSaveDialog.FileName = "mlog_coll.exe.config";
            this.ConfigSaveDialog.Filter = "\t@C (UTF-8)|*.config|\t@C (UTF-16)|*.config|\t@C (ANSI)|*.config|ׂẴt@C " +
                "(*.*)|*.*";
            // 
            // ConfigCreateControl
            // 
            this.Controls.Add(this.ConfigDesignerGroup);
            this.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.Name = "ConfigCreateControl";
            this.Size = new System.Drawing.Size(600, 380);
            this.Load += new System.EventHandler(this.ConfigCreateControl_Load);
            this.ConfigDesignerGroup.ResumeLayout(false);
            this.ConfigCreatorTab.ResumeLayout(false);
            this.GlobalSettingsPage.ResumeLayout(false);
            this.TracePage.ResumeLayout(false);
            this.IPv6Page.ResumeLayout(false);
            this.ListenerPage.ResumeLayout(false);
            this.ListenerModulePage.ResumeLayout(false);
            this.UDPListenerPage.ResumeLayout(false);
            this.SimpleEventLogListenerPage.ResumeLayout(false);
            this.ListenerFilterPage.ResumeLayout(false);
            this.EncodingSelectorPage.ResumeLayout(false);
            this.RelayPage.ResumeLayout(false);
            this.RelayPluginPage.ResumeLayout(false);
            this.DefaultCollectorPluginPage.ResumeLayout(false);
            this.RelayFilterPage.ResumeLayout(false);
            this.SourceAddressFilterPage.ResumeLayout(false);
            this.PriorityFilterPage.ResumeLayout(false);
            this.CollectorPage.ResumeLayout(false);
            this.SimpleFileWriterPage.ResumeLayout(false);
            this.SimpleEventLogWriterPage.ResumeLayout(false);
            this.SimpleDbWriterPage.ResumeLayout(false);
            this.SimpleSyslogForwarderPage.ResumeLayout(false);
            this.ConfigBuildPanel.ResumeLayout(false);
            this.ResumeLayout(false);

        }
		#endregion

        private void ConfigCreateControl_Load(object sender, System.EventArgs e)
        {
            const string AppConfigFileName = "mlog_ctl.exe.config";

            ConfigSectionTree.ExpandAll();
            ConfigSectionTree.SelectedNode = ConfigSectionTree.TopNode;

            ConfigSaveDialog.FileName = Path.Combine(Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location), AppConfigFileName);
        }

        private void ConfigSectionTree_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
        {
            ConfigCreatorTab.SelectedTab = this.TabPageOf(e.Node);

            ConfigSectionTree.Focus();
        }

        private void ConfigCreatorTab_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            ConfigSectionTree.SelectedNode = this.NodeOf(ConfigCreatorTab.SelectedTab);

            ConfigCreatorTab.Focus();
        }

        private void ConfigPreviewButton_Click(object sender, System.EventArgs e)
        {
            ConfigViewer viewer = new ConfigViewer();
            viewer.PreviewTextBox.Text = this.BuildConfiguration();;
            viewer.PreviewTextBox.SelectAll();
            viewer.ShowDialog();
        }

        private void ConfigSaveButton_Click(object sender, System.EventArgs e)
        {
            const int EncodingUTF8Index = 1;
            const int EncodingUTF16Index = 2;
            const int EncodingANSIIndex = 3;

            if (DialogResult.OK == ConfigSaveDialog.ShowDialog())
            {
                Encoding encoding = Encoding.UTF8;

                switch (ConfigSaveDialog.FilterIndex)
                {
                    case EncodingUTF8Index:
                    {
                        encoding = Encoding.UTF8;

                        break;
                    }
                    case EncodingUTF16Index:
                    {
                        encoding = Encoding.Unicode;

                        break;
                    }
                    case EncodingANSIIndex:
                    {
                        encoding = Encoding.Default;

                        break;
                    }
                }

                XmlDocument doc = new XmlDocument();
                doc.LoadXml(this.BuildConfiguration());

                XmlTextWriter writer = new XmlTextWriter(ConfigSaveDialog.FileName, encoding);
                writer.Formatting = Formatting.Indented;

                doc.Save(writer);
                writer.Close();
            }
        }

        /// <summary>
        /// c[m[hƃ}b`^uy[WԂ܂
        /// </summary>
        /// <param name="node"></param>
        /// <returns></returns>
        private TabPage TabPageOf(TreeNode node)
        {
            foreach (TabPage tab in ConfigCreatorTab.TabPages)
            {
                if (tab.Text == node.Text)
                {
                    return tab;
                }
            }

            return null;
        }

        /// <summary>
        /// ^uy[Wƃ}b`c[m[hԂ܂
        /// </summary>
        /// <param name="tab"></param>
        /// <returns></returns>
        private TreeNode NodeOf(TabPage tab)
        {
            return this.NodeOf(tab, ConfigSectionTree.Nodes);
        }

        /// <summary>
        /// w肳ꂽc[m[h̃Tuc[^uy[Wƃ}b`c[m[hԂ܂
        /// </summary>
        /// <param name="tab"></param>
        /// <param name="startNode"></param>
        /// <returns></returns>
        private TreeNode NodeOf(TabPage tab, TreeNodeCollection startNode)
        {
            foreach (TreeNode node in startNode)
            {
                if (node.Text == tab.Text)
                {
                    return node;
                }
                else if (node.Nodes.Count > 0)
                {
                    TreeNode childNode = this.NodeOf(tab, node.Nodes);

                    if (childNode != null)
                    {
                        return childNode;
                    }
                }
            }

            return null;
        }

        private string BuildConfiguration()
        {
            const string ConfigRootElement = "configuration";
            const string ConfigSectionElement = "configSections";
            const string ConfigSettingElement = "syslogConfig";
            const string MovingSystemSettingNode = "settings/" + ConfigRootElement;

            #region ConfigSection Element
            const string ConfigSectionValue = @"
                <sectionGroup name=""syslogConfig"">
                    <sectionGroup name=""settings"">
                        <section name=""defaultEncoding"" type=""System.Configuration.SingleTagSectionHandler"" />
                        <section name=""errorPacket"" type=""System.Configuration.SingleTagSectionHandler"" />
                    </sectionGroup>
                    <sectionGroup name=""listener"">
                        <section name=""modules"" type=""Syslog.Config.SectionHandler.AssemblySectionHandler,mlog_lib"" />
                        <section name=""filters"" type=""Syslog.Config.SectionHandler.AssemblySectionHandler,mlog_lib"" />
                    </sectionGroup>
                    <sectionGroup name=""relay"">
                        <section name=""plugin"" type=""Syslog.Config.SectionHandler.AssemblySectionHandler,mlog_lib"" />
                        <section name=""filters"" type=""Syslog.Config.SectionHandler.AssemblySectionHandler,mlog_lib"" />
                    </sectionGroup>
                    <sectionGroup name=""collector"">
                        <section name=""modules"" type=""Syslog.Config.SectionHandler.AssemblySectionHandler,mlog_lib"" />
                    </sectionGroup>
                </sectionGroup>";
            #endregion

            StringBuilder sb = new StringBuilder(20480);

            foreach (TreeNode child in ConfigSectionTree.Nodes)
            {
                sb.Append(this.BuildConfiguration(child));
                sb.Append(Environment.NewLine);
            }

            StringBuilder IndentedConfig = new StringBuilder(51200);

            using (StringWriter ConfigWriter = new StringWriter(IndentedConfig))
            {
                XmlTextWriter writer = new XmlTextWriter(ConfigWriter);
                writer.Formatting = Formatting.Indented;

                XmlDocument doc = new XmlDocument();

                XmlElement element = doc.CreateElement(ConfigRootElement);
                XmlElement section = doc.CreateElement(ConfigSectionElement);
                XmlElement setting = doc.CreateElement(ConfigSettingElement);
                section.InnerXml = ConfigSectionValue;
                setting.InnerXml = sb.ToString();

                element.AppendChild(section);
                element.AppendChild(setting);

                // .Net Framework ݒm[hړ
                XmlNode SystemSettingNode = setting.SelectSingleNode(MovingSystemSettingNode);

                if (SystemSettingNode != null)
                {
                    foreach (XmlNode node in SystemSettingNode.ChildNodes)
                    {
                        element.AppendChild(node.CloneNode(true));
                    }

                    SystemSettingNode.ParentNode.RemoveChild(SystemSettingNode);
                }

                doc.AppendChild(element);
                doc.Save(ConfigWriter);

                XmlDocument NormalizeDocument = new XmlDocument();
                NormalizeDocument.LoadXml(ConfigWriter.ToString());

                IndentedConfig.Remove(0, IndentedConfig.Length);

                NormalizeDocument.Save(ConfigWriter);
                writer.Close();

                return ConfigWriter.ToString();
            }
        }

        private string BuildConfiguration(TreeNode node)
        {
            StringBuilder sb = new StringBuilder(2048);

            foreach (TreeNode child in node.Nodes)
            {
                sb.Append(this.BuildConfiguration(child));
                sb.Append(Environment.NewLine);
            }

            return this.BuildConfiguration(this.TabPageOf(node), sb.ToString());
        }

        private string BuildConfiguration(TabPage tab)
        {
            return this.BuildConfiguration(tab, String.Empty);
        }

        private string BuildConfiguration(TabPage tab, string innerString)
        {
            if (tab.Controls.Count > 0)
            {
                foreach (Control control in tab.Controls)
                {
                    if (control is Syslog.Console.Controls.ConfigCreator.ConfigInputControl)
                    {
                        ConfigCreator.ConfigInputControl InputControl = (ConfigCreator.ConfigInputControl) control;

                        return InputControl.ToString(innerString);
                    }
                }
            }

            return String.Empty;
        }

	}
}
