using System;
using System.Collections;
using System.ComponentModel;
using System.IO;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace Syslog.Console.Controls.ConfigCreator
{
	public class FileWriterInputControl : Syslog.Console.Controls.ConfigCreator.ConfigInputControl
	{
        private System.Windows.Forms.Label SavingFolderLabel;
        private System.Windows.Forms.Label RotationLabel;
        private System.Windows.Forms.ComboBox RotationCombo;
        private System.Windows.Forms.TextBox SavingFolderTextBox;
        private System.Windows.Forms.Button SavingFolderDialogButton;
        private System.Windows.Forms.Label EncodingLabel;
        private Syslog.Console.Controls.EncodingSelectorComboBox EncodingCombo;
        private System.Windows.Forms.Label LogFormatLabel;
        private System.Windows.Forms.TextBox LogFormatTextBox;
        private System.Windows.Forms.FolderBrowserDialog SavingFolderBrowser;
        private System.Windows.Forms.ErrorProvider FilePathErrorProvider;
		private System.ComponentModel.IContainer components = null;

		public FileWriterInputControl()
		{
			// ̌Ăяo Windows tH[ fUCiŕKvłB
            InitializeComponent();

            // qRg[Iɍ쐬
            this.CreateControl();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region fUCiŐꂽR[h
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            this.SavingFolderLabel = new System.Windows.Forms.Label();
            this.SavingFolderTextBox = new System.Windows.Forms.TextBox();
            this.SavingFolderDialogButton = new System.Windows.Forms.Button();
            this.RotationLabel = new System.Windows.Forms.Label();
            this.RotationCombo = new System.Windows.Forms.ComboBox();
            this.EncodingLabel = new System.Windows.Forms.Label();
            this.EncodingCombo = new Syslog.Console.Controls.EncodingSelectorComboBox();
            this.LogFormatLabel = new System.Windows.Forms.Label();
            this.LogFormatTextBox = new System.Windows.Forms.TextBox();
            this.SavingFolderBrowser = new System.Windows.Forms.FolderBrowserDialog();
            this.FilePathErrorProvider = new System.Windows.Forms.ErrorProvider();
            this.InputGroup.SuspendLayout();
            // 
            // InputGroup
            // 
            this.InputGroup.Controls.Add(this.LogFormatTextBox);
            this.InputGroup.Controls.Add(this.LogFormatLabel);
            this.InputGroup.Controls.Add(this.EncodingCombo);
            this.InputGroup.Controls.Add(this.EncodingLabel);
            this.InputGroup.Controls.Add(this.RotationCombo);
            this.InputGroup.Controls.Add(this.RotationLabel);
            this.InputGroup.Controls.Add(this.SavingFolderDialogButton);
            this.InputGroup.Controls.Add(this.SavingFolderTextBox);
            this.InputGroup.Controls.Add(this.SavingFolderLabel);
            this.InputGroup.Name = "InputGroup";
            this.InputGroup.Text = "Simple File Writer";
            // 
            // SavingFolderLabel
            // 
            this.SavingFolderLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.SavingFolderLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.SavingFolderLabel.Location = new System.Drawing.Point(24, 88);
            this.SavingFolderLabel.Name = "SavingFolderLabel";
            this.SavingFolderLabel.Size = new System.Drawing.Size(296, 23);
            this.SavingFolderLabel.TabIndex = 2;
            this.SavingFolderLabel.Text = "OۑtH_(&P):";
            // 
            // SavingFolderTextBox
            // 
            this.SavingFolderTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.FilePathErrorProvider.SetIconAlignment(this.SavingFolderTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
            this.SavingFolderTextBox.Location = new System.Drawing.Point(24, 112);
            this.SavingFolderTextBox.Name = "SavingFolderTextBox";
            this.SavingFolderTextBox.Size = new System.Drawing.Size(312, 22);
            this.SavingFolderTextBox.TabIndex = 3;
            this.SavingFolderTextBox.Text = "%SystemRoot%\\System32\\Logfiles\\Syslog";
            this.SavingFolderTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.SavingFolderTextBox_Validating);
            this.SavingFolderTextBox.TextChanged += new System.EventHandler(this.SavingFolderTextBox_TextChanged);
            // 
            // SavingFolderDialogButton
            // 
            this.SavingFolderDialogButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.SavingFolderDialogButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.SavingFolderDialogButton.Location = new System.Drawing.Point(256, 144);
            this.SavingFolderDialogButton.Name = "SavingFolderDialogButton";
            this.SavingFolderDialogButton.Size = new System.Drawing.Size(75, 32);
            this.SavingFolderDialogButton.TabIndex = 4;
            this.SavingFolderDialogButton.Text = "Q(&R)";
            this.SavingFolderDialogButton.Click += new System.EventHandler(this.SavingFolderDialogButton_Click);
            // 
            // RotationLabel
            // 
            this.RotationLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.RotationLabel.Location = new System.Drawing.Point(24, 192);
            this.RotationLabel.Name = "RotationLabel";
            this.RotationLabel.Size = new System.Drawing.Size(128, 23);
            this.RotationLabel.TabIndex = 5;
            this.RotationLabel.Text = "ۑԊu(&I):";
            // 
            // RotationCombo
            // 
            this.RotationCombo.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.RotationCombo.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.RotationCombo.Items.AddRange(new object[] {
                                                               "Daily",
                                                               "Weekly",
                                                               "Monthly"});
            this.RotationCombo.Location = new System.Drawing.Point(152, 192);
            this.RotationCombo.Name = "RotationCombo";
            this.RotationCombo.Size = new System.Drawing.Size(184, 22);
            this.RotationCombo.TabIndex = 6;
            // 
            // EncodingLabel
            // 
            this.EncodingLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.EncodingLabel.Location = new System.Drawing.Point(24, 224);
            this.EncodingLabel.Name = "EncodingLabel";
            this.EncodingLabel.Size = new System.Drawing.Size(128, 23);
            this.EncodingLabel.TabIndex = 7;
            this.EncodingLabel.Text = "R[h(&E):";
            // 
            // EncodingCombo
            // 
            this.EncodingCombo.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.EncodingCombo.DisplayMember = "EncodingName";
            this.EncodingCombo.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.EncodingCombo.Location = new System.Drawing.Point(152, 224);
            this.EncodingCombo.Name = "EncodingCombo";
            this.EncodingCombo.Size = new System.Drawing.Size(184, 22);
            this.EncodingCombo.TabIndex = 8;
            this.EncodingCombo.ValueMember = "WebName";
            // 
            // LogFormatLabel
            // 
            this.LogFormatLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.LogFormatLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.LogFormatLabel.Location = new System.Drawing.Point(24, 32);
            this.LogFormatLabel.Name = "LogFormatLabel";
            this.LogFormatLabel.Size = new System.Drawing.Size(296, 23);
            this.LogFormatLabel.TabIndex = 0;
            this.LogFormatLabel.Text = "ۑtH[}bg(&F):";
            // 
            // LogFormatTextBox
            // 
            this.LogFormatTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.LogFormatTextBox.Location = new System.Drawing.Point(24, 56);
            this.LogFormatTextBox.Name = "LogFormatTextBox";
            this.LogFormatTextBox.Size = new System.Drawing.Size(312, 22);
            this.LogFormatTextBox.TabIndex = 1;
            this.LogFormatTextBox.Text = "{DateTime}.{DateTime:ff} {DestAddress:host} {Syslog:PRI}{Syslog:HEADER} {Syslog:M" +
                "SG}";
            // 
            // SavingFolderBrowser
            // 
            this.SavingFolderBrowser.Description = "Ot@CۑtH_IĂB";
            // 
            // FilePathErrorProvider
            // 
            this.FilePathErrorProvider.ContainerControl = this;
            // 
            // FileWriterInputControl
            // 
            this.Name = "FileWriterInputControl";
            this.Load += new System.EventHandler(this.FileWriterInputControl_Load);
            this.InputGroup.ResumeLayout(false);

        }
        #endregion

        public override string ToString(string innerString)
        {
            const string AssemblyID = "logfile-writer";
            const string AssemblyType = "Syslog.Collector.Writer.SimpleFileWriter";
            const string AssemblyName = "mlog_coll";

            const string ConfigEntry = "simpleFileWriter";
            const string LogRotation = "rotation";
            const string LogOutputPath = "outputPath";
            const string LogEncoding = "encoding";

            XmlDocument doc = new XmlDocument();
            XmlElement element = doc.CreateElement(ConfigEntry);

            XmlAttribute RotationAttribute = doc.CreateAttribute(LogRotation);
            RotationAttribute.Value = RotationCombo.SelectedItem.ToString();

            XmlAttribute OutputPathAttribute = doc.CreateAttribute(LogOutputPath);
            OutputPathAttribute.Value = SavingFolderTextBox.Text;

            XmlAttribute EncodingAttribute = doc.CreateAttribute(LogEncoding);
            EncodingAttribute.Value = EncodingCombo.SelectedValue.ToString();

            element.Attributes.Append(RotationAttribute);
            element.Attributes.Append(OutputPathAttribute);
            element.Attributes.Append(EncodingAttribute);

            XmlText LogFormatNode = doc.CreateTextNode(LogFormatTextBox.Text);
            element.AppendChild(LogFormatNode);

            AssemblyElementCreator AssemblyCreator = new AssemblyElementCreator(AssemblyID, AssemblyType, AssemblyName);
            XmlNode AssemblyNode = doc.ImportNode(AssemblyCreator.ToNode(element), true);

            doc.AppendChild(AssemblyNode);

            return doc.OuterXml;
        }

        private void FileWriterInputControl_Load(object sender, System.EventArgs e)
        {
            RotationCombo.SelectedIndex = 0;
            EncodingCombo.SetDefaultSelection();
        }

        private void SavingFolderTextBox_Validating(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if (SavingFolderTextBox.TextLength > 0)
            {
                try
                {
                    Path.GetFullPath(SavingFolderTextBox.Text);

                    FilePathErrorProvider.SetError(SavingFolderTextBox, String.Empty);
                }
                catch (Exception ex)
                {
                    FilePathErrorProvider.SetError(SavingFolderTextBox, ex.Message);

                    e.Cancel = true;
                }
            }
            else
            {
                FilePathErrorProvider.SetError(SavingFolderTextBox, String.Empty);
            }
        }

        private void SavingFolderTextBox_TextChanged(object sender, System.EventArgs e)
        {
            if (SavingFolderTextBox.TextLength == 0)
            {
                FilePathErrorProvider.SetError(SavingFolderTextBox, String.Empty);
            }
        }

        private void SavingFolderDialogButton_Click(object sender, System.EventArgs e)
        {
            string SelectionPath = Environment.ExpandEnvironmentVariables(SavingFolderTextBox.Text);
            SavingFolderBrowser.SelectedPath = SelectionPath;

            if (DialogResult.OK == SavingFolderBrowser.ShowDialog())
            {
                SavingFolderTextBox.Text = SavingFolderBrowser.SelectedPath;
            }
        }
	}
}

