using System;
using System.Collections;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Net;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using System.Xml;

namespace Syslog.Console.Controls.ConfigCreator
{
	public class SyslogForwarderInputControl : Syslog.Console.Controls.ConfigCreator.ConfigInputControl
	{
        private System.Windows.Forms.Label ForwardingHostLabel;
        private System.Windows.Forms.TextBox ForwardingHost;
        private System.Windows.Forms.Label PortLabel;
        private System.Windows.Forms.NumericUpDown PortUpDown;
        private System.Windows.Forms.Label EncodingLabel;
        private Syslog.Console.Controls.EncodingSelectorComboBox EncodingCombo;
		private System.ComponentModel.IContainer components = null;

		public SyslogForwarderInputControl()
		{
			// ̌Ăяo Windows tH[ fUCiŕKvłB
            InitializeComponent();

            // qRg[Iɍ쐬
            this.CreateControl();

            // TODO: ̃AhXwł悤 UI g
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region fUCiŐꂽR[h
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            this.ForwardingHostLabel = new System.Windows.Forms.Label();
            this.ForwardingHost = new System.Windows.Forms.TextBox();
            this.PortLabel = new System.Windows.Forms.Label();
            this.PortUpDown = new System.Windows.Forms.NumericUpDown();
            this.EncodingLabel = new System.Windows.Forms.Label();
            this.EncodingCombo = new Syslog.Console.Controls.EncodingSelectorComboBox();
            this.InputGroup.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.PortUpDown)).BeginInit();
            // 
            // InputGroup
            // 
            this.InputGroup.Controls.Add(this.EncodingCombo);
            this.InputGroup.Controls.Add(this.PortUpDown);
            this.InputGroup.Controls.Add(this.PortLabel);
            this.InputGroup.Controls.Add(this.ForwardingHost);
            this.InputGroup.Controls.Add(this.ForwardingHostLabel);
            this.InputGroup.Controls.Add(this.EncodingLabel);
            this.InputGroup.Name = "InputGroup";
            this.InputGroup.Text = "Simple Syslog Forwarder";
            // 
            // ForwardingHostLabel
            // 
            this.ForwardingHostLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.ForwardingHostLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.ForwardingHostLabel.Location = new System.Drawing.Point(24, 32);
            this.ForwardingHostLabel.Name = "ForwardingHostLabel";
            this.ForwardingHostLabel.Size = new System.Drawing.Size(224, 23);
            this.ForwardingHostLabel.TabIndex = 0;
            this.ForwardingHostLabel.Text = "]zXg(&F):";
            // 
            // ForwardingHost
            // 
            this.ForwardingHost.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.ForwardingHost.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.ForwardingHost.Location = new System.Drawing.Point(24, 56);
            this.ForwardingHost.Name = "ForwardingHost";
            this.ForwardingHost.Size = new System.Drawing.Size(240, 22);
            this.ForwardingHost.TabIndex = 1;
            this.ForwardingHost.Text = "";
            // 
            // PortLabel
            // 
            this.PortLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.PortLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.PortLabel.Location = new System.Drawing.Point(272, 32);
            this.PortLabel.Name = "PortLabel";
            this.PortLabel.Size = new System.Drawing.Size(64, 23);
            this.PortLabel.TabIndex = 2;
            this.PortLabel.Text = "|[g(&P):";
            // 
            // PortUpDown
            // 
            this.PortUpDown.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.PortUpDown.Location = new System.Drawing.Point(272, 56);
            this.PortUpDown.Maximum = new System.Decimal(new int[] {
                                                                       65535,
                                                                       0,
                                                                       0,
                                                                       0});
            this.PortUpDown.Name = "PortUpDown";
            this.PortUpDown.Size = new System.Drawing.Size(64, 22);
            this.PortUpDown.TabIndex = 3;
            this.PortUpDown.Value = new System.Decimal(new int[] {
                                                                     514,
                                                                     0,
                                                                     0,
                                                                     0});
            this.PortUpDown.Enter += new System.EventHandler(this.PortUpDown_Enter);
            // 
            // EncodingLabel
            // 
            this.EncodingLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.EncodingLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.EncodingLabel.Location = new System.Drawing.Point(24, 88);
            this.EncodingLabel.Name = "EncodingLabel";
            this.EncodingLabel.Size = new System.Drawing.Size(224, 23);
            this.EncodingLabel.TabIndex = 4;
            this.EncodingLabel.Text = "R[h(&E):";
            // 
            // EncodingCombo
            // 
            this.EncodingCombo.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.EncodingCombo.DisplayMember = "EncodingName";
            this.EncodingCombo.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.EncodingCombo.Location = new System.Drawing.Point(24, 112);
            this.EncodingCombo.Name = "EncodingCombo";
            this.EncodingCombo.Size = new System.Drawing.Size(240, 22);
            this.EncodingCombo.TabIndex = 5;
            this.EncodingCombo.ValueMember = "WebName";
            // 
            // SyslogForwarderInputControl
            // 
            this.Name = "SyslogForwarderInputControl";
            this.Load += new System.EventHandler(this.SyslogForwarderInputControl_Load);
            this.InputGroup.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.PortUpDown)).EndInit();

        }
		#endregion

        private void SyslogForwarderInputControl_Load(object sender, System.EventArgs e)
        {
            EncodingCombo.SetDefaultSelection();
        }

        private void PortUpDown_Enter(object sender, System.EventArgs e)
        {
            PortUpDown.Select(0, PortUpDown.Value.ToString().Length);
        }

        public override string ToString(string innerString)
        {
            const string AssemblyID = "syslog-forwarder";
            const string AssemblyType = "Syslog.Collector.Writer.SimpleSyslogForwarder";
            const string AssemblyName = "mlog_coll";

            const string ConfigEntry = "forward";
            const string ForwardEncoding = "encoding";
            const string DestinationAddress = "destinationAddress";
            const string DestinationPort = "destinationPort";

            XmlDocument doc = new XmlDocument();
            XmlElement element = doc.CreateElement(ConfigEntry);

            XmlAttribute EncodingAttribute = doc.CreateAttribute(ForwardEncoding);
            EncodingAttribute.Value = EncodingCombo.SelectedValue.ToString();

            XmlAttribute AddressAttribute = doc.CreateAttribute(DestinationAddress);
            AddressAttribute.Value = ForwardingHost.Text;

            XmlAttribute PortAttribute = doc.CreateAttribute(DestinationPort);
            PortAttribute.Value = PortUpDown.Value.ToString();

            element.Attributes.Append(EncodingAttribute);
            element.Attributes.Append(AddressAttribute);
            element.Attributes.Append(PortAttribute);

            AssemblyElementCreator AssemblyCreator = new AssemblyElementCreator(AssemblyID, AssemblyType, AssemblyName);
            XmlNode AssemblyNode = doc.ImportNode(AssemblyCreator.ToNode(element), true);

            doc.AppendChild(AssemblyNode);

            return doc.OuterXml;
        }
	}
}

