using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.Xml;

namespace Syslog.Console.Controls.ConfigCreator
{
	public class IPv6InputControl : Syslog.Console.Controls.ConfigCreator.ConfigInputControl
	{
        private System.Windows.Forms.Label IPv6Label;
        private System.Windows.Forms.CheckBox IPv6Check;
		private System.ComponentModel.IContainer components = null;

		public IPv6InputControl()
		{
			// ̌Ăяo Windows tH[ fUCiŕKvłB
			InitializeComponent();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region fUCiŐꂽR[h
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            this.IPv6Label = new System.Windows.Forms.Label();
            this.IPv6Check = new System.Windows.Forms.CheckBox();
            this.InputGroup.SuspendLayout();
            // 
            // InputGroup
            // 
            this.InputGroup.Controls.Add(this.IPv6Check);
            this.InputGroup.Controls.Add(this.IPv6Label);
            this.InputGroup.Name = "InputGroup";
            this.InputGroup.Text = "IPv6";
            // 
            // IPv6Label
            // 
            this.IPv6Label.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.IPv6Label.Location = new System.Drawing.Point(24, 40);
            this.IPv6Label.Name = "IPv6Label";
            this.IPv6Label.Size = new System.Drawing.Size(112, 23);
            this.IPv6Label.TabIndex = 0;
            this.IPv6Label.Text = "IPv6 L(&I):";
            // 
            // IPv6Check
            // 
            this.IPv6Check.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.IPv6Check.Checked = true;
            this.IPv6Check.CheckState = System.Windows.Forms.CheckState.Checked;
            this.IPv6Check.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.IPv6Check.Location = new System.Drawing.Point(152, 40);
            this.IPv6Check.Name = "IPv6Check";
            this.IPv6Check.Size = new System.Drawing.Size(160, 24);
            this.IPv6Check.TabIndex = 1;
            this.IPv6Check.Text = "IPv6 Lɂ";
            this.IPv6Check.TextAlign = System.Drawing.ContentAlignment.TopLeft;
            // 
            // IPv6InputControl
            // 
            this.Name = "IPv6InputControl";
            this.InputGroup.ResumeLayout(false);

        }
        #endregion
        public override string ToString(string innerString)
        {
            const string ConfigElement = "system.net";
            const string ConfigEntryElement = "settings";
            const string EnablingIPv6Entry = "ipv6";
            const string EnablingIPv6 = "enabled";

            if (!IPv6Check.Checked)
            {
                return String.Empty;
            }

            XmlDocument doc = new XmlDocument();
            XmlElement SystemNetElement = doc.CreateElement(ConfigElement);
            XmlElement EntryElement = doc.CreateElement(ConfigEntryElement);
            XmlElement IPv6Element = doc.CreateElement(EnablingIPv6Entry);
            XmlAttribute IPv6Attribute = doc.CreateAttribute(EnablingIPv6);
            IPv6Attribute.Value = IPv6Check.Checked.ToString().ToLower();

            IPv6Element.Attributes.Append(IPv6Attribute);
            EntryElement.AppendChild(IPv6Element);
            SystemNetElement.AppendChild(EntryElement);            
            doc.AppendChild(SystemNetElement);

            return doc.OuterXml;
        }
	}
}

