using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.Xml;

namespace Syslog.Console.Controls.ConfigCreator
{
	public class ListenerModuleInputControl : Syslog.Console.Controls.ConfigCreator.ConfigInfoControl
	{
        private System.Windows.Forms.Label ModuleSelectLabel;
        private System.Windows.Forms.CheckBox EnabledUdpListenerCheck;
        private System.Windows.Forms.CheckBox EnabledEventLogListenerCheck;
		private System.ComponentModel.IContainer components = null;

		public ListenerModuleInputControl()
		{
			// ̌Ăяo Windows tH[ fUCiŕKvłB
			InitializeComponent();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region fUCiŐꂽR[h
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            this.ModuleSelectLabel = new System.Windows.Forms.Label();
            this.EnabledUdpListenerCheck = new System.Windows.Forms.CheckBox();
            this.EnabledEventLogListenerCheck = new System.Windows.Forms.CheckBox();
            this.InputGroup.SuspendLayout();
            // 
            // ConfigDescription
            // 
            this.ConfigDescription.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.ConfigDescription.Name = "ConfigDescription";
            this.ConfigDescription.Size = new System.Drawing.Size(288, 72);
            this.ConfigDescription.Text = "Managed Syslog Listener Module ݒ肵܂B\r\nSyslog Listener  Syslog bZ[We\[XW" +
                "܂B";
            // 
            // InputGroup
            // 
            this.InputGroup.Controls.Add(this.EnabledUdpListenerCheck);
            this.InputGroup.Controls.Add(this.ModuleSelectLabel);
            this.InputGroup.Controls.Add(this.EnabledEventLogListenerCheck);
            this.InputGroup.Name = "InputGroup";
            this.InputGroup.Text = "Managed Syslog Listener Modules";
            // 
            // ModuleSelectLabel
            // 
            this.ModuleSelectLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.ModuleSelectLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.ModuleSelectLabel.Location = new System.Drawing.Point(32, 128);
            this.ModuleSelectLabel.Name = "ModuleSelectLabel";
            this.ModuleSelectLabel.Size = new System.Drawing.Size(208, 23);
            this.ModuleSelectLabel.TabIndex = 0;
            this.ModuleSelectLabel.Text = "p郂W[(&M):";
            // 
            // EnabledUdpListenerCheck
            // 
            this.EnabledUdpListenerCheck.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.EnabledUdpListenerCheck.Checked = true;
            this.EnabledUdpListenerCheck.CheckState = System.Windows.Forms.CheckState.Checked;
            this.EnabledUdpListenerCheck.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.EnabledUdpListenerCheck.Location = new System.Drawing.Point(56, 160);
            this.EnabledUdpListenerCheck.Name = "EnabledUdpListenerCheck";
            this.EnabledUdpListenerCheck.Size = new System.Drawing.Size(232, 24);
            this.EnabledUdpListenerCheck.TabIndex = 1;
            this.EnabledUdpListenerCheck.Text = "&UDP Listener";
            // 
            // EnabledEventLogListenerCheck
            // 
            this.EnabledEventLogListenerCheck.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.EnabledEventLogListenerCheck.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.EnabledEventLogListenerCheck.Location = new System.Drawing.Point(56, 184);
            this.EnabledEventLogListenerCheck.Name = "EnabledEventLogListenerCheck";
            this.EnabledEventLogListenerCheck.Size = new System.Drawing.Size(232, 24);
            this.EnabledEventLogListenerCheck.TabIndex = 2;
            this.EnabledEventLogListenerCheck.Text = "Simple &EventLog Listener";
            // 
            // ListenerModuleInputControl
            // 
            this.Name = "ListenerModuleInputControl";
            this.InputGroup.ResumeLayout(false);

        }
        #endregion

        public override string ToString(string innerString)
        {
            const string ConfigModuleElement = "modules";
            const string ConfigAssemblyElement = "assembly";
            const string ConfigAssemblyTypeAttribute = "type";
            const string ConfigUdpListenerTypeValue = "Syslog.Listener.UDPListener";
            const string ConfigEventLogListenerTypeValue = "Syslog.Listener.SimpleEventLogListener";

            XmlDocument doc = new XmlDocument();
            XmlElement element = doc.CreateElement(ConfigModuleElement);

            XmlDocumentFragment frag = doc.CreateDocumentFragment();
            frag.InnerXml = innerString;

            foreach (XmlNode node in frag.ChildNodes)
            {
                if (node.Name == ConfigAssemblyElement)
                {
                    XmlAttribute TypeAttribute = (XmlAttribute) node.Attributes.GetNamedItem(ConfigAssemblyTypeAttribute);

                    if (EnabledUdpListenerCheck.Checked && TypeAttribute.Value == ConfigUdpListenerTypeValue)
                    {
                        element.AppendChild(node.CloneNode(true));

                        continue;
                    }

                    if (EnabledEventLogListenerCheck.Checked && TypeAttribute.Value == ConfigEventLogListenerTypeValue)
                    {
                        element.AppendChild(node.CloneNode(true));

                        continue;
                    }
                }
            }
            
            doc.AppendChild(element);

            return doc.OuterXml;
        }
	}
}

