using System;
using System.Collections;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Net;
using System.Windows.Forms;
using System.Xml;

namespace Syslog.Console.Controls.ConfigCreator
{
	public class UdpListenerInputControl : Syslog.Console.Controls.ConfigCreator.ConfigInputControl
	{
        private Syslog.Console.Controls.IPAddressBox IPAddressTextBox;
        private System.Windows.Forms.Label IPAddressLabel;
        private System.Windows.Forms.Label PortLabel;
        private System.Windows.Forms.Label RecievedInterfaceLabel;
        private System.Windows.Forms.ListView AddressList;
        private System.Windows.Forms.ColumnHeader IPAddressColumn;
        private System.Windows.Forms.ColumnHeader PortColumn;
        private System.Windows.Forms.Button RankUpButton;
        private System.Windows.Forms.Button RankDownButton;
        private System.Windows.Forms.Button AddButton;
        private System.Windows.Forms.Button RemoveButton;
        private System.Windows.Forms.NumericUpDown PortUpDown;
		private System.ComponentModel.IContainer components = null;

		public UdpListenerInputControl()
		{
			// ̌Ăяo Windows tH[ fUCiŕKvłB
            InitializeComponent();

            this.AddIPAddress("0.0.0.0", 514);

            if (System.Net.Sockets.Socket.SupportsIPv6)
            {
                this.AddIPAddress("::", 514);
            }
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region fUCiŐꂽR[h
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            this.RecievedInterfaceLabel = new System.Windows.Forms.Label();
            this.IPAddressTextBox = new Syslog.Console.Controls.IPAddressBox();
            this.IPAddressLabel = new System.Windows.Forms.Label();
            this.PortLabel = new System.Windows.Forms.Label();
            this.AddressList = new System.Windows.Forms.ListView();
            this.IPAddressColumn = new System.Windows.Forms.ColumnHeader();
            this.PortColumn = new System.Windows.Forms.ColumnHeader();
            this.RankUpButton = new System.Windows.Forms.Button();
            this.RankDownButton = new System.Windows.Forms.Button();
            this.AddButton = new System.Windows.Forms.Button();
            this.RemoveButton = new System.Windows.Forms.Button();
            this.PortUpDown = new System.Windows.Forms.NumericUpDown();
            this.InputGroup.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.PortUpDown)).BeginInit();
            // 
            // InputGroup
            // 
            this.InputGroup.Controls.Add(this.AddButton);
            this.InputGroup.Controls.Add(this.RankUpButton);
            this.InputGroup.Controls.Add(this.AddressList);
            this.InputGroup.Controls.Add(this.IPAddressTextBox);
            this.InputGroup.Controls.Add(this.RecievedInterfaceLabel);
            this.InputGroup.Controls.Add(this.IPAddressLabel);
            this.InputGroup.Controls.Add(this.PortLabel);
            this.InputGroup.Controls.Add(this.RankDownButton);
            this.InputGroup.Controls.Add(this.RemoveButton);
            this.InputGroup.Controls.Add(this.PortUpDown);
            this.InputGroup.Name = "InputGroup";
            this.InputGroup.Text = "UDP Listener";
            // 
            // RecievedInterfaceLabel
            // 
            this.RecievedInterfaceLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.RecievedInterfaceLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.RecievedInterfaceLabel.Location = new System.Drawing.Point(24, 32);
            this.RecievedInterfaceLabel.Name = "RecievedInterfaceLabel";
            this.RecievedInterfaceLabel.Size = new System.Drawing.Size(224, 23);
            this.RecievedInterfaceLabel.TabIndex = 0;
            this.RecievedInterfaceLabel.Text = "MC^[tFCX";
            // 
            // IPAddressTextBox
            // 
            this.IPAddressTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.IPAddressTextBox.Error = "";
            this.IPAddressTextBox.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.IPAddressTextBox.IconAlignment = System.Windows.Forms.ErrorIconAlignment.MiddleLeft;
            this.IPAddressTextBox.IconPadding = 0;
            this.IPAddressTextBox.Location = new System.Drawing.Point(24, 80);
            this.IPAddressTextBox.Name = "IPAddressTextBox";
            this.IPAddressTextBox.Size = new System.Drawing.Size(240, 22);
            this.IPAddressTextBox.TabIndex = 2;
            this.IPAddressTextBox.Text = "";
            this.IPAddressTextBox.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.IPAddressTextBox_KeyPress);
            this.IPAddressTextBox.TextChanged += new System.EventHandler(this.IPAddressTextBox_TextChanged);
            // 
            // IPAddressLabel
            // 
            this.IPAddressLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.IPAddressLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.IPAddressLabel.Location = new System.Drawing.Point(24, 56);
            this.IPAddressLabel.Name = "IPAddressLabel";
            this.IPAddressLabel.Size = new System.Drawing.Size(224, 23);
            this.IPAddressLabel.TabIndex = 1;
            this.IPAddressLabel.Text = "C^[tFCX AhX(&I):";
            // 
            // PortLabel
            // 
            this.PortLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.PortLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.PortLabel.Location = new System.Drawing.Point(272, 56);
            this.PortLabel.Name = "PortLabel";
            this.PortLabel.Size = new System.Drawing.Size(64, 23);
            this.PortLabel.TabIndex = 3;
            this.PortLabel.Text = "|[g(&P):";
            // 
            // AddressList
            // 
            this.AddressList.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.AddressList.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                          this.IPAddressColumn,
                                                                                          this.PortColumn});
            this.AddressList.FullRowSelect = true;
            this.AddressList.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
            this.AddressList.HideSelection = false;
            this.AddressList.Location = new System.Drawing.Point(24, 160);
            this.AddressList.MultiSelect = false;
            this.AddressList.Name = "AddressList";
            this.AddressList.Size = new System.Drawing.Size(240, 88);
            this.AddressList.TabIndex = 7;
            this.AddressList.View = System.Windows.Forms.View.Details;
            this.AddressList.SelectedIndexChanged += new System.EventHandler(this.AddressList_SelectedIndexChanged);
            // 
            // IPAddressColumn
            // 
            this.IPAddressColumn.Text = "IPAhX";
            this.IPAddressColumn.Width = 160;
            // 
            // PortColumn
            // 
            this.PortColumn.Text = "|[gԍ";
            this.PortColumn.Width = 70;
            // 
            // RankUpButton
            // 
            this.RankUpButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.RankUpButton.Enabled = false;
            this.RankUpButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.RankUpButton.Location = new System.Drawing.Point(280, 160);
            this.RankUpButton.Name = "RankUpButton";
            this.RankUpButton.Size = new System.Drawing.Size(48, 40);
            this.RankUpButton.TabIndex = 8;
            this.RankUpButton.Text = "&Up";
            this.RankUpButton.Click += new System.EventHandler(this.RankUpButton_Click);
            // 
            // RankDownButton
            // 
            this.RankDownButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.RankDownButton.Enabled = false;
            this.RankDownButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.RankDownButton.Location = new System.Drawing.Point(280, 208);
            this.RankDownButton.Name = "RankDownButton";
            this.RankDownButton.Size = new System.Drawing.Size(48, 40);
            this.RankDownButton.TabIndex = 9;
            this.RankDownButton.Text = "&Down";
            this.RankDownButton.Click += new System.EventHandler(this.RankDownButton_Click);
            // 
            // AddButton
            // 
            this.AddButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.AddButton.Enabled = false;
            this.AddButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.AddButton.Location = new System.Drawing.Point(96, 112);
            this.AddButton.Name = "AddButton";
            this.AddButton.Size = new System.Drawing.Size(75, 30);
            this.AddButton.TabIndex = 5;
            this.AddButton.Text = "ǉ(&A)";
            this.AddButton.Click += new System.EventHandler(this.AddButton_Click);
            // 
            // RemoveButton
            // 
            this.RemoveButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.RemoveButton.Enabled = false;
            this.RemoveButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.RemoveButton.Location = new System.Drawing.Point(184, 112);
            this.RemoveButton.Name = "RemoveButton";
            this.RemoveButton.Size = new System.Drawing.Size(80, 30);
            this.RemoveButton.TabIndex = 6;
            this.RemoveButton.Text = "폜(&R)";
            this.RemoveButton.Click += new System.EventHandler(this.RemoveButton_Click);
            // 
            // PortUpDown
            // 
            this.PortUpDown.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.PortUpDown.Location = new System.Drawing.Point(272, 80);
            this.PortUpDown.Maximum = new System.Decimal(new int[] {
                                                                       65535,
                                                                       0,
                                                                       0,
                                                                       0});
            this.PortUpDown.Name = "PortUpDown";
            this.PortUpDown.Size = new System.Drawing.Size(64, 22);
            this.PortUpDown.TabIndex = 4;
            this.PortUpDown.Value = new System.Decimal(new int[] {
                                                                     514,
                                                                     0,
                                                                     0,
                                                                     0});
            this.PortUpDown.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.PortUpDown_KeyPress);
            this.PortUpDown.Enter += new System.EventHandler(this.PortUpDown_Enter);
            // 
            // UdpListenerInputControl
            // 
            this.Name = "UdpListenerInputControl";
            this.Load += new System.EventHandler(this.UdpListenerInputControl_Load);
            this.InputGroup.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.PortUpDown)).EndInit();

        }
		#endregion

        public override string ToString(string innerString)
        {
            const string AssemblyID = "udp-listener";
            const string AssemblyType = "Syslog.Listener.UDPListener";
            const string AssemblyName = "mlog_listen";
            const string AddressEntry = "allow";
            const string IPAddressEntry = "address";
            const string PortEntry = "port";

            XmlDocument doc = new XmlDocument();
            XmlDocumentFragment frag = doc.CreateDocumentFragment();

            foreach (ListViewItem item in AddressList.Items)
            {
                XmlAttribute IPAddressAttribute = doc.CreateAttribute(IPAddressEntry);
                IPAddressAttribute.Value = item.SubItems[0].Text;

                XmlAttribute PortAttribute = doc.CreateAttribute(PortEntry);
                PortAttribute.Value = item.SubItems[1].Text;

                XmlElement AddressElement = doc.CreateElement(AddressEntry);
                AddressElement.Attributes.Append(IPAddressAttribute);
                AddressElement.Attributes.Append(PortAttribute);

                frag.AppendChild(AddressElement);
            }

            AssemblyElementCreator AssemblyCreator = new AssemblyElementCreator(AssemblyID, AssemblyType, AssemblyName);
            XmlNode AssemblyNode = doc.ImportNode(AssemblyCreator.ToNode((XmlNode) frag), true);

            doc.AppendChild(AssemblyNode);

            return doc.OuterXml;
        }

        private void UdpListenerInputControl_Load(object sender, System.EventArgs e)
        {
            IPAddressTextBox.Clear();
        }

        private void IPAddressTextBox_TextChanged(object sender, System.EventArgs e)
        {
            if (IPAddressTextBox.TextLength > 0)
            {
                AddButton.Enabled = true;
            }
            else
            {
                AddButton.Enabled = false;
            }
        }

        private void IPAddressTextBox_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
        {
            this.PressEnterKey(e);
        }

        private void PortUpDown_Enter(object sender, System.EventArgs e)
        {
            PortUpDown.Select(0, PortUpDown.Value.ToString().Length);
        }

        private void PortUpDown_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
        {
            this.PressEnterKey(e);
        }

        private void AddButton_Click(object sender, System.EventArgs e)
        {
            try
            {
                this.AddIPAddress(IPAddressTextBox.Text, (int) PortUpDown.Value);

                IPAddressTextBox.Clear();
            }
            catch
            {
            }
            
            IPAddressTextBox.Focus();
        }

        private void RemoveButton_Click(object sender, System.EventArgs e)
        {
            foreach (ListViewItem item in AddressList.SelectedItems)
            {
                item.Remove();
            }

            if (AddressList.FocusedItem != null)
            {
                AddressList.FocusedItem.Selected = true;
                AddressList.FocusedItem.EnsureVisible();
            }
        }

        private void AddressList_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            const int PortColumnIndex = 1;

            if (AddressList.SelectedItems.Count > 0)
            {
                RemoveButton.Enabled = true;
                
                IPAddressTextBox.Text = AddressList.SelectedItems[0].Text;
                PortUpDown.Value = Decimal.Parse(AddressList.SelectedItems[0].SubItems[PortColumnIndex].Text);
            }
            else
            {
                RemoveButton.Enabled = false;
            }

            this.UpdateAddressSortingButton();
        }

        private void RankUpButton_Click(object sender, System.EventArgs e)
        {
            if (AddressList.SelectedItems.Count > 0)
            {
                if (AddressList.SelectedItems[0].Index != 0)
                {
                    ListViewItem CloneItem = (ListViewItem) AddressList.SelectedItems[0].Clone();
                    ListViewItem InsertedItem = AddressList.Items.Insert(AddressList.SelectedItems[0].Index - 1, CloneItem);
                    AddressList.SelectedItems[0].Remove();

                    InsertedItem.Selected = true;
                    InsertedItem.Focused = true;
                    AddressList.Focus();
                    AddressList.EnsureVisible(InsertedItem.Index);
                }
            }
        }

        private void RankDownButton_Click(object sender, System.EventArgs e)
        {
            if (AddressList.SelectedItems.Count > 0)
            {
                if (AddressList.SelectedItems[0].Index != AddressList.Items.Count - 1)
                {
                    ListViewItem CloneItem = (ListViewItem) AddressList.SelectedItems[0].Clone();
                    ListViewItem InsertedItem = AddressList.Items.Insert(AddressList.SelectedItems[0].Index + 2, CloneItem);
                    AddressList.SelectedItems[0].Remove();

                    InsertedItem.Selected = true;
                    InsertedItem.Focused = true;
                    AddressList.Focus();
                    AddressList.EnsureVisible(InsertedItem.Index);
                }
            }
        }

        private ListViewItem AddIPAddress(string address, int port)
        {
            return this.AddIPAddress(IPAddress.Parse(address), port);
        }

        private ListViewItem AddIPAddress(IPAddress address, int port)
        {
            ListViewItem AddressEntry = new ListViewItem(address.ToString());
            AddressEntry.SubItems.Add(port.ToString());

            foreach (ListViewItem item in AddressList.Items)
            {
                if (item.Text == AddressEntry.Text)
                {
                    foreach (ListViewItem.ListViewSubItem sub in item.SubItems)
                    {
                        if (sub.Text == port.ToString())
                        {
                            item.Selected = true;
                            item.Focused = true;
                            item.EnsureVisible();

                            return item;
                        }
                    }
                }
            }

            ListViewItem InsertedItem = AddressList.Items.Add(AddressEntry);
            InsertedItem.Selected = true;
            InsertedItem.Focused = true;
            InsertedItem.EnsureVisible();

            return InsertedItem;
        }

        private void PressEnterKey(KeyPressEventArgs e)
        {
            if ((int) e.KeyChar == (int) Keys.Enter)
            {
                this.AddButton.PerformClick();

                e.Handled = true;
            }
        }

        private void UpdateAddressSortingButton()
        {
            const int MultiItemCount = 1;

            if (AddressList.Items.Count > MultiItemCount)
            {
                if (AddressList.SelectedItems.Count > 0)
                {
                    if (AddressList.SelectedItems[0].Index == 0)
                    {
                        RankUpButton.Enabled = false;
                        RankDownButton.Enabled = true;
                    }
                    else if (AddressList.SelectedItems[0].Index == AddressList.Items.Count - 1)
                    {
                        RankUpButton.Enabled = true;
                        RankDownButton.Enabled = false;
                    }
                    else
                    {
                        RankUpButton.Enabled = true;
                        RankDownButton.Enabled = true;
                    }

                    return;
                }
            }

            RankUpButton.Enabled = false;
            RankDownButton.Enabled = false;
        }
	}
}

