using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.Xml;

namespace Syslog.Console.Controls.ConfigCreator
{
	public class RelayFilterInputControl : Syslog.Console.Controls.ConfigCreator.ConfigInfoControl
	{
        private System.Windows.Forms.Label EnabledFilterLabel;
        private System.Windows.Forms.CheckBox SourceAddressFilterCheck;
        private System.Windows.Forms.CheckBox PriorityFilterCheck;
		private System.ComponentModel.IContainer components = null;

		public RelayFilterInputControl()
		{
			// ̌Ăяo Windows tH[ fUCiŕKvłB
			InitializeComponent();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region fUCiŐꂽR[h
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            this.EnabledFilterLabel = new System.Windows.Forms.Label();
            this.SourceAddressFilterCheck = new System.Windows.Forms.CheckBox();
            this.PriorityFilterCheck = new System.Windows.Forms.CheckBox();
            this.InputGroup.SuspendLayout();
            // 
            // ConfigDescription
            // 
            this.ConfigDescription.Name = "ConfigDescription";
            this.ConfigDescription.Size = new System.Drawing.Size(288, 64);
            this.ConfigDescription.Text = "Managed Syslog Relay Filter ̐ݒs܂B\r\nRelay Filter  Syslog bZ[W Relay Plugin " +
                "֓nOɂꂼKvȏbZ[Wɑ΂ĉ܂B";
            // 
            // InputGroup
            // 
            this.InputGroup.Controls.Add(this.PriorityFilterCheck);
            this.InputGroup.Controls.Add(this.SourceAddressFilterCheck);
            this.InputGroup.Controls.Add(this.EnabledFilterLabel);
            this.InputGroup.Name = "InputGroup";
            this.InputGroup.Text = "Syslog Relay Filter";
            // 
            // EnabledFilterLabel
            // 
            this.EnabledFilterLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.EnabledFilterLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.EnabledFilterLabel.Location = new System.Drawing.Point(32, 128);
            this.EnabledFilterLabel.Name = "EnabledFilterLabel";
            this.EnabledFilterLabel.Size = new System.Drawing.Size(224, 23);
            this.EnabledFilterLabel.TabIndex = 0;
            this.EnabledFilterLabel.Text = "p Relay Filter (&F):";
            // 
            // SourceAddressFilterCheck
            // 
            this.SourceAddressFilterCheck.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.SourceAddressFilterCheck.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.SourceAddressFilterCheck.Location = new System.Drawing.Point(64, 152);
            this.SourceAddressFilterCheck.Name = "SourceAddressFilterCheck";
            this.SourceAddressFilterCheck.Size = new System.Drawing.Size(224, 24);
            this.SourceAddressFilterCheck.TabIndex = 1;
            this.SourceAddressFilterCheck.Text = "&Source Address Filter";
            // 
            // PriorityFilterCheck
            // 
            this.PriorityFilterCheck.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.PriorityFilterCheck.Checked = true;
            this.PriorityFilterCheck.CheckState = System.Windows.Forms.CheckState.Checked;
            this.PriorityFilterCheck.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.PriorityFilterCheck.Location = new System.Drawing.Point(64, 176);
            this.PriorityFilterCheck.Name = "PriorityFilterCheck";
            this.PriorityFilterCheck.Size = new System.Drawing.Size(224, 24);
            this.PriorityFilterCheck.TabIndex = 2;
            this.PriorityFilterCheck.Text = "&Priority Filter";
            // 
            // RelayFilterInputControl
            // 
            this.Name = "RelayFilterInputControl";
            this.InputGroup.ResumeLayout(false);

        }
        #endregion

        public override string ToString(string innerString)
        {
            const string ConfigModuleElement = "filters";
            const string ConfigAssemblyElement = "assembly";
            const string ConfigAssemblyTypeAttribute = "type";
            const string ConfigSourceAddressFilterTypeValue = "Syslog.Relay.Filter.SourceAddressFilter";
            const string ConfigPriorityFilterTypeValue = "Syslog.Relay.Filter.PriorityFilter";

            XmlDocument doc = new XmlDocument();
            XmlElement element = doc.CreateElement(ConfigModuleElement);

            XmlDocumentFragment frag = doc.CreateDocumentFragment();
            frag.InnerXml = innerString;

            foreach (XmlNode node in frag.ChildNodes)
            {
                if (node.Name == ConfigAssemblyElement)
                {
                    XmlAttribute TypeAttribute = (XmlAttribute) node.Attributes.GetNamedItem(ConfigAssemblyTypeAttribute);

                    if (SourceAddressFilterCheck.Checked && TypeAttribute.Value == ConfigSourceAddressFilterTypeValue)
                    {
                        element.AppendChild(node.CloneNode(true));

                        continue;
                    }

                    if (PriorityFilterCheck.Checked && TypeAttribute.Value == ConfigPriorityFilterTypeValue)
                    {
                        element.AppendChild(node.CloneNode(true));

                        continue;
                    }
                }
            }
            
            doc.AppendChild(element);

            return doc.OuterXml;
        }
	}
}

