using System;
using System.Collections;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Net;
using System.Windows.Forms;
using System.Xml;

namespace Syslog.Console.Controls.ConfigCreator
{
	public class SourceAddressRelayFilterInputControl : Syslog.Console.Controls.ConfigCreator.ConfigInputControl
	{
        private System.Windows.Forms.Label SourceAddressFilterLabel;
        private System.Windows.Forms.Label IPAddressLabel;
        private Syslog.Console.Controls.IPAddressBox IPAddressTextBox;
        private System.Windows.Forms.Label PortLabel;
        private System.Windows.Forms.NumericUpDown PortUpDown;
        private System.Windows.Forms.Button AddButton;
        private System.Windows.Forms.Button DeleteButton;
        private System.Windows.Forms.ListView IPAddressList;
        private System.Windows.Forms.ColumnHeader IPAddressColumn;
        private System.Windows.Forms.ColumnHeader PortColumn;
		private System.ComponentModel.IContainer components = null;

		public SourceAddressRelayFilterInputControl()
		{
			// ̌Ăяo Windows tH[ fUCiŕKvłB
            InitializeComponent();

            if (System.Net.Sockets.Socket.SupportsIPv6)
            {
                this.AddIPAddress("::", 514);
            }

            this.AddIPAddress("127.0.0.1", 514);
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region fUCiŐꂽR[h
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(SourceAddressRelayFilterInputControl));
            this.SourceAddressFilterLabel = new System.Windows.Forms.Label();
            this.IPAddressLabel = new System.Windows.Forms.Label();
            this.IPAddressTextBox = new Syslog.Console.Controls.IPAddressBox();
            this.PortLabel = new System.Windows.Forms.Label();
            this.PortUpDown = new System.Windows.Forms.NumericUpDown();
            this.AddButton = new System.Windows.Forms.Button();
            this.DeleteButton = new System.Windows.Forms.Button();
            this.IPAddressList = new System.Windows.Forms.ListView();
            this.IPAddressColumn = new System.Windows.Forms.ColumnHeader();
            this.PortColumn = new System.Windows.Forms.ColumnHeader();
            this.InputGroup.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.PortUpDown)).BeginInit();
            // 
            // InputGroup
            // 
            this.InputGroup.Controls.Add(this.IPAddressList);
            this.InputGroup.Controls.Add(this.DeleteButton);
            this.InputGroup.Controls.Add(this.AddButton);
            this.InputGroup.Controls.Add(this.PortUpDown);
            this.InputGroup.Controls.Add(this.PortLabel);
            this.InputGroup.Controls.Add(this.IPAddressTextBox);
            this.InputGroup.Controls.Add(this.IPAddressLabel);
            this.InputGroup.Controls.Add(this.SourceAddressFilterLabel);
            this.InputGroup.Name = "InputGroup";
            this.InputGroup.Text = "Source Address Filter";
            // 
            // SourceAddressFilterLabel
            // 
            this.SourceAddressFilterLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.SourceAddressFilterLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.SourceAddressFilterLabel.Location = new System.Drawing.Point(24, 32);
            this.SourceAddressFilterLabel.Name = "SourceAddressFilterLabel";
            this.SourceAddressFilterLabel.Size = new System.Drawing.Size(280, 23);
            this.SourceAddressFilterLabel.TabIndex = 0;
            this.SourceAddressFilterLabel.Text = "Syslog bZ[W󂯓郊[gzXg";
            // 
            // IPAddressLabel
            // 
            this.IPAddressLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.IPAddressLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.IPAddressLabel.Location = new System.Drawing.Point(24, 56);
            this.IPAddressLabel.Name = "IPAddressLabel";
            this.IPAddressLabel.Size = new System.Drawing.Size(160, 23);
            this.IPAddressLabel.TabIndex = 1;
            this.IPAddressLabel.Text = "IPAhX(&A):";
            // 
            // IPAddressTextBox
            // 
            this.IPAddressTextBox.Address = ((System.Net.IPAddress)(resources.GetObject("IPAddressTextBox.Address")));
            this.IPAddressTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.IPAddressTextBox.Error = "";
            this.IPAddressTextBox.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.IPAddressTextBox.IconAlignment = System.Windows.Forms.ErrorIconAlignment.MiddleLeft;
            this.IPAddressTextBox.IconPadding = 0;
            this.IPAddressTextBox.Location = new System.Drawing.Point(24, 80);
            this.IPAddressTextBox.Name = "IPAddressTextBox";
            this.IPAddressTextBox.Size = new System.Drawing.Size(240, 22);
            this.IPAddressTextBox.TabIndex = 2;
            this.IPAddressTextBox.Text = "";
            this.IPAddressTextBox.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.IPAddressTextBox_KeyPress);
            this.IPAddressTextBox.TextChanged += new System.EventHandler(this.IPAddressTextBox_TextChanged);
            // 
            // PortLabel
            // 
            this.PortLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.PortLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.PortLabel.Location = new System.Drawing.Point(272, 56);
            this.PortLabel.Name = "PortLabel";
            this.PortLabel.Size = new System.Drawing.Size(64, 23);
            this.PortLabel.TabIndex = 3;
            this.PortLabel.Text = "|[g(&P):";
            // 
            // PortUpDown
            // 
            this.PortUpDown.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.PortUpDown.Location = new System.Drawing.Point(272, 80);
            this.PortUpDown.Maximum = new System.Decimal(new int[] {
                                                                       65535,
                                                                       0,
                                                                       0,
                                                                       0});
            this.PortUpDown.Name = "PortUpDown";
            this.PortUpDown.Size = new System.Drawing.Size(64, 22);
            this.PortUpDown.TabIndex = 4;
            this.PortUpDown.Value = new System.Decimal(new int[] {
                                                                     514,
                                                                     0,
                                                                     0,
                                                                     0});
            this.PortUpDown.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.PortUpDown_KeyPress);
            this.PortUpDown.Enter += new System.EventHandler(this.PortUpDown_Enter);
            // 
            // AddButton
            // 
            this.AddButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.AddButton.Enabled = false;
            this.AddButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.AddButton.Location = new System.Drawing.Point(88, 112);
            this.AddButton.Name = "AddButton";
            this.AddButton.Size = new System.Drawing.Size(75, 32);
            this.AddButton.TabIndex = 5;
            this.AddButton.Text = "ǉ(&A)";
            this.AddButton.Click += new System.EventHandler(this.AddButton_Click);
            // 
            // DeleteButton
            // 
            this.DeleteButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.DeleteButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.DeleteButton.Location = new System.Drawing.Point(184, 112);
            this.DeleteButton.Name = "DeleteButton";
            this.DeleteButton.Size = new System.Drawing.Size(75, 32);
            this.DeleteButton.TabIndex = 6;
            this.DeleteButton.Text = "폜(&D)";
            this.DeleteButton.Click += new System.EventHandler(this.DeleteButton_Click);
            // 
            // IPAddressList
            // 
            this.IPAddressList.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.IPAddressList.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                            this.IPAddressColumn,
                                                                                            this.PortColumn});
            this.IPAddressList.FullRowSelect = true;
            this.IPAddressList.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
            this.IPAddressList.HideSelection = false;
            this.IPAddressList.Location = new System.Drawing.Point(16, 152);
            this.IPAddressList.Name = "IPAddressList";
            this.IPAddressList.Size = new System.Drawing.Size(312, 97);
            this.IPAddressList.TabIndex = 7;
            this.IPAddressList.View = System.Windows.Forms.View.Details;
            this.IPAddressList.SelectedIndexChanged += new System.EventHandler(this.IPAddressList_SelectedIndexChanged);
            // 
            // IPAddressColumn
            // 
            this.IPAddressColumn.Text = "IPAhX";
            this.IPAddressColumn.Width = 200;
            // 
            // PortColumn
            // 
            this.PortColumn.Text = "|[gԍ";
            this.PortColumn.Width = 80;
            // 
            // SourceAddressRelayFilterInputControl
            // 
            this.Name = "SourceAddressRelayFilterInputControl";
            this.Load += new System.EventHandler(this.SourceAddressRelayFilterInputControl_Load);
            this.InputGroup.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.PortUpDown)).EndInit();

        }
        #endregion

        public override string ToString(string innerString)
        {
            const string AssemblyID = "srcaddress-filter";
            const string AssemblyType = "Syslog.Relay.Filter.SourceAddressFilter";
            const string AssemblyName = "mlog_relay";
            const string AddressEntry = "allow";
            const string IPAddressEntry = "address";
            const string PortEntry = "port";

            XmlDocument doc = new XmlDocument();
            XmlDocumentFragment frag = doc.CreateDocumentFragment();

            foreach (ListViewItem item in IPAddressList.Items)
            {
                XmlAttribute IPAddressAttribute = doc.CreateAttribute(IPAddressEntry);
                IPAddressAttribute.Value = item.SubItems[0].Text;

                XmlAttribute PortAttribute = doc.CreateAttribute(PortEntry);
                PortAttribute.Value = item.SubItems[1].Text;

                XmlElement AddressElement = doc.CreateElement(AddressEntry);
                AddressElement.Attributes.Append(IPAddressAttribute);
                AddressElement.Attributes.Append(PortAttribute);

                frag.AppendChild(AddressElement);
            }

            AssemblyElementCreator AssemblyCreator = new AssemblyElementCreator(AssemblyID, AssemblyType, AssemblyName);
            XmlNode AssemblyNode = doc.ImportNode(AssemblyCreator.ToNode((XmlNode) frag), true);

            doc.AppendChild(AssemblyNode);

            return doc.OuterXml;
        }

        private void SourceAddressRelayFilterInputControl_Load(object sender, System.EventArgs e)
        {
            IPAddressTextBox.Clear();
            IPAddressList.SelectedItems.Clear();
        }

        private void IPAddressTextBox_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
        {
            this.PressEnterKey(e);
        }

        private void IPAddressTextBox_TextChanged(object sender, System.EventArgs e)
        {
            if (IPAddressTextBox.TextLength > 0)
            {
                AddButton.Enabled = true;
            }
            else
            {
                AddButton.Enabled = false;
            }
        }

        private void PortUpDown_Enter(object sender, System.EventArgs e)
        {
            PortUpDown.Select(0, PortUpDown.Value.ToString().Length);
        }

        private void PortUpDown_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
        {
            this.PressEnterKey(e);
        }

        private void AddButton_Click(object sender, System.EventArgs e)
        {
            this.AddIPAddress(IPAddressTextBox.Text, (int) PortUpDown.Value);

            IPAddressTextBox.Clear();
            IPAddressTextBox.Focus();
        }

        private void DeleteButton_Click(object sender, System.EventArgs e)
        {
            foreach (ListViewItem item in IPAddressList.SelectedItems)
            {
                item.Remove();
            }

            if (IPAddressList.FocusedItem != null)
            {
                IPAddressList.FocusedItem.Selected = true;
                IPAddressList.FocusedItem.EnsureVisible();
            }
        }

        private void IPAddressList_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            const int PortColumnIndex = 1;

            if (IPAddressList.SelectedItems.Count > 0)
            {
                DeleteButton.Enabled = true;
                
                IPAddressTextBox.Text = IPAddressList.SelectedItems[0].Text;
                PortUpDown.Value = Decimal.Parse(IPAddressList.SelectedItems[0].SubItems[PortColumnIndex].Text);
            }
            else
            {
                DeleteButton.Enabled = false;
            }
        }

        private ListViewItem AddIPAddress(string address, int port)
        {
            return this.AddIPAddress(IPAddress.Parse(address), port);
        }

        private ListViewItem AddIPAddress(IPAddress address, int port)
        {
            ListViewItem AddressEntry = new ListViewItem(address.ToString());
            AddressEntry.SubItems.Add(port.ToString());

            IPAddressList.SelectedItems.Clear();

            foreach (ListViewItem item in IPAddressList.Items)
            {
                if (item.Text == AddressEntry.Text)
                {
                    foreach (ListViewItem.ListViewSubItem sub in item.SubItems)
                    {
                        if (sub.Text == port.ToString())
                        {
                            item.Selected = true;
                            item.Focused = true;
                            item.EnsureVisible();

                            return item;
                        }
                    }
                }
            }

            ListViewItem InsertedItem = IPAddressList.Items.Add(AddressEntry);
            InsertedItem.Focused = true;
            InsertedItem.EnsureVisible();

            return InsertedItem;
        }

        private void PressEnterKey(KeyPressEventArgs e)
        {
            if ((int) e.KeyChar == (int) Keys.Enter)
            {
                this.AddButton.PerformClick();

                e.Handled = true;
            }
        }
	}
}
