using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syslog.Console.Controls;

namespace Syslog.Console
{
	/// <summary>
	/// SyslogConsole ̊Tv̐łB
	/// </summary>
	public class SyslogConsole : System.Windows.Forms.Form
	{
        /// TODO: `bg@\, http://www24.big.or.jp/~wfp/hiki/hiki.cgi?syslog_aa
        
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;
        private System.Windows.Forms.MenuItem ConsoleMenuFile;
        private System.Windows.Forms.StatusBar ConsoleStatus;
        private System.Windows.Forms.Panel ConsoleModePanel;
        private System.Windows.Forms.TabControl ConsoleModeTab;
        private System.Windows.Forms.TabPage ServiceViewPage;
        private System.Windows.Forms.TabPage TraceViewPage;
        private System.Windows.Forms.TabPage ConfigViewPage;
        private System.Windows.Forms.TabPage ConfigCreatePage;
        private Syslog.Console.Controls.ConfigCreateControl ConfigCreator;
        private System.Windows.Forms.Label ComingSoonLabel;
        private System.Windows.Forms.MainMenu ConsoleMenu;
        private System.Windows.Forms.MenuItem FileMenuItem;
        private System.Windows.Forms.MenuItem FileExitMenuItem;
        private System.Windows.Forms.MenuItem HelpMenuItem;
        private System.Windows.Forms.MenuItem AboutHelpMenuItem;
        private System.Windows.Forms.MenuItem WindowMenuItem;
        private ServiceConsoleControl ServiceConsole;

		public SyslogConsole()
		{
			InitializeComponent();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}

			base.Dispose( disposing );
		}

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            this.ConsoleMenuFile = new System.Windows.Forms.MenuItem();
            this.ConsoleStatus = new System.Windows.Forms.StatusBar();
            this.ConsoleModePanel = new System.Windows.Forms.Panel();
            this.ConsoleModeTab = new System.Windows.Forms.TabControl();
            this.ServiceViewPage = new System.Windows.Forms.TabPage();
            this.ServiceConsole = new Syslog.Console.Controls.ServiceConsoleControl();
            this.ConfigCreatePage = new System.Windows.Forms.TabPage();
            this.ConfigCreator = new Syslog.Console.Controls.ConfigCreateControl();
            this.ConfigViewPage = new System.Windows.Forms.TabPage();
            this.TraceViewPage = new System.Windows.Forms.TabPage();
            this.ComingSoonLabel = new System.Windows.Forms.Label();
            this.ConsoleMenu = new System.Windows.Forms.MainMenu();
            this.FileMenuItem = new System.Windows.Forms.MenuItem();
            this.FileExitMenuItem = new System.Windows.Forms.MenuItem();
            this.HelpMenuItem = new System.Windows.Forms.MenuItem();
            this.AboutHelpMenuItem = new System.Windows.Forms.MenuItem();
            this.WindowMenuItem = new System.Windows.Forms.MenuItem();
            this.ConsoleModePanel.SuspendLayout();
            this.ConsoleModeTab.SuspendLayout();
            this.ServiceViewPage.SuspendLayout();
            this.ConfigCreatePage.SuspendLayout();
            this.TraceViewPage.SuspendLayout();
            this.SuspendLayout();
            // 
            // ConsoleMenuFile
            // 
            this.ConsoleMenuFile.Index = -1;
            this.ConsoleMenuFile.Text = "t@C(&F)";
            // 
            // ConsoleStatus
            // 
            this.ConsoleStatus.Location = new System.Drawing.Point(0, 424);
            this.ConsoleStatus.Name = "ConsoleStatus";
            this.ConsoleStatus.ShowPanels = true;
            this.ConsoleStatus.Size = new System.Drawing.Size(632, 22);
            this.ConsoleStatus.TabIndex = 1;
            // 
            // ConsoleModePanel
            // 
            this.ConsoleModePanel.Controls.Add(this.ConsoleModeTab);
            this.ConsoleModePanel.Dock = System.Windows.Forms.DockStyle.Fill;
            this.ConsoleModePanel.DockPadding.Bottom = 2;
            this.ConsoleModePanel.DockPadding.Left = 4;
            this.ConsoleModePanel.DockPadding.Right = 4;
            this.ConsoleModePanel.DockPadding.Top = 8;
            this.ConsoleModePanel.Location = new System.Drawing.Point(0, 0);
            this.ConsoleModePanel.Name = "ConsoleModePanel";
            this.ConsoleModePanel.Size = new System.Drawing.Size(632, 424);
            this.ConsoleModePanel.TabIndex = 0;
            // 
            // ConsoleModeTab
            // 
            this.ConsoleModeTab.Appearance = System.Windows.Forms.TabAppearance.FlatButtons;
            this.ConsoleModeTab.Controls.Add(this.ServiceViewPage);
            this.ConsoleModeTab.Controls.Add(this.ConfigCreatePage);
            this.ConsoleModeTab.Controls.Add(this.ConfigViewPage);
            this.ConsoleModeTab.Controls.Add(this.TraceViewPage);
            this.ConsoleModeTab.Dock = System.Windows.Forms.DockStyle.Fill;
            this.ConsoleModeTab.Location = new System.Drawing.Point(4, 8);
            this.ConsoleModeTab.Name = "ConsoleModeTab";
            this.ConsoleModeTab.SelectedIndex = 0;
            this.ConsoleModeTab.Size = new System.Drawing.Size(624, 414);
            this.ConsoleModeTab.SizeMode = System.Windows.Forms.TabSizeMode.Fixed;
            this.ConsoleModeTab.TabIndex = 1;
            this.ConsoleModeTab.SelectedIndexChanged += new System.EventHandler(this.ConsoleModeTab_SelectedIndexChanged);
            // 
            // ServiceViewPage
            // 
            this.ServiceViewPage.Controls.Add(this.ServiceConsole);
            this.ServiceViewPage.Location = new System.Drawing.Point(4, 26);
            this.ServiceViewPage.Name = "ServiceViewPage";
            this.ServiceViewPage.Size = new System.Drawing.Size(616, 384);
            this.ServiceViewPage.TabIndex = 0;
            this.ServiceViewPage.Text = "T[rX";
            // 
            // ServiceConsole
            // 
            this.ServiceConsole.Dock = System.Windows.Forms.DockStyle.Fill;
            this.ServiceConsole.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.ServiceConsole.Location = new System.Drawing.Point(0, 0);
            this.ServiceConsole.Name = "ServiceConsole";
            this.ServiceConsole.Size = new System.Drawing.Size(616, 384);
            this.ServiceConsole.TabIndex = 0;
            // 
            // ConfigCreatePage
            // 
            this.ConfigCreatePage.Controls.Add(this.ConfigCreator);
            this.ConfigCreatePage.Location = new System.Drawing.Point(4, 24);
            this.ConfigCreatePage.Name = "ConfigCreatePage";
            this.ConfigCreatePage.Size = new System.Drawing.Size(616, 386);
            this.ConfigCreatePage.TabIndex = 4;
            this.ConfigCreatePage.Text = "\";
            // 
            // ConfigCreator
            // 
            this.ConfigCreator.Dock = System.Windows.Forms.DockStyle.Fill;
            this.ConfigCreator.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.ConfigCreator.Location = new System.Drawing.Point(0, 0);
            this.ConfigCreator.Name = "ConfigCreator";
            this.ConfigCreator.Size = new System.Drawing.Size(616, 386);
            this.ConfigCreator.TabIndex = 0;
            // 
            // ConfigViewPage
            // 
            this.ConfigViewPage.Location = new System.Drawing.Point(4, 24);
            this.ConfigViewPage.Name = "ConfigViewPage";
            this.ConfigViewPage.Size = new System.Drawing.Size(616, 386);
            this.ConfigViewPage.TabIndex = 3;
            this.ConfigViewPage.Text = "ڍאݒ";
            // 
            // TraceViewPage
            // 
            this.TraceViewPage.Controls.Add(this.ComingSoonLabel);
            this.TraceViewPage.Location = new System.Drawing.Point(4, 24);
            this.TraceViewPage.Name = "TraceViewPage";
            this.TraceViewPage.Size = new System.Drawing.Size(616, 386);
            this.TraceViewPage.TabIndex = 2;
            this.TraceViewPage.Text = "Syslog j^";
            this.TraceViewPage.Visible = false;
            // 
            // ComingSoonLabel
            // 
            this.ComingSoonLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.ComingSoonLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.ComingSoonLabel.Location = new System.Drawing.Point(40, 32);
            this.ComingSoonLabel.Name = "ComingSoonLabel";
            this.ComingSoonLabel.Size = new System.Drawing.Size(376, 25);
            this.ComingSoonLabel.TabIndex = 0;
            this.ComingSoonLabel.Text = "Coming Soon...";
            // 
            // ConsoleMenu
            // 
            this.ConsoleMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                        this.FileMenuItem,
                                                                                        this.WindowMenuItem,
                                                                                        this.HelpMenuItem});
            // 
            // FileMenuItem
            // 
            this.FileMenuItem.Index = 0;
            this.FileMenuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                         this.FileExitMenuItem});
            this.FileMenuItem.Text = "t@C(&F)";
            // 
            // FileExitMenuItem
            // 
            this.FileExitMenuItem.Index = 0;
            this.FileExitMenuItem.Shortcut = System.Windows.Forms.Shortcut.AltF4;
            this.FileExitMenuItem.Text = "I(&X)";
            this.FileExitMenuItem.Click += new System.EventHandler(this.FileExitMenuItem_Click);
            // 
            // HelpMenuItem
            // 
            this.HelpMenuItem.Index = 2;
            this.HelpMenuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                         this.AboutHelpMenuItem});
            this.HelpMenuItem.Text = "wv(&H)";
            // 
            // AboutHelpMenuItem
            // 
            this.AboutHelpMenuItem.Enabled = false;
            this.AboutHelpMenuItem.Index = 0;
            this.AboutHelpMenuItem.Text = "o[W(&A)";
            this.AboutHelpMenuItem.Click += new System.EventHandler(this.AboutHelpMenuItem_Click);
            // 
            // WindowMenuItem
            // 
            this.WindowMenuItem.Index = 1;
            this.WindowMenuItem.Text = "EBhE(&W)";
            // 
            // SyslogConsole
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
            this.ClientSize = new System.Drawing.Size(632, 446);
            this.Controls.Add(this.ConsoleModePanel);
            this.Controls.Add(this.ConsoleStatus);
            this.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.Menu = this.ConsoleMenu;
            this.Name = "SyslogConsole";
            this.Text = "Managed Syslog Console";
            this.Load += new System.EventHandler(this.SyslogConsole_Load);
            this.ConsoleModePanel.ResumeLayout(false);
            this.ConsoleModeTab.ResumeLayout(false);
            this.ServiceViewPage.ResumeLayout(false);
            this.ConfigCreatePage.ResumeLayout(false);
            this.TraceViewPage.ResumeLayout(false);
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// AvP[ṼC Gg |CgłB
		/// </summary>
		[STAThread]
		static void Main() 
		{
            Application.EnableVisualStyles();

			Application.Run(new SyslogConsole());
		}

        private void SyslogConsole_Load(object sender, System.EventArgs e)
        {
            this.WindowMenuItemInitializer();

            this.SelectNextControl(this.ActiveControl, true, true, true, true);
            this.SelectNextControl(this.ActiveControl, true, true, true, true);
        }

        private void ConsoleModeTab_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            if (ConsoleModeTab.SelectedTab.Equals(ConfigViewPage))
            {
                if (ConsoleModeTab.SelectedTab.Controls.Count == 0)
                {
                    Cursor.Current = Cursors.WaitCursor;

                    ConfigConsoleControl ConfigConsole = new ConfigConsoleControl();
                    ConfigConsole.Dock = DockStyle.Fill;

                    ConsoleModeTab.SelectedTab.Controls.Add(ConfigConsole);

                    Cursor.Current = Cursors.Default;
                }
            }
        }

        private void FileExitMenuItem_Click(object sender, System.EventArgs e)
        {
            this.Close();
        }

        private void AboutHelpMenuItem_Click(object sender, System.EventArgs e)
        {
            return;
        }

        private void WindowSubMenuItem_Click(object sender, System.EventArgs e)
        {
            foreach (TabPage tab in ConsoleModeTab.TabPages)
            {
                if (tab.Text == ((MenuItem) sender).Text)
                {
                    ConsoleModeTab.SelectedTab = tab;

                    break;
                }
            }
        }

        private void WindowMenuItemInitializer()
        {
            foreach (TabPage tab in ConsoleModeTab.TabPages)
            {
                WindowMenuItem.MenuItems.Add(tab.Text, new EventHandler(this.WindowSubMenuItem_Click));
            }
        }
	}
}
