using System;

namespace Syslog.Listener
{
    /// <summary>
    /// MSyslogpPbg̓e𑀍삷郊XitB^C^[tFCXB
    /// </summary>
    /// <remarks>
    /// <example>
    /// <code>
    /// public class CustomFilter : ISyslogListenerFilter
    /// {
    ///     public CustomFilter()
    ///     {
    ///     }
    ///     
    ///     public bool Init(ListenerFilterEvent FilterEvent)
    ///     {
    ///         FilterEvent.Receiving += (new ReceivedEventHandler(this.FilterEvent_Receiving));
    ///     }
    ///     
    ///     public string
    ///     {
    ///         get
    ///         {
    ///             return "Custom Listener Filter Plugin Module";
    ///         }
    ///     }
    ///     
    ///     private bool FilterEvent_Receiving(object sender, ReceivedEventArgs e)
    ///     {
    ///         // pPbg̓eg[TɑM
    ///         System.Diagnostics.Trace.WriteLine(e.Packet.GetPacketString());
    ///         
    ///         // pPbg̏p
    ///         return true;
    ///     }
    ///     
    ///     private void Dispose()
    ///     {
    ///         return;
    ///     }
    /// }
    /// </code>
    /// </example>
    /// </remarks>
    public interface ISyslogListenerFilter : IDisposable
    {
        /// <summary>
        /// CxgfQ[gZbgAbvtB^܂B
        /// </summary>
        /// <param name="FilterEvent">tB^̎sCxg ListenerFilterEventB</param>
        /// <param name="config">app.config JX^RtBO[Vm[hB</param>
        void Init(ListenerFilterEvent FilterEvent, string config);

        /// <summary>
        /// ISyslogListenerFilter ̃thB
        /// </summary>
        string Name
        {
            get;
        }
    }
}