using System;

namespace Syslog.Listener
{
    /// <summary>
    /// MpPbg f[^񋟂܂
    /// </summary>
    /// <remarks>
    /// MpPbgƊ֘Af[^܂ށA<see cref="Syslog.SyslogPacket" /> 擾܂B
    /// </remarks>
    public class ReceivedEventArgs : System.EventArgs
    {
        /// <summary>
        /// vCx[g tB[hB<see cref="Syslog.Listener.ReceivedEventArgs.Packet"/> i[܂B
        /// </summary>
        private SyslogPacket syslogPacket = null;

        /// <summary>
        /// vCx[g tB[hB<see cref="Syslog.Listener.ReceivedEventArgs.Listener"/> i[܂B
        /// </summary>
        private ISyslogListener senderListener = null;

        /// <summary>
        /// ftHgRXgN^B
        /// </summary>
        public ReceivedEventArgs()
        {
        }

        /// <summary>
        /// <paramref name="packet"/>  <see cref="Syslog.SyslogPacket"/> w肵āA
        /// <see cref="Syslog.Listener.ReceivedEventArgs"/> NX̐VCX^X܂B
        /// </summary>
        /// <param name="sender"><paramref name="packet"/> MXi CX^XB</param>
        /// <param name="packet">MpPbgƊ֘Af[^킷 <see cref="Syslog.SyslogPacket"/> CX^XB</param>
        /// <exception cref="ArgumentNullException"><paramref name="Listener"/>  null QƂłB</exception>
        /// <exception cref="ArgumentNullException"><paramref name="packet"/>  null Q łB</exception>
        public ReceivedEventArgs(ISyslogListener sender, SyslogPacket packet)
        {
            // sender nĂꍇ
            if (sender != null)
            {
                // sender i[
                senderListener = sender;
            }
            // sender  null QƂ̏ꍇ
            else
            {
                // Null Exception X[
                throw new ArgumentNullException("sender");
            }

            // SyslogpPbgnĂꍇ
            if (packet != null)
            {
                // SyslogpPbgi[
                syslogPacket = packet;
            }
            // packet  null QƂ̏ꍇ
            else
            {
                // Null Exception X[
                throw new ArgumentNullException("packet");
            }
        }

        /// <summary>
        /// pPbgMXi CX^X擾܂B
        /// </summary>
        /// <value>
        /// <see cref="Syslog.Listener.ISyslogListener"/> C^[tFCX郊Xi CX^X擾܂B
        /// </value>
        public ISyslogListener Listener
        {
            get
            {
                return senderListener;
            }
        }

        /// <summary>
        /// MpPbgƊ֘Af[^܂ <see cref="Syslog.SyslogPacket"/> 擾܂B
        /// </summary>
        /// <remarks>
        /// tB^瑀\ <see cref="Syslog.SyslogPacket"/> 擾܂B
        /// </remarks>
        /// <value>
        /// <see cref="Syslog.SyslogPacket"/> 擾܂B
        /// </value>
        /// <exception cref="System.ArgumentNullException"><paramref name="Packet"/>  null QƂłB</exception>
        public SyslogPacket Packet
        {
            get
            {
                return syslogPacket;
            }
            set
            {
                syslogPacket = value;
            }
        }
    }
}
