using System;
using System.Diagnostics;

namespace Syslog.Listener.Filter
{
	/// <summary>
	/// AvP[Vg[T Syslog pPbg𑗐MtB^łB
	/// </summary>
	public class ListenerTracer : ISyslogListenerFilter
	{
        /// <summary>
        /// ftHgRXgN^B
        /// </summary>
		public ListenerTracer()
		{
        }

        #region ISyslogListenerFilter o
        /// <summary>
        /// tB^ăCxgfQ[gɐڑ܂B
        /// </summary>
        /// <param name="FilterEvent">tB^OsCxgfQ[gi[ <see cref="ListenerFilterEvent"/>B</param>
        /// <param name="config">app.config JX^RtBO[Vm[hB</param>
        public void Init(ListenerFilterEvent FilterEvent, string config)
        {
            // pPbg`FbNOɃtB^s
            FilterEvent.Receiving += new ReceivedEventHandler(FilterEvent_Receiving);
            // pPbg`FbNɃtB^s
            FilterEvent.Received += new ReceivedEventHandler(FilterEvent_Received);
        }

        /// <summary>
        /// ListenerTracert ̃thłB
        /// </summary>
        public string Name
        {
            get
            {
                return "Syslog Listener Filter Tracer";
            }
        }
        #endregion

        #region IDisposable o
        /// <summary>
        /// \[X܂B
        /// </summary>
        public void Dispose()
        {
        }
        #endregion

        /// <summary>
        /// SyslogpPbg̃tH[}bg`FbNOɃpPbg܂B
        /// </summary>
        /// <param name="sender">SyslogpPbgM <see cref="ISyslogListener"/>B</param>
        /// <param name="e">SyslogpPbgf[^i[ <see cref="ReceivedEventArgs"/>B</param>
        /// <returns>㑱̏𑱍s邩肵܂Bfalse Ԃꍇ͏𒆎~܂B</returns>
        private bool FilterEvent_Receiving(object sender, ReceivedEventArgs e)
        {
            // g[XbZ[W𑗐M܂
            Trace.Indent();
            Trace.WriteLine("Listener Filter Receiving Event.", "Syslog.Listener.ListenerTracer");
            Trace.Unindent();

            // 㑱̏𑱍s܂
            return true;
        }

        /// <summary>
        /// SyslogpPbg̃tH[}bg`FbNɃpPbg܂B
        /// </summary>
        /// <param name="sender">SyslogpPbgM IListenerB</param>
        /// <param name="e">SyslogpPbgf[^i[ ReceivedEventArgsB</param>
        /// <returns>㑱̏𑱍s邩肵܂Bfalse Ԃꍇ͏𒆎~܂B</returns>
        private bool FilterEvent_Received(object sender, ReceivedEventArgs e)
        {
            // g[XbZ[W𑗐M܂
            Trace.Indent();
            Trace.WriteLine("Listener Filter Received Event.", "Syslog.Listener.ListenerTracer");
            Trace.Unindent();

            // 㑱̏𑱍s܂
            return true;
        }
    }
}
