using System;

namespace Syslog.Relay
{
    /// <summary>
    /// [eBOtB^C^[tFCXB
    /// </summary>
    public interface ISyslogRelayFilter : IDisposable
    {
        /// <summary>
        /// tB^ăCxgZbgAbv܂B
        /// </summary>
        /// <param name="FilterEvent">tB^OCxgfQ[gZbgAbv邽߂ RelayFilterEventB</param>
        /// <param name="config">app.config JX^RtBO[Vm[hB</param>
        void Init(RelayFilterEvent FilterEvent, string config);

        /// <summary>
        /// [eBOtB^̃th
        /// </summary>
        string Name
        {
            get;
        }
    }
}