using System;

namespace Syslog.Relay
{
	/// <summary>
	/// [eBOɃtB^OKpCxg̃Cxgf[^łB
	/// </summary>
	public class RoutingEventArgs : System.EventArgs
	{
        private string relayPluginId = String.Empty;
        private ISyslogRelayPlugin relayPlugin = null;
        private SyslogInfo syslogInfo = null;

        /// <summary>
        /// ftHgRXgN^B
        /// </summary>
        public RoutingEventArgs()
        {
        }

        /// <summary>
        /// RXgN^B[eBOIDA[eBOW[ASyslogpPbgɃCX^X쐬܂B
        /// </summary>
        /// <param name="id">[eBOW[IDB</param>
        /// <param name="plugin">pPbg[eBOĂ郂W[̃CX^XB</param>
        /// <param name="syslog">tB^Kp SyslogInfoB</param>
        /// <exception cref="ArgumentNullException"><c>id</c>, <c>plugin</c>, <c>syslog</c> ꂩ null QƂłB</exception>
		public RoutingEventArgs(string id, ISyslogRelayPlugin plugin, SyslogInfo syslog)
		{
            if (id != null)
            {
                // [eBOvOCID擾
                relayPluginId = id;
            }
            else
            {
                throw new ArgumentNullException("id");
            }

            if (plugin != null)
            {
                // [eBOW[̃CX^X擾
                relayPlugin = plugin;
            }
            else
            {
                throw new ArgumentNullException("plugin");
            }

            if (syslog != null)
            {
                // SyslogInfo 擾
                syslogInfo = syslog;
            }
            else
            {
                throw new ArgumentNullException("syslog");
            }
		}

        /// <summary>
        /// tB^Kp SyslogInfo Ă郋[eBOW[ID
        /// </summary>
        public string PluginID
        {
            get
            {
                return relayPluginId;
            }
            set
            {
                relayPluginId = value;
            }
        }

        /// <summary>
        /// tB^Kp SyslogInfo Ă郋[eBOW[̃CX^XB
        /// </summary>
        public ISyslogRelayPlugin Plugin
        {
            get
            {
                return relayPlugin;
            }
            set
            {
                relayPlugin = value;
            }
        }

        /// <summary>
        /// tB^Kp SyslogInfoB
        /// </summary>
        public SyslogInfo Syslog
        {
            get
            {
                return syslogInfo;
            }
            set
            {
                syslogInfo = value;
            }
        }
	}
}
